<?php 
	include("../includes/config.php");
	require("../includes/Admin.class.php");
	$admin=new Admin($db,$config);
	if(!$admin->check()){
		Main::redirect("",array("error",e("You are not authorized to access this location.")));
		exit;
	}
	$admin->dispatch();		
?>
<!DOCTYPE html>
<!--[if lt IE 7]>html class="no-js lt-ie9 lt-ie8 lt-ie7"> <![endif]-->
<!--[if IE 7]><html class="no-js lt-ie9 lt-ie8"> <![endif]-->
<!--[if IE 8]><html class="no-js lt-ie9"> <![endif]-->
<!--[if gt IE 8]><html class="no-js"> <![endif]-->
<html lang="en">
<head>
	<title><?php echo $config["title"] ?> Admin Panel</title>

	<!--Meta Tags -->
	<meta http-equiv="content-type" content="text/html; charset=UTF-8" />  
	<!-- Styles -->
	<link rel="stylesheet" type="text/css" href="<?php echo $config["url"]?>/admin/static/style.css">
	<link href="<?php echo $config["url"]?>/static/flat/green.css" rel="stylesheet">
	<!-- Scripts -->
	<script type="text/javascript" src="<?php echo $config["url"]?>/static/jquery.js"></script>		
	<script type="text/javascript" src="<?php echo $config["url"]?>/static/excanvas.js"></script>
	<script type="text/javascript" src="<?php echo $config["url"]?>/static/flot.js"></script>	
	<script type="text/javascript" src="<?php echo $config["url"]?>/static/icheck.js"></script>	
	<script type="text/javascript" src="<?php echo $config["url"]?>/admin/static/ckeditor/ckeditor.js"></script>	
	<script type="text/javascript" src="<?php echo $config["url"]?>/static/jquery-ui.js"></script>	
	<!--[if lt IE 9]>
		<script type="text/javascript" src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>	
	<![endif]-->	
</head>
<body>	
	<a href="#main" id="back-to-top">Back to top</a>
	<header>
		<div class="row container">
			<div class="grid third">
				<h1>Admin Panel</h1>
			</div><!-- /.grid third -->
			<div class="grid twothird">
				<form action="<?php echo $config["url"]?>/admin/search" method="get" class="search">
					<input type="text" value="" name="q" placeholder="<?php echo ($admin->action("user"))?'Enter an email or a keyword to search for a user':'Enter the url, alias, or a keyword to search for a url.' ?>">
					<?php echo ($admin->action("user"))?'<input type="hidden" name="do" value="user"/>':'' ?>
					<button type="submit" class="button">Search</button>
				</form><!-- /.search -->
			</div><!-- /.grid twothird -->			
		</div><!-- /.row -->
	</header>
	<section>
		<div class="container" id="main">
			<div class="nav">
				<ul class="primary">
					<li><a href="<?php echo $config["url"]?>/admin/">Dashboard</a></li>
					<li><a href="<?php echo $config["url"]?>/admin/url">Manage URLs</a></li>
					<li><a href="<?php echo $config["url"]?>/admin/user">Manage Users</a></li>
					<li><a href="<?php echo $config["url"]?>/admin/page">Manage Pages</a></li>				
					<li class="noborder"><a href="<?php echo $config["url"]?>/admin/setting">Settings</a></li>
					<li class="right alt"><a href="<?php echo $config["url"]?>" target="_blank">View Site</a></li>
				</ul><!-- /.main -->
				<ul class="secondary">
					<li class="right"><a href="<?php echo $config["url"];?>/user/logout">Logout</a></li>
					<li class="right"><a href="#" class="edituser" data-action="edituser" data-id="<?php echo $admin->info('id')?>">Edit Profile</a></li>					
					<li class="right"><a href="<?php echo $config["url"];?>/user">User Account</a></li>
				</ul><!-- /.secondary -->			
			</div><!-- /.nav -->	
			<?php echo Main::message(); ?>		
			<?php echo $admin->update_notification();?>		
			<?php echo $admin->content(); ?>	
		</div><!-- /.container -->
	</section>
	<br class="clear">
	<footer>
		<div class="container">
			<span class="left">2013-<?php echo date('Y') ?> &copy; <a href="http://gempixel.com">KBRmedia</a> - All Rights Reserved</span>
			<div class="right">
				<a href="<?php echo $config["url"]?>/admin/help">Documentation</a> - Version <?php echo _VERSION; ?> <a href="http://gempixel.com/update.php?token=<?php echo md5('shortener'); ?>&amp;current=<?php echo _VERSION; ?>" target="_blank">(Check for update)</a>				
			</div><!-- /.right -->	
		</div><!-- /.container -->
	</footer>	
	<!--<?php echo $db->num_queries ?> queries fetched in <?php echo round((microtime(TRUE) - _EXECUTION), 4)?> seconds-->
	<script type="text/javascript">
   var appurl="<?php echo $config["url"]?>/admin";
	</script>
	<script type="text/javascript" src="<?php echo $config["url"]?>/static/application.fn.js"></script>
	<script type="text/javascript" src="<?php echo $config["url"]?>/admin/static/dashboard.js"></script>
</body>
</html>