/**
 *  Premium URL Shortener jQuery Custom
 *  Copyright @KBRmedia - All rights Reserved 
 */
$(document).ready(function () {
	/**
	 * Chart Option
	 */
	if($("#chart").length){
		var options = {
		  series: {
		    lines: { show: true, lineWidth: 3,fill: true },
		    points: { show: true, lineWidth: 2 }, 
		    shadowSize: 0
		  },
		  grid: { hoverable: true, clickable: true, borderWidth: 0, color: "#fff"},
		  colors: ["#1ABC9C","#3498DB","#E74C3C","#9B59B6"],
		  xaxis: {ticks: xlabel, tickDecimals: 0, tickLength: 0},
		  yaxis: {ticks:3, tickDecimals: 0, tickLength: 0},
		};	
		$.plot("#chart", data ,options);	
		function showTooltip(x, y, c) {
      $('<div id="tooltip" class="chart-tip">' + c + '</div>').css( {
          position: 'absolute',
          display: 'none',
          top: y - 25,
          left: x + 5,
          color: '#fff',
          opacity: 0.80
      }).appendTo("body").fadeIn(200);
    }

    var previousPoint = null;
    $("#chart").bind("plothover", function (event, pos, item) {
        if (item) {
          if (previousPoint != item.dataIndex) {
              previousPoint = item.dataIndex;
              $("#tooltip").remove();
              showTooltip(item.pageX, item.pageY, item.datapoint[1]+" "+item.series["label"]);
          }
        }
    }); 		
	}
  /**
   * Flat Check Box 
   */
  $('input').iCheck({
    checkboxClass: 'icheckbox_flat-green',
    radioClass: 'iradio_flat-green'
  });
   // New
  $('#selectall').click(function(e) {
    e.preventDefault();   
    $('input').iCheck('toggle');            
  }); 
  /**
   * Sticky Filters
   */
  $('.filter').sticky({TopMargin: 5});
  /**
   * Delete All
   */
  $('#deleteall').click(function(e){
    e.preventDefault();
    $('form#delete-all-urls').submit();
  });
  /**
   * Settings Tabs
   */
    $(".tab_container").hide();
    $(".tab_container:first").show(); 


    $("#tab-menu > li > a").click(function(e) {
        e.preventDefault();
        $("#tab-menu > li > a").removeClass("current"); 
        $(this).addClass("current"); 
        $(".tab_container").hide(); 
        var activeTab = $(this).attr("href");
        $(activeTab).fadeIn("slow");  
    });  
    var sidebar_h=$(".sidebar").height();
    if($(".content").height()>sidebar_h){
      $(".sidebar").height($(".content").height());
    }    
  /**
   * Custom Radio Box
   */
    $(document).on('click','.form_opt li a',function(e) {
      e.preventDefault();
      var name = $(this).parent("li").parent("ul").attr("data-id");
      var to = $(this).attr("data-value");
      $("input#" + name).val(to);
      $(this).parent("li").parent("ul").find("a").removeClass("current");
      $(this).addClass("current");
    });   
  /**
   * Message Clear
   */  
    $("div.message").click(function(){
      $(this).fadeOut("slow");
    });
  /**
   * Add & Delete Location Field
   */
    $(".add_geo").click(function(){
      $('#geo').append("<div class='block'><h3>New Geotargeting Data <a href='#' class='button red right small delete_geo'>Delete</a></h3><label>Country</label> <input type='text' name='location[]' value='' class='input country' /><label>Target URL</label><input type='text' name='target[]' value='' class='input' /></div>");
      return false;
    }); 
    $(document).on('click',".delete_geo",function(){
        $(this).parent('h3').parent('.block').slideUp('slow',function(){
            $(this).remove();
        });
        return false;
    }); 
  /**
   * Label Fix
   */  
   $(document).on('click','label',function(){
      $(this).next('input[type=text],input[type=password],textarea').focus();
   });
  /**
   * Back to top
   */
    $(window).scroll(function(){   
        if(window.pageYOffset>300){
          $("#back-to-top").fadeIn('slow');
        }else{
          $("#back-to-top").fadeOut('slow');
        }
    });
    $("a#back-to-top, a.scroll").smoothscroll();
  /**
   * Activate Functions
   */
    $(".tooltip").tooltip();
    $("a.delete").click(function(e){
      e.preventDefault();
      $(this).modal();
      return false;
    });
  /**
   * Ajax Requests
   */
    $(document).on('click',".edituser,#adduser",function(e){ 
      e.preventDefault();
      $(this).modal({title:"User Management",content:"Please wait while loading...",confimation:1});
      var id = $(this).attr("data-id");
      var action = $(this).attr("data-action");
      $.ajax({
          type: "POST",
          url: appurl+"/admin_ajax.php",
          data: "action="+action+"&id="+id,           
          success: function (html) { 
            $("#modal-alert > p").hide();                                            
            $("#modal-alert > p").html(html);
            $("#modal-alert > p").fadeIn('fast');  
          }
      });        
    });
    $(document).on('submit',"#edittheuser,#addtheuser",function(e){ 
        e.preventDefault();
        $.ajax({
          type: "POST",
          url: appurl+"/admin_ajax.php",
          data: $(this).serialize(),           
          success: function (html) {                                             
            $("#modal-alert > p").hide();                                            
            $("#modal-alert > p").html(html);
            $("#modal-alert > p").fadeIn('slow');  
          }
        });        
    }); 
  /**
   * Autocomplete list of Countries
   */    
    $(document).on("keydown.autocomplete",".country",function(e){
      var countries = ["Afghanistan","Aland Islands","Albania","Algeria","American Samoa","Andorra","Angola","Anguilla","Antarctica","Antigua and Barbuda","Argentina","Armenia","Aruba","Asia/Pacific Region","Australia","Austria","Azerbaijan","Bahamas","Bahrain","Bangladesh","Barbados","Belarus","Belgium","Belize","Benin","Bermuda","Bhutan","Bolivia","Bosnia and Herzegovina","Botswana","Bouvet Island","Brazil","British Indian Ocean Territory","Brunei Darussalam","Bulgaria","Burkina Faso","Burundi","Cambodia","Cameroon","Canada","Cape Verde","Cayman Islands","Central African Republic","Chad","Chile","China","Christmas Island","Cocos (Keeling) Islands","Colombia","Comoros","Congo","Congo  The Democratic Republic of the","Cook Islands","Costa Rica","Cote d'Ivoire","Croatia","Cuba","Cyprus","Czech Republic","Denmark","Djibouti","Dominica","Dominican Republic","Ecuador","Egypt","El Salvador","Equatorial Guinea","Eritrea","Estonia","Ethiopia","Europe","Falkland Islands (Malvinas)","Faroe Islands","Fiji","Finland","France","French Guiana","French Polynesia","French Southern Territories","Gabon","Gambia","Georgia","Germany","Ghana","Gibraltar","Greece","Greenland","Grenada","Guadeloupe","Guam","Guatemala","Guernsey","Guinea","Guinea-Bissau","Guyana","Haiti","Heard Island and McDonald Islands","Holy See (Vatican City State)","Honduras","Hong Kong","Hungary","Iceland","India","Indonesia","Iran  Islamic Republic of","Iraq","Ireland","Isle of Man","Israel","Italy","Jamaica","Japan","Jersey","Jordan","Kazakhstan","Kenya","Kiribati","Korea  Democratic People's Republic of","Korea  Republic of","Kuwait","Kyrgyzstan","Lao People's Democratic Republic","Latvia","Lebanon","Lesotho","Liberia","Libyan Arab Jamahiriya","Liechtenstein","Lithuania","Luxembourg","Macao","Macedonia","Madagascar","Malawi","Malaysia","Maldives","Mali","Malta","Marshall Islands","Martinique","Mauritania","Mauritius","Mayotte","Mexico","Micronesia  Federated States of","Moldova  Republic of","Monaco","Mongolia","Montenegro","Montserrat","Morocco","Mozambique","Myanmar","Namibia","Nauru","Nepal","Netherlands","Netherlands Antilles","New Caledonia","New Zealand","Nicaragua","Niger","Nigeria","Niue","Norfolk Island","Northern Mariana Islands","Norway","Oman","Pakistan","Palau","Palestinian Territory","Panama","Papua New Guinea","Paraguay","Peru","Philippines","Pitcairn","Poland","Portugal","Puerto Rico","Qatar","Reserved","Reunion","Romania","Russian Federation","Rwanda","Saint Helena","Saint Kitts and Nevis","Saint Lucia","Saint Pierre and Miquelon","Saint Vincent and the Grenadines","Samoa","San Marino","Sao Tome and Principe","Saudi Arabia","Senegal","Serbia","Seychelles","Sierra Leone","Singapore","Slovakia","Slovenia","Solomon Islands","Somalia","South Africa","South Georgia and the South Sandwich Islands","Spain","Sri Lanka","Sudan","Suriname","Svalbard and Jan Mayen","Swaziland","Sweden","Switzerland","Syrian Arab Republic","Taiwan","Tajikistan","Tanzania  United Republic of","Thailand","Timor-Leste","Togo","Tokelau","Tonga","Trinidad and Tobago","Tunisia","Turkey","Turkmenistan","Turks and Caicos Islands","Tuvalu","Uganda","Ukraine","United Arab Emirates","United Kingdom","United States","United States Minor Outlying Islands","Uruguay","Uzbekistan","Vanuatu","Venezuela","Vietnam","Virgin Islands  British","Virgin Islands  U.S.","Wallis and Futuna","Western Sahara","Yemen","Zambia","Zimbabwe"];     
      $(this).autocomplete({
        source : countries
      });
    });   
  /**
   * Click Once and disable button
   */
    $(".clickonce").click(function(){
      $(this).addClass('disabled');
    });
});