<?php if(!defined("APP")) die() ?>
<div class="sidebar">
	<ul class="menu toggle" id="tab-menu">
		<li><a href="#general" class="current">General Info</a></li>
		<li><a href="#settings">Application Settings</a></li>		
		<li><a href="#editor">Using Editors</a></li>		
		<li><a href="#paypal">Monetization Features</a></li>		
	</ul>
</div><!-- /.sidebar -->
<div class="content">
	<div class="tab_container" id="general">
		<h2>General Information</h2>
		<p>Thank you for purchasing this script. Some parts of the documentation has been moved to here in order facilitate access. Furthermore, there are new help icons almost everywhere that you can use for quick help. If you have any questions, you can contact from <a href="http://gempixel.com/profile">here</a> and please provide as much info as possible.
		</p>
		<h4>Mail Configuration</h4>
		<p>Currently this application will attempt to send mail using the sendmail module. However if you want to use SMTP, open <code>includes/Main.class.php</code> and fill in your SMTP info where it says <code>$smtp=array</code>. If you decide to use SMTP and for some reason it fails, the application will use the sendmail module as a fallback
		</p> 
		<h4>GeoIP</h4>
		<p>
			You can now use the GeoIP database instead of API callback. This can sometimes be faster than the callback. The GeoIP database must be downloaded from <a href="http://dev.maxmind.com/geoip/legacy/geolite/" target="_blank">MaxMind</a> and extracted and uploaded in <code>includes/lib/</code> folder. The two files should be named <code>GeoIP.dat</code> and <code>geoip.inc</code>. Both can be download for free: <a href="http://dev.maxmind.com/geoip/legacy/geolite/" target="_blank">GeoIP.data (GeoLite Country: Binary/gzip)</a> and <a href="https://github.com/maxmind/geoip-api-php/tree/master/src" target="_blank">geoip.inc</a>.</p>
		</p> 		
	</div><!-- /#general.tab_container -->
	<div class="tab_container" id="settings">
		<h2>Application Settings</h2>
		<p>This software has many different settings that you can play with to configure your URL shortener how you want. Most of the settings are pretty forward and don't require additional explanation however some might be confusing. These are explained in details below.</p>

		<h3 id="gsettings">General Settings</h3>
		<h4>Maintenance</h4>
		<p>If you decide to edit your website, you may want to put into maintenance mode. This will prevent any users from accessing the site while it is under maintenance. Admins can however login freely and still use everything.</p>

		<h4>Private Service</h4>
		<p>If you wish to use your shortener for your own purpose, you can set it to private. This will prevent users from registering and shortening URLs. Admins and registered users can still use the application freely however only the admin can create accounts.</p>

		<h4>Redirection</h4>
		<p>As you may have noticed, you have three redirection options: Splash page, frame bar or direct. The splash page shows the thumbnail along with a message that can be customized by just editing the template <code>splash.php</code>. Furthermore, you can enable the auto-redirect option by just filling the field below the redirection setting. Note that the number here will be in seconds (so if you put 5, the user will be automatically redirect after 5 seconds). You can use an alternate splash page only for URLs that match the list of blacklisted keywords. For this the option "Inappropriate URLs" must be enabled.</p>
		<br />
		<p>The other option is a bar that will frame the target URL. The bar can be easily customized by editing the <code>frame.php</code> file. Some websites, such as google, facebook or youtube, can not be framed. In this case the user will be automatically redirected to the target page without going through the frame page.</p>
		<br />
		<p>The final option is that users will be automatically redirected to the target page. Note that if you are using the Google Analytics tracking system, auto-redirection will not be possible. The user will go through a blank page before the target page. A server-side method is available however it is still experimental and may not guarantee gathering of data.</p>
		
		<h4>Anonymous User History</h4>
		<p>If this option is enabled, anonymous users will be able to see their last 10 URLs shortened under the main form on the homepage. These URLs are always public, not pass-protected and not geotargeted. This however requires browser cookies to be enabled.</p>

		<h4>Google Analytics Tracking &amp; Sytem</h4>
		<p>
			Each short URL now comes with advanced statistics. You have two options of gathering data. The first one is the built-in system. This however logs data in the database and may require you too have at least 1 MB of free space (For popular sites, this would be higher).
			The second method uses the powerful &amp; free service provided by Google: Google Analytics. Using this free service will save you from storing massive amount of data in your mysql database, however there are some disadvantages to this (Not reliable data, mismatch of system stats and Google and blank page if you are using direct redirection). Note that this scripts uses GAPI, which is a free google analytics class that enables users to fetch data from Google.
		</p>

		<p>
			To use advanced statistics, you will need to create an account with <a href="http://www.google.com/analytics/" target="_blank">Google</a> and then register your site if you have not done so. You will also need to authenticate using your Google Analytics credential and then grant access to your application. Simply follow these instructions and you should be OK. You may stumble at some errors during this process, because of some settings of your server. The most common error is that Google doesn't grant access to this app to use your analytics data. If after following these instructions, you still get that error, please contact me via my codecanyon profile. But I have tested this on multiple servers and it worked fine.
		</p>
		<h3>Instructions</h3>
		<ol>
			<li>Create an account with <a href="http://www.google.com/analytics/" target="_blank">Google</a></li>
			<li>Register your website and copy your analytics code</li>
			<li>Login to this script's admin panel and add your code in the settings</li>
			<li>Open <code>config.php</code> and add your Google credentials (i.e. email and password) (and folder if you have installed in one)</li>
			<li>Next you will need to get your profile id. You can get that in two ways. Go to Google Analytics and click on your website (or profile). Once you get to the page where you see all charts, check the URL of that page: you should see the following:
				<b>https://www.google.com/analytics/web/?hl=en#management/Profile/SOMETHINGp<code>XXXXXXXX</code></b>. The numbers following the <b>p</b> is your profile id. The second way is to click "Admin" then browse to your profile. You will then see several tabs click on "Profile Settings" and you will see your profile id. Copy and paste that in config.php.
			</li>
			<li>Now everything is set up correctly, but you still need to authorize your app to access your google analytics data. Open your url shortener site. Generate a short URL then go to stats page. Now here you shouldn't see any charts or maps (just blank). This is normal. Let that page open and go to <a href="https://accounts.google.com/DisplayUnlockCaptcha">https://accounts.google.com/DisplayUnlockCaptcha</a> (make sure you are logged in with the same google account that you set up earlier. Once on that page, click "Continue" and then simply refresh your short URL stats page.
			</li>
			<li>Following these steps, the script stats should work. If it doesn't contact me and I will try to find out why.</li>
		</ol>		
		<p class="message note">Please note that the stats are retrieved from Google so they are not live. You may notice a lag between the number of clicks and other stats.</p>
	</div><!-- /#setting.tab_container -->	
	<div class="tab_container" id="editor">
		<h2>Using the new editor</h2>
		<p>You can now easily edit themes or languages by the using the software's own editor. These require some basic knowledge and precautions which are detailed below.</p>

		<h3 id="theme">Theme editor</h3>
		<p>If you want to directly edit the template, you can use the theme editor. On left side you will the list of <strong>authorized</strong> template files and on the right side you will the editor. If you know your stuff and don't fear PHP codes then code ahead and have fun otherwise I highly recommend that you don't play with the PHP code. Note the CSS file must be format in a specific way (much like wordpress). You must add in a comment the format:
		</p>
<pre>
/**
 * Theme: THEME NAME
 * Author: AUTHOR NAME - AUTHOR SITE
 * Date: DATE IN THE FOLLOWING FORMAT: YYYY-MM-DD
 */
</pre>
	<h3 id="lang">Language Editor</h3>
	<p>The language editor features an easy-to-use interface that can filled as you translate the text above it. You just need to write the language name (e.g. English) and translate each sting and the application will take care of the rest. However if you decide to manually translate text (highly discouraged), you have to take precautions as a slight error will cause the application to crash. Also from everything is automated, meaning that languages will be added in the language menu as soon you create them. </p>

	<h4>Translating Custom Pages</h4>
	<p>If you wish to translate one of the custom pages, please follow these instructions.</p>
	<ol>
		<li>Create the original page in English (says the name is <code>My page</code> where the permalink will be http://YOURSITE/page/<code>my-page</code>)</li>

		<li>Create another page and put the translated name of the original one which in our example will be <code>Ma page</code>. If you choose to leave the slug field empty the system will create the following sluge: ma-page. DON'T leave that empty! Instead type-in manually <code>my-page_LANGUAGECODE</code>. So if you create a page with the following slug <code>my-page_fr</code> if a user decides to switch the language to French the system will attempt to get the content of that page first. If it doesn't exist, it will use the original one. </li>

		<li>Also make sure to NOT show the translated page in the menu but do show the original one. The system will take care of that.</li>
	</ol>

	<h3 id="auto-translation">Automatic Translation</h3>
	Translating all these strings can be a pain. If you are interested I can translate it to any language or instruct you how to easily translate this for a fee. Just get in touch with me from codecanyon profile.
	</div><!-- /#editor.tab_container -->	
	<div class="tab_container" id="paypal">
		<h2>How to set up Paypal</h2>

		<p>
			To be able to accept payments, you are required to register for either a <a href="https://www.paypal.com/ca/webapps/mpp/paypal-payments-standard">Business Account</a>. Then all you need to is to set your business paypal email, in the paypal settings and set the cost of some of the features and that is it. Make sure to enable IPN.
		</p>

	</div><!-- /#paypal.tab_container -->		
</div>