<?php if(!defined("APP")) die() ?>
<div class="sidebar">
	<ul class="menu">
		<li><a href="<?php echo $this->config["url"]?>/admin/setting">Configuration</a>
			<ul id="tab-menu">
				<li><a href="#general" class="current">General Settings</a></li>				
				<li><a href="#config">Application Settings</a></li>	
				<li><a href="#security">Security Settings</a></li>
				<li><a href="#user">User Settings</a></li>	
				<li><a href="#tracking">Advanced Tracking</a></li>
				<li><a href="#domain">Multiple Domains</a></li>
				<li><a href="#ads">Advertisement</a></li>			
				<li><a href="#paypal">Paypal Settings</a></li>							
				<li><a href="#mt">Maintenance Tools</a></li>		
			</ul>	
		</li>
		<li><a href="<?php echo $this->config["url"] ?>/admin/setting?do=theme">Choose Theme</a></li>
		<li><a href="<?php echo $this->config["url"] ?>/admin/setting?do=editor">Theme Editor</a></li>
		<li><a href="<?php echo $this->config["url"] ?>/admin/setting?do=lang">Language Editor</a></li>
	</ul>
</div><!-- /.sidebar -->
<div class="content">
	<form action="<?php echo $this->config["url"] ?>/admin/setting?do=update" method="post" class="form" enctype="multipart/form-data">

		<div class="tab_container" id="general">	
			<h2>General Settings</h2>
			<label for="url">Main URL (with http:// and without trailing slash)</label>
			<input type="text" id="url" name="url" value="<?php echo $this->config["url"]?>" class="input" />		
			<a href="#" data-content="The URL of your website. Make sure to remove the last slash." class="tooltip"><i class="icon-help"></i></a>	

			<label for="logo">Site Logo (Max 100 KB)</label>
			<?php if(!empty($this->config["logo"])):  ?>
			<img src="<?php echo $this->config["url"] ?>/static/<?php echo $this->config["logo"] ?>" alt=""> <br />
			<?php endif ?>
			<input type="file" id="logo" name="logo_path" class="input" />
			<a href="#" data-content="The logo of your website (PNG or JPG Max 100 KB)." class="tooltip"><i class="icon-help"></i></a>

			<label for="title">Site Name/Title</label>
			<input type="text" id="title" name="title" value="<?php echo $this->config["title"]?>" class="input" />
			<a href="#" data-content="The title of your website which is also the meta title." class="tooltip"><i class="icon-help"></i></a>

			<label for="keywords">Site Keywords (Seperated by a comma)</label>
			<input type="text" id="keywords" name="keywords" value="<?php echo $this->config["keywords"]?>" class="input" />			

			<label for="description">Description (no html)</label>
			<textarea name="description" id="description" class="input"><?php echo $this->config["description"]?></textarea>		
			
			<label for="languages">Default Language</label>
			<select name="default_lang" id="lanagues">
				<option value="en">English</option>				
				<?php foreach ($this->lang(TRUE) as $lang): ?>
					<option value="<?php echo $lang["code"] ?>" <?php if($this->config["default_lang"]==$lang["code"]) echo "selected" ?>><?php echo $lang["lang"] ?></option>
				<?php endforeach ?>
			</select>

			<label for="email">Admin Email (for contact)</label>
			<input type="text" id="email" name="email" value="<?php echo $this->config["email"]?>" class="input" />
			<a href="#" data-content="All emails sent through the contact form will be sent to this address." class="tooltip"><i class="icon-help"></i></a>


			<label for="facebook">Facebook Page</label>
			<input type="text" id="facebook" name="facebook" value="<?php echo $this->config["facebook"]?>" class="input" />
			<a href="#" data-content="Link to your Facebook page e.g. http://facebook.com/gempixel" class="tooltip"><i class="icon-help"></i></a>

			<label for="twitter">Twitter Page</label>
			<input type="text" id="twitter" name="twitter" value="<?php echo $this->config["twitter"]?>" class="input" />			
			<a href="#" data-content="Link to your Twitter profile e.g. http://www.twitter.com/kbrmedia" class="tooltip"><i class="icon-help"></i></a>	

			<label for="apikey">Geotargeting API Key</label>
			<p>Country of users must be determined from their IP. If you want to use the downloadable GeoIP database (can be faster), leave the following field empty. Otherwise you can get an API key by clicking the help button. The GeoIP database must be downloaded from <a href="http://dev.maxmind.com/geoip/legacy/geolite/" target="_blank">MaxMind</a> and extracted and uploaded in <code>includes/lib/</code> folder. The two files should be named <code>GeoIP.dat</code> and <code>geoip.inc</code>. Both can be download for free: <a href="http://dev.maxmind.com/geoip/legacy/geolite/" target="_blank">GeoIP.data (GeoLite Country: Binary/gzip)</a> and <a href="https://github.com/maxmind/geoip-api-php/tree/master/src" target="_blank">geoip.inc</a>.</p>
			<input type="text" id="apikey" name="apikey" value="<?php echo $this->config["apikey"]?>" class="input" />
			<a href="http://ipinfodb.com/register.php" target="_blank" data-content="This script uses a third party API to determine the user's location hence an API key is requred. This is also required for system tracking. Click on the help icon to register. It's free!" class="tooltip"><i class="icon-help"></i></a>				
		</div><!-- /.tab_container general -->

		<div class="tab_container" id="config">
			<h2>Application Settings</h2>
			<ul class="form_opt" data-id="maintenance">
				<li class="label">Site Online/Offline <small>Setting offline will make your website inaccessible for all users but admins.</small></li>
				<li><a href="" class="last<?php echo (($this->config["maintenance"])?' current':'')?>" data-value="1">Offline for Maintenance</a></li>
				<li><a href="" class="first<?php echo ((!$this->config["maintenance"])?' current':'')?>" data-value="0">Online</a></li>
			</ul>
			<input type="hidden" name="maintenance" id="maintenance" value="<?php echo $this->config["maintenance"]?>">	

			<ul class="form_opt" data-id="private">
				<li class="label">Private Service <small>Enabling this will prevent users from shortening and registering. Only you can create accounts.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["private"])?' current':'')?>" data-value="0">Disable</a></li>
				<li><a href="" class="first<?php echo (($this->config["private"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="private" id="private" value="<?php echo $this->config["private"]?>">	

			<ul class="form_opt" data-id="show_media">
				<li class="label">Media Gateway <small>Enabling this will create automatically media pages for URLs such as Youtube, Vine, Dailymotion. Registered users can override this option.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["show_media"])?' current':'')?>" data-value="0">Disable</a></li>
				<li><a href="" class="first<?php echo (($this->config["show_media"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="private" id="private" value="<?php echo $this->config["private"]?>">				

			<ul class="form_opt" data-id="geotarget">
				<li class="label">Geotargeting (API Key Requried)<small>Redirects user according to their country (if set by user).</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["geotarget"])?' current':'')?>" data-value="0">Disable</a></li>
				<li><a href="" class="first<?php echo (($this->config["geotarget"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="geotarget" id="geotarget" value="<?php echo $this->config["geotarget"]?>">

			<ul class="form_opt" data-id="frame">
				<li class="label">Redirection<small>Choose the type of redirection mechanism. "None" will directly redirect.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["frame"])?' current':'')?>" data-value="0">None</a></li>
				<li><a href="" class="<?php echo (($this->config["frame"]==1)?' current':'')?>" data-value="1">Frame Bar</a></li>
				<li><a href="" class="first<?php echo (($this->config["frame"]==2)?' current':'')?>" data-value="2">Splash Page</a></li>
			</ul>
			<input type="hidden" name="frame" id="frame" value="<?php echo $this->config["frame"]?>">			

			<label>Auto-Redirect Timer (empty=disabled)</label>
			<input type="text" name="timer" value="<?php echo $this->config["timer"]?>" class="input" />
			<a href="#" target="_blank" data-content="To enable auto-redirection, add the number of seconds to wait before redirecting the user from the SPLASH page only, e.g. '5'= 5 seconds" class="tooltip"><i class="icon-help"></i></a>							

			<ul class="form_opt" data-id="api">
				<li class="label">Developer API <small>Allow registered users to shorten URLs from their site using an API.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["api"])?' current':'')?>" data-value="0">Disable</a></li>
				<li><a href="" class="first<?php echo (($this->config["api"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="api" id="api" value="<?php echo $this->config["api"]?>">							

			<ul class="form_opt" data-id="sharing">
				<li class="label">Sharing <small>Allow users to share their shorten URL through social networks such as facebook and twitter.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["sharing"])?' current':'')?>" data-value="0">Disable</a></li>
				<li><a href="" class="first<?php echo (($this->config["sharing"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="sharing" id="sharing" value="<?php echo $this->config["sharing"]?>">					

			<ul class="form_opt" data-id="update_notification">
				<li class="label">Update Notification <small>Be notified when an update is available.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["update_notification"])?' current':'')?>" data-value="0">Disable</a></li>
				 <li><a href="" class="first<?php echo (($this->config["update_notification"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="update_notification" id="update_notification" value="<?php echo $this->config["sharing"]?>">					
		</div><!-- /.tab_container config -->

		<div class="tab_container" id="security">
			<ul class="form_opt" data-id="adult">
				<li class="label">Allow Inappropriate URLs <small>Once disabled, any url containing adult/warez keywords will not be allowed.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["adult"])?' current':'')?>" data-value="0">Do not Allow</a></li>
				<li><a href="" class="first<?php echo (($this->config["adult"])?' current':'')?>" data-value="1">Allow</a></li>
			</ul>
			<input type="hidden" name="adult" id="adult" value="<?php echo $this->config["adult"]?>">		
						
			<label>Blacklist Domains <a href="#" target="_blank" class="tooltip" data-content="To blacklist domain names, simply add them in the field below in the following format (seperated by a comma): domain.com,domain2.com,domain3.com"><i class="icon-help"></i></a></label>

			<textarea name="domain_blacklist" class="input" rows="5"><?php echo $this->config["domain_blacklist"] ?></textarea>

			<label>Blacklist Keywords <a href="#" target="_blank" class="tooltip" data-content="Each URL shortener will be matched with list of keywords below and if matched it will not allowed. Seperate each keyword by a comma e.g. keyword1, keyword2"><i class="icon-help"></i></a></label>
			<textarea name="keyword_blacklist" class="input" rows="5"><?php echo $this->config["keyword_blacklist"] ?></textarea>

			<label>Google Safe Browsing <a href="https://developers.google.com/safe-browsing" target="_blank" class="tooltip" data-content="Google safe browsing prevents spam and phishing URLs from being shortened. You just need an API key to activate. To deactivate it, simply remove the key."><i class="icon-help"></i></a></label>
			<input type="text" class="input" name="safe_browsing" value="<?php echo $this->config["safe_browsing"]?>">

			<ul class="form_opt" data-id="captcha">
				<li class="label">Captcha (View Documentation)<small>Users will be prompted to answer a captcha before processing their request.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["captcha"])?' current':'')?>" data-value="0">Disable</a></li>
				<li><a href="" class="<?php echo (($this->config["captcha"]=="1")?' current':'')?>" data-value="1">reCaptcha</a></li>
				<li><a href="" class="first<?php echo (($this->config["captcha"]=="2")?' current':'')?>" data-value="2">Solvemedia</a></li>
			</ul>
			<input type="hidden" name="captcha" id="captcha" value="<?php echo $this->config["captcha"]?>">	

			<label>reCaptcha Public Key</label>
			<input type="text" class="input" name="captcha_public" value="<?php echo $this->config["captcha_public"]?>">
			<a href="https://recaptcha.net" target="_blank" class="tooltip" data-content="To use reCaptcha, you must grab a public key and a private key which can be obtained for free. Click on the help icon to register."><i class="icon-help"></i></a>
		
			<label>reCaptcha Private Key</label>
			<input type="text" class="input" name="captcha_private" value="<?php echo $this->config["captcha_private"]?>">			
			
			<h2>Notes about security settings</h2>
			<p>Be careful when blacklisting keywords as the system can sometimes mark a URL as bad simply because the keyword matches it so be as precise as possible. Also if you leave the keyword field empty, the system will use an internal list, that is if the option is disabled.</p>

			<p>Currently there are only two CAPTCHA systems supported however if you have the knowledge you can easily implement your own. The input fields above are for <b>reCaptcha</b> only. For other systems, you must directly add your keys in their respective files that are in the includes folder.</p>
		</div><!-- /.tab_container security -->

		<div class="tab_container" id="user">

			<ul class="form_opt" data-id="user_r">
				<li class="label">User Registration <small>Allow users to register and to bookmark their URLs. If disable registration links will be hidden.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["user"])?' current':'')?>" data-value="0">Disable</a></li>
				 <li><a href="" class="first<?php echo (($this->config["user"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="user" id="user_r" value="<?php echo $this->config["user"]?>">	

			<ul class="form_opt" data-id="user_activate">
				<li class="label">User Activation <small>If enabled, an email containing an activation link will be sent to the user.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["user_activate"])?' current':'')?>" data-value="0">Disable</a></li>
				 <li><a href="" class="first<?php echo (($this->config["user_activate"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="user_activate" id="user_activate" value="<?php echo $this->config["user_activate"]?>">			

			<ul class="form_opt" data-id="user_history">
				<li class="label">Anonymous User History <small>If enabled, anonymous users can view their personal history of URLs on the home page.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["user_history"])?' current':'')?>" data-value="0">Disable</a></li>
				 <li><a href="" class="first<?php echo (($this->config["user_history"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="user_history" id="user_history" value="<?php echo $this->config["user_history"]?>">

			<ul class="form_opt" data-id="fb_connect">
				<li class="label">Enable Facebook Connect <small>Users can login and get registered using their facebook account.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["fb_connect"])?' current':'')?>" data-value="0">Disable</a></li>
				<li><a href="" class="first<?php echo (($this->config["fb_connect"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="fb_connect" id="fb_connect" value="<?php echo $this->config["fb_connect"]?>">			
	
			<label>Facebook App ID</label>
			<input type="text" class="input" name="facebook_app_id" value="<?php echo $this->config["facebook_app_id"]?>">
			<a href="https://developer.facebook.com" target="_blank" class="tooltip" data-content="You need both the Application ID and Secret ID to be able to use facebook connect. Click on the help icon for more info."><i class="icon-help"></i></a>

			<label>Facebook Secret</label>
			<input type="text" class="input" name="facebook_secret" value="<?php echo $this->config["facebook_secret"]?>">

			<ul class="form_opt" data-id="tw_connect">
				<li class="label">Enable Twitter Connect <small>Users can login and get registered using their twitter account.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["tw_connect"])?' current':'')?>" data-value="0">Disable</a></li>
				<li><a href="" class="first<?php echo (($this->config["tw_connect"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="tw_connect" id="tw_connect" value="<?php echo $this->config["tw_connect"]?>">			

			<label>Twitter Key</label>
			<input type="text" class="input" name="twitter_key" value="<?php echo $this->config["twitter_key"]?>">
			<a href="https://dev.twitter.com" target="_blank" class="tooltip" data-content="You need both the Application key and Secret ID to be able to use twitter connect. Click on the help icon for more info."><i class="icon-help"></i></a>

			<label>Twitter Secret</label>
			<input type="text" class="input" name="twitter_secret" value="<?php echo $this->config["twitter_secret"]?>">
			
			<h2>Notes about login system</h2>
			<p>Once user registration is disabled, new users will not be able to register in any way. All registration system including Facebook and Twitter connect will be disabled regardless of their respective setting above. Existing users can still freely login using any method.</p>
		</div><!-- /.tab_container user -->

		<div class="tab_container" id="tracking">
			<ul class="form_opt" data-id="tracking">
				<li class="label">Choose Advanced Tracking System <small>"Google" will use Google Analytics, "System" will use built-in tracking system and "Disable" will disable advanced tracking.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["tracking"])?' current':'')?>" data-value="0">Disable</a></li>
				<li><a href="" class="<?php echo (($this->config["tracking"]==='1')?' current':'')?>" data-value="1">System</a></li>
				<li><a href="" class="first<?php echo (($this->config["tracking"]==='2')?' current':'')?>" data-value="2">Google</a></li>
			</ul>
			<input type="hidden" name="tracking" id="tracking" value="<?php echo $this->config["tracking"]?>">

			<label for="analytic">Google Analytics Account ID</label>
			<input name="analytic" id="analytic" class="input" value="<?php echo $this->config["analytic"]?>">
			<a href="#" data-content="You Google Analytics account id e.g. UA-12345678-1." class="tooltip"><i class="icon-help"></i></a>	

			<h2>Notes on using Google Analytics</h2>
			<p>If you want to use Google Analytics then please create a Google Analytics (GA) account and register your website. Following that you must copy and paste your GA account ID (e.g. UA-12345678-1) in the field above. You must also authorize your site to access you GA data by following the instructions in the <a href="<?php echo $this->config["url"] ?>/admin/help#analytics">documentation</a>.</p>
		</div><!-- /.tab_container tracking -->

		<div class="tab_container" id="domain">
			<h2>Multiple Domains</h2>
			<ul class="form_opt" data-id="multiple_domains">
				<li class="label">Multiple Domain Names <small>If enabled users will have the choice to select their preferred domain name from the list below. Make sure that all these point to the script.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["multiple_domains"])?' current':'')?>" data-value="0">Disable</a></li>
				<li><a href="" class="first<?php echo (($this->config["multiple_domains"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="multiple_domains" id="multiple_domains" value="<?php echo $this->config["multiple_domains"]?>">			
			<label>Domain  (one domain per line, do not include your main domain name)</label>
			<textarea name="domain_names" class="input"><?php echo $this->config["domain_names"]?></textarea>
			
			<h2>Notes about Multiple Domains</h2>
			<p>If you own and want use multiple domain names then all you have to do is to point all of them to the location where this script is installed. This means that you have to use the DNS servers and the same path as your primary domain. <strong>Notes</strong> The main domain will be automatically added in the list and will always be the default one. Also, secondary domains will always be redirected to the primary domain as login information is usually stored on the main one and cannot be transfered easily. This redirection occurs everywhere except when users follow the short URL.</p>
		</div><!-- /.tab_container domain-->

		<div class="tab_container" id="ads">
			<h2 id='advert'>Advertisement</h2>
			<ul class="form_opt" data-id="ads">
				<li class="label">Advertisement <small>Enable or disable advertisement throughout the site.</small></li>
				<li><a href="" class="last<?php echo ((!$this->config["ads"])?' current':'')?>" data-value="0">Disable</a></li>
				<li><a href="" class="first<?php echo (($this->config["ads"])?' current':'')?>" data-value="1">Enable</a></li>
			</ul>
			<input type="hidden" name="ads" id="ads" value="<?php echo $this->config["ads"]?>">			

			<label>Advertisement Code 1 (728x90 recommended)</label>
			<textarea name="ad728" class="input"><?php echo $this->config["ad728"]?></textarea>
			<label>Advertisement Code 2 (468x60 recommended)</label>
			<textarea name="ad468" class="input"><?php echo $this->config["ad468"]?></textarea>
			<label>Advertisement Code 3 (300x250 recommended)</label>
			<textarea name="ad300" class="input"><?php echo $this->config["ad300"]?></textarea>		
			<h2>Note about Advertisment codes</h2>	
			<p>Although this script stores three different codes, it does not use all of them. This is done to make the process of adding ads easier. You will have the option to dynamically insert advertisment in your <a href="<?php echo $this->config["url"]?>/admin/page">custom page</a>. Also if you want to edit the theme and directly add advertisements you can use the following code (where <b>SIZE</b> can be 728, 468 or 300): 
			<br>
			<code>&lt;?php echo $this->ads('<b>SIZE</b>')?></code></p>	
		</div><!-- /#ads.tab_container -->	

		<div class="tab_container" id="paypal">
			<h2 id='advert'>Paypal Settings</h2>
			<label for="paypal_email">Paypal Business Email</label>
			<input name="paypal_email" id="paypal_email" class="input" value="<?php echo $this->config["paypal_email"]?>">
			<a href="#" data-content="Paypal business email where the payments will be made to." class="tooltip"><i class="icon-help"></i></a>	
			
			<label for="removal_amount">Advertisement Removal Amount in USD</label>
			<input name="removal_amount" id="removal_amount" class="input" value="<?php echo $this->config["removal_amount"]?>">
			<a href="#" data-content="User must pay this amount to remove ads. E.g 4.99" class="tooltip"><i class="icon-help"></i></a>	

			<label for="custom_splash_amount">Custom Splash Page Amount in USD (leave empty to unlock for free)</label>
			<input name="custom_splash_amount" id="custom_splash_amount" class="input" value="<?php echo $this->config["custom_splash_amount"]?>">
			<a href="#" data-content="User must pay this amount to unlock custom splash page. E.g 9.99" class="tooltip"><i class="icon-help"></i></a>	
		</div><!-- /#paypal.tab_container -->	

		<div class="tab_container" id="mt">
			<h2>Delete inactive URLs</h2>
			<div class="row">
				<div class="grid twothird">
					<p>This feature cleans the database by deleting inactive URLs. Inactive URLs are those that haven't received any clicks in the last 30 days.</p>
				</div><!-- /.grid twothird -->
				<div class="grid third">
					<p><a href="<?php echo $this->config["url"] ?>/admin/?do=deleteinactiveurls&amp;token=<?php echo md5(date('YndH')."DeleteInactiveURL")?>" class="button red delete right">Delete URLs</a></p>
				</div><!-- /.grid third -->				
			</div>				
			<h2>Delete inactive Users</h2>
			<div class="row">
				<div class="grid twothird">
					<p>This feature cleans the database by deleting inactive users. Inactive users are those who haven't activated their account yet.</p>
				</div><!-- /.grid twothird -->
				<div class="grid third">
					<p><a href="<?php echo $this->config["url"] ?>/admin/?do=deleteinactiveusers&amp;token=<?php echo md5(date('YndH')."DeleteInactiveUsers")?>" class="button red delete right">Delete Users</a></p>
				</div><!-- /.grid third -->				
			</div>				
			<h2>Export URLs</h2>
			<div class="row">
				<div class="grid twothird">
					<p>Click the button to export a list of URLs in CSV format. The list can be opened on excel and software that support csv file. This may take several minutes depending on the amount of URLs present in the database. Click only once!</p>
				</div><!-- /.grid twothird -->
				<div class="grid third">
					<p><a href="<?php echo $this->config["url"] ?>/admin/?do=exporturls" class="button right clickonce">Export URLs</a></p>
				</div><!-- /.grid third -->				
			</div>				
			<h2>Export Users</h2>
			<div class="row">
				<div class="grid twothird">
					<p>Click the button to export a list of users in CSV format. The list can be opened on excel and software that support csv file. Click only once!</p>
				</div><!-- /.grid twothird -->
				<div class="grid third">
					<p><a href="<?php echo $this->config["url"] ?>/admin/?do=export" class="button right clickonce">Export Users</a></p>
				</div><!-- /.grid third -->				
			</div>	
			<h2>Optimize Database</h2>
			<div class="row">
				<div class="grid twothird">
					<p>Optimizing the database regularly keeps the data structured and speeds up retrieval of data.</p>
				</div><!-- /.grid twothird -->
				<div class="grid third">
					<p><a href="<?php echo $this->config["url"] ?>/admin/?do=optimize" class="button right">Optimize Database</a></p>
				</div><!-- /.grid third -->				
			</div>						
		</div><!-- /#mt.tab_container -->		
		<?php echo Main::csrf_token(TRUE) ?>
		<button type="submit" class="button">Submit</button>		
	</form>
</div><!-- /.content -->