<?php
require ("../includes/config.php");

if($config["private"] || !$config["user"] || $config["maintenance"]) Main::redirect("?error",array("error",e("Sorry, we are not accepting users right now.")));

if(isset($_GET["auth"])){
  // GET Auth Type
  if($app->logged()) Main::redirect("",array("error",e("You are already logged in.")));
  if($_GET['auth']=='facebook'){

    //Facebook Auth
    if(!$config["fb_connect"]) Main::redirect("",array("error",e("Sorry, Facebook connect is not available right now.")));
    if(isset($_GET["error"])) Main::redirect("",array("error",e("You must grant access to this application to use your facebook account.")));

    require("facebook.php");  

    // Creating the facebook object  
    $facebook = new Facebook(array(  
        'appId'  => $config["facebook_app_id"],
        'secret' =>  $config["facebook_secret"], 
        'cookie' => true
    )); 

    // Let's see if we have an active session 
    $session = $facebook->getUser(); 
    if (!empty($session)) { 
      $fb = $facebook->api('/me');   
      if(!isset($fb["email"])) Main:: redirect("",array("error",e("You must grant permission to this application to use your profile information.")));
      $app->auth("facebook",array("email"=>$fb["email"],"username"=>$fb["username"],"id"=>$fb["id"]));
      exit;
    }else{  
      $login_url = $facebook->getLoginUrl(array('scope' => 'email')); 
      header("Location: ".$login_url);  
      exit;
    }    
  }elseif($_GET['auth']=='twitter'){
    if(isset($_GET["denied"])) Main:: redirect("",array("error",e("You must grant permission to this application to use your twitter account.")));

    if(!$config["tw_connect"]) Main::redirect("",array("error",e("Sorry, Twitter connect is not available right now.")));

    require("twitter.php"); 
    if(!empty($_GET['oauth_verifier']) && !empty($_SESSION['oauth_token']) && !empty($_SESSION['oauth_token_secret'])){  
      $twitteroauth = new TwitterOAuth($config["twitter_key"], $config["twitter_secret"], $_SESSION['oauth_token'], $_SESSION['oauth_token_secret']);
      $access_token = $twitteroauth->getAccessToken($_GET['oauth_verifier']); 
      // Save it in a session var 
      $_SESSION['access_token'] = $access_token; 
      // Let's get the user's info 
      $user_info = $twitteroauth->get('account/verify_credentials');
      if(!isset($user_info->id)) Main::redirect("",array("error",e("An error occured, please try again later.")));
      $app->auth("twitter",array("id"=>$user_info->id,"username"=>$user_info->screen_name));
    }
    // The TwitterOAuth instance  
    $twitteroauth = new TwitterOAuth($config["twitter_key"], $config["twitter_secret"]);  

    // Requesting authentication tokens, the parameter is the URL we will be redirected to  
    $request_token = $twitteroauth->getRequestToken("{$config["url"]}/connect?auth=twitter");
    // Saving them into the session  
    $_SESSION['oauth_token'] = $request_token['oauth_token'];  
    $_SESSION['oauth_token_secret'] = $request_token['oauth_token_secret'];  
    // If everything goes well..  
    if($twitteroauth->http_code==200){  
        // Let's generate the URL and redirect  
        $url = $twitteroauth->getAuthorizeURL($request_token['oauth_token']); 
        header('Location: '. $url); 
        exit;
    } else { 
       Main::redirect('',array('error','An error has occured! Please make sure that you have set up this application as instructed.'));  
    }  
  }
}
Main::redirect("?");
?>