<?php 
/**
 * ====================================================================================
 *                           PREMIUM URL SHORTENER (c) KBRmedia
 * ----------------------------------------------------------------------------------
 * @copyright This software is exclusively sold at CodeCanyon.net. If you have downloaded this
 *  from another site or received it from someone else than me, then you are engaged
 *  in an illegal activity. You must delete this software immediately or buy a proper
 *  license from http://gempixel.com/buy/short.
 *
 *  Thank you for your cooperation and don't hesitate to contact me if anything :)
 * ====================================================================================
 *
 * @author KBRmedia (http://gempixel.com)
 * @link http://gempixel.com 
 * @package Premium URL Shortener
 * @subpackage Admin Request Handler (Admin.class.php)
 */
class Admin{

		protected $id, $email, $user;
		protected $out;
		protected $config, $db;
		private $update=TRUE;
		protected $page=1;


    public function __construct($db,$config){
       $_GET=array_map("Main::clean", $_GET);       
       if(isset($_GET["page"]) && is_numeric($_GET["page"])) $this->page=$_GET["page"];       
       $this->config=$config;
       $this->db=$db;
       $this->out= new stdClass();
       if($this->config["demo"]) $this->update=FALSE;
    }
    public function __destruct(){
			unset($this->db,$this->out,$this->config);
		}
	/**
	 * Validate admin & set info
	 * @since v2.0
	 */
		public function check(){				
			if($info=Main::user()){
				if($user=$this->db->get("user",array("id"=>"?","password"=>"?","admin"=>"1"),array("limit"=>1),array($info[0],$info[1]))){
					$this->id=$user["id"];
					$this->email=$user["email"];
					return TRUE;
				}
			}
			return FALSE;
		}	
	/**
	 * Is set Action
	 * @since v2.0
	 */
		public function action($action,$var="action"){
			if(isset($_GET[$var]) && $_GET[$var]==$action) return TRUE;
			return FALSE;
		}
	/**
	 * Admin Info
	 * @since v2.0
	 */
		public function info($info){
			if(isset($this->$info)) return $this->$info;
		}
		/**
		 * Admin Header Content
		 */
		public function dispatch(){
			if(isset($_GET["do"]) && in_array($_GET["do"], array("export","exporturls","deleteinactiveurls","optimize","deleteinactiveusers"))){
				$this->$_GET["do"]();
				exit;
			}else{
				ob_start();
			}
		}
		/**
		 * Generate Content
		 * @since v3.0
		 */
		public function content(){
			if(!isset($_GET["action"]) || (isset($_GET["action"]) && $_GET["action"]=="admin")){
				$this->home();
			}else{
				if(in_array($_GET["action"], array("url","user","page","setting","help","search","stats"))){
					$this->$_GET["action"]();
				}else{
					echo "<p class='message error'>Page not found or access not authorized.</p>";
				}
			}
		}
		/**
		 * Generate Dashboard Layout
		 * @since v2.0
		 */
		protected function home(){
			$this->out->urls=$this->db->count("url");
			$this->out->urls_today=$this->db->count("url","date>=curdate()")." Today";
			$this->out->users=$this->db->count("user");
			$this->out->users_today=$this->db->count("user","date>=curdate()")." Today";
			$this->out->clicks=$this->db->count("url","","click");
			if($this->config["tracking"]=="2") {
				$this->out->clicks_today="Not available*";
			}else{
				$this->out->clicks_today=$this->db->count("stats","date>=curdate()")." Today";
			}
			include(ROOT."/admin/system/index.php");
		}
		/**
		 * Search Page
		 * @since v2.0
		 */
		protected function search($limit=15){
			if(empty($_GET["q"]) || strlen($_GET["q"])<3) Main::redirect("admin",array("error","Keyword must be at least 3 characters."));
			
			if($this->action("user","do")){
				if($data=$this->db->search("user",array("email"=>"?","username"=>"?"),array("count"=>TRUE,"limit"=>(($this->page-1)*$limit).", $limit"),array("%{$_GET["q"]}%","%{$_GET["q"]}%"))){
					$this->out->users=$data;
				}else{
					Main::redirect("admin/user",array("error","Nothing found for this query."));
					$this->out->users=array();
					return;
				}				
				if(($this->db->rowCount%$limit)<>0) {
					$max=floor($this->db->rowCount/$limit)+1;
				} else {
					$max=floor($this->db->rowCount/$limit);
				}			
				$this->out->count=$this->db->rowCount;
				$this->out->pagination=Main::pagination($max, $this->page, $this->config["url"]."/admin/search?q={$_GET["q"]}&do=user&page=%d");
			}else{
				if($data=$this->db->search("url",array("url"=>":q","alias"=>":q","meta_title"=>":q"),array("count"=>TRUE,"limit"=>(($this->page-1)*$limit).", $limit"),array(":q"=>"%{$_GET["q"]}%"))){
					$this->out->urls=$data;
				}else{
					Main::redirect("admin/url",array("error","Nothing found for this query."));
					$this->out->urls=array();
				}				
				if(($this->db->rowCount%$limit)<>0) {
					$max=floor($this->db->rowCount/$limit)+1;
				} else {
					$max=floor($this->db->rowCount/$limit);
				}			
				$this->out->count=$this->db->rowCount;
				$this->out->pagination=Main::pagination($max, $this->page, $this->config["url"]."/admin/search?q={$_GET["q"]}&page=%d");
			}
			include(ROOT."/admin/system/search.php");
		}
		/**
		 * Generate Admin URLs page 
		 * @since v2.0		 
		 */		
		protected function url($limit=15){
			if(isset($_GET["do"])){
				if($_GET["do"]=="edit"){
					$this->url_edit();					
					return;				
				}elseif($_GET["do"]=="delete"){
					$this->url_delete();					
					return;	
				}elseif($_GET["do"]=="mass-delete"){
					$this->url_delete_all();					
					return;	
				}
			}
			$filter="id";
			$order="id";
			$asc=FALSE;			
			$array_filters=array("most","less","old");
			$class[0]=$class[1]=$class[2]=$class[3]="";

			if(isset($_GET["filter"]) && in_array($_GET["filter"], $array_filters)){
					if($_GET["filter"]=="most"){
						$filter="click";
						$order="most";
						$asc=FALSE;
						$class[2]="class='current'";
					}elseif($_GET["filter"]=="less"){
						$filter="click";
						$order="less";
						$asc=TRUE;
						$class[3]="class='current'";
					}elseif($_GET["filter"]=="old"){
						$filter="date";
						$order="old";
						$asc=TRUE;
						$class[1]="class='current'";
					}
			}else{
				$class[0]="class='current'";
			}
			if($data=$this->db->get("url","",array("count"=>TRUE,"order"=>$filter,"limit"=>(($this->page-1)*$limit).", $limit","asc"=>$asc))){
				$this->out->urls=$data;
			}else{
				$this->out->urls=array();
			}
			if($this->page > $this->db->rowCount) Main::redirect("admin/",array("error","No URLs found."));
			if(($this->db->rowCount%$limit)<>0) {
				$max=floor($this->db->rowCount/$limit)+1;
			} else {
				$max=floor($this->db->rowCount/$limit);
			}			
			$this->out->count=$this->db->rowCount;
			$this->out->pagination=Main::pagination($max, $this->page, $this->config["url"]."/admin/url?page=%d&filter=$order");

			include(ROOT."/admin/system/urls.php");
		}
		/**
		 * Generate Edit URL page 
		 * @since v2.0		 
		 */		
		protected function url_edit(){
			if(isset($_POST["id"]) && is_numeric($_POST["id"])){
				$this->url_update();
				return;
			}
			if($url=$this->db->get("url",array("id"=>"?"),array("limit"=>1),array($_GET["id"]))){
				$this->out->url=$url;
				include(ROOT."/admin/system/editurl.php");
				return;
			}
			Main::redirect("admin",array("error","This url doesn't exist."));
			return;
		}
		/**
		 * Update URL 
		 * @since v2.0		 
		 */		
		protected function url_update(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			if(!Main::validate_csrf_token($_POST["token"])){
				Main::redirect("admin/url?do=edit&id={$_POST["id"]}",array("error","Something went wrong, please try again."));
				return;
			}
			if(!empty($_POST['location'][0]) && !empty($_POST['target'][0])){
				foreach ($_POST['location'] as $i => $country) {
					if(!empty($country)){
						$countries[strtolower(Main::clean($country))]=$_POST['target'][$i];
				  }
				}
				$countries=json_encode($countries);
			}else{
				$countries='';
			}	
			if($this->db->update("url",array("url"=>"?","meta_title"=>"?","meta_description"=>"?","location"=>"?","ads"=>"?"),array("id"=>"?"),array($_POST["url"],Main::clean($_POST["title"]),Main::clean($_POST["description"]),$countries,$_POST["ads"],$_POST["id"]))){
				Main::redirect("admin/url?do=edit&id={$_POST["id"]}",array("success","This URL has been successfully updated."));
				return;
			}
			Main::redirect("admin",array("error","This url doesn't exist."));
			return;
		}		
		/**
		 * Delete URL + everything attached
		 * @since v2.0		 
		 */		
		protected function url_delete($id=NULL){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			if(isset($_GET["id"]) && is_numeric($_GET["id"]) && is_null($id)){
				$deleteid=$_GET["id"];
			}elseif(!is_null($id)){
				$deleteid=$id;
			}else{
				Main::redirect("admin/url",array("error","That action cannot be completed."));
				return;
			}
			$url=$this->db->get("url",array("id"=>"?"),array("limit"=>1),array($deleteid));
			$this->db->delete("url",array("id"=>"?"),array($deleteid));
			$this->db->delete("stats",array("short"=>"?"),array($url["alias"]));
			if(is_null($id)) Main::redirect("admin/url",array("success","This url and associated stats have been successfully deleted."));	
			return;
		}	
		/**
		 * Delete All URLs
		 * @since v2.0		 
		 */		
		protected function url_delete_all(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			if(!Main::validate_csrf_token($_POST["token"])){
				Main::redirect("admin/url",array("error","Something went wrong, please try again."));
				return;
			}			
			foreach($_POST["delete-id"] as $id){
				if(is_numeric($id)){
					$this->url_delete($id);
				}
			}				
			Main::redirect("admin/url",array("success","Selected URLs have beed deleted."));
			return;
		}		
		/**
		 * Generate Admin Users page
		 * @since v2.0
		 */
		protected function user($limit=15){
			if(isset($_GET["do"])){
				if($_GET["do"]=="profile"){
					$this->user_profile($limit);					
				}elseif($_GET["do"]=="delete"){
					$this->user_delete();					
				}elseif($_GET["do"]=="deleteall"){
					$this->user_delete_all();					
				}
				return;				
			}
			$filter="id";
			$order="id";
			$asc=FALSE;			
			$where="";
			$array_filters=array("admin","old");			
			$class[0]=$class[1]=$class[2]="";

			if(isset($_GET["filter"]) && in_array($_GET["filter"], $array_filters)){
					if($_GET["filter"]=="old"){
						$filter="date";
						$order="old";
						$asc=TRUE;
						$class[1]="class='current'";
					}elseif($_GET["filter"]=="admin"){
						$where=array("admin"=>"1");
						$class[2]="class='current'";
					}
			}else{
				$class[0]="class='current'";
			}			
			if($data=$this->db->get("user",$where,array("count"=>TRUE,"order"=>$filter,"limit"=>(($this->page-1)*$limit).", $limit","asc"=>$asc,"all"=>1))){
				$this->out->users=$data;
			}else{
				$this->out->users=array();
			}
			if($this->db->rowCount!="0" && $this->page > $this->db->rowCount) Main::redirect("admin/",array("error","No user found."));
			if(($this->db->rowCount%$limit)<>0) {
				$max=floor($this->db->rowCount/$limit)+1;
			} else {
				$max=floor($this->db->rowCount/$limit);
			}			
			$this->out->count=$this->db->rowCount;
			$this->out->pagination=Main::pagination($max, $this->page, $this->config["url"]."/admin/user?page=%d");

			include(ROOT."/admin/system/users.php");
		}
		/**
		 * Shows User Profile
		 * @since v2.0
		 */		
		protected function user_profile($limit){
			if(isset($_GET["id"]) && is_numeric($_GET["id"])){
					if($user=$this->db->get("user",array("id"=>$_GET["id"]),array("limit"=>1))){
						$user["email"]=($this->config["demo"])?"Hidden":$user["email"];
						if($data=$this->db->get("url",array("userid"=>$_GET["id"]),array("order"=>"date","limit"=>(($this->page-1)*$limit).", $limit"))){
							$this->out->urls=$data;
						}else{
							$this->out->urls=array();
						}
						if(($this->db->rowCount%$limit)<>0) {
							$max=floor($this->db->rowCount/$limit)+1;
						} else {
							$max=floor($this->db->rowCount/$limit);
						}			
						$this->out->pagination=Main::pagination($max, $this->page, $this->config["url"]."/admin/user?do=profile&id={$_GET["id"]}&page=%d");
						include(ROOT."/admin/system/profile.php");
						return;			
					}		
				}			
		}
		/**
		 * Add user
		 * @since v2.0
		 */		
		public function user_add(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			if(!Main::validate_csrf_token($_POST["token"])) {
				Main::redirect("admin/user",array("error","Something went wrong, please try again."));
				return;
			}
			if(empty($_POST["email"]) || !Main::email($_POST["email"])){
				echo "<p class='message error'>Please enter a valid email.</p>";
				return;
			}
			if($this->db->get("user",array("email"=>"?"),array("limit"=>1),array($_POST["email"]))){
				echo "<p class='message error'>This email has already been used. Please try again.</p>";
				return;
			}
			if(!empty($_POST["username"]) && $this->db->get("user",array("username"=>"?"),array("limit"=>1),array($_POST["username"]))){
				echo "<p class='message error'>This username has already been used. Please try again.</p>";
				return;
			}
			if(empty($_POST["password"]) || strlen($_POST["password"])<6) {
				echo "<p class='message error'>Please enter a strong password (at least 6 characters).</p>";
				return;
			}
			$unique=FALSE;
			while (!$unique) {
				$api=Main::api();
				if(!$this->db->get("user",array("api"=>$api),array("limit"=>1))) $unique=TRUE;
			}			
			if($this->db->insert("user",array("email"=>"?","username"=>"?","password"=>"?","admin"=>"?","date"=>"NOW()","api"=>"?","ads"=>"?"),array(Main::email($_POST["email"]),Main::slug($_POST["username"]),Main::encode($_POST["password"]),Main::clean($_POST["status"]),$api,Main::clean($_POST["ads"])))){
				Main::set_message(array("success","This user has been successfully added."));
				echo "<p class='message success'>This user has been successfully added.</p>";
				echo "<script>window.location='{$this->config["url"]}/admin/user'</script>";
				return;
			}	
		}		
		/**
		 * Edit user
		 * @since v2.0
		 */			
		public function user_edit(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			if(!Main::validate_csrf_token($_POST["token"])) {
				Main::redirect("admin/user",array("error","Something went wrong, please try again."));
				return;
			}
			$user=$this->db->get("user",array("id"=>"?"),array("limit"=>1),array($_POST["id"]));
			if($user["auth"]!="twitter" && (empty($_POST["email"]) || !Main::email($_POST["email"]))){
				echo "<p class='message error'>Please enter a valid email.</p>";
				return;
			}
			if($_POST["email"]!==$user["email"]){
				if($this->db->get("user",array("email"=>"?"),array("limit"=>1),array($_POST["email"]))){
					echo "<p class='message error'>This email has already been used. Please try again.</p>";
					return;
				}
			}		
			if(!empty($_POST["username"]) && $_POST["username"]!==$user["username"]){
				if($this->db->get("user",array("username"=>"?"),array("limit"=>1),array($_POST["username"]))){
					echo "<p class='message error'>This username has already been used. Please try again.</p>";
					return;
				}
			}			
			if(!empty($_POST["password"])){
				if($this->db->update("user",array("email"=>"?","username"=>"?","password"=>"?","admin"=>"?","ads"=>"?","banned"=>"?","active"=>"?","splash_opt"=>"?"),array("id"=>"?"),array(Main::email($_POST["email"]),Main::clean($_POST["username"]),Main::encode($_POST["password"]),Main::clean($_POST["status"]),Main::clean($_POST["ads"]),Main::clean($_POST["banned"]),Main::clean($_POST["active"]),Main::clean($_POST["splash_opt"]),Main::clean($_POST["id"])))){
					Main::set_message(array("success","This user has been successfully added."));
					echo "<p class='message success'>This user has been successfully updated.</p>";
					echo "<script>window.location='{$this->config["url"]}/admin/user?do=profile&id={$_POST['id']}'</script>";
					return;
				}					
			}else{
				if($this->db->update("user",array("email"=>"?","username"=>"?","admin"=>"?","ads"=>"?","banned"=>"?","active"=>"?","splash_opt"=>"?"),array("id"=>"?"),array(Main::email($_POST["email"]),Main::clean($_POST["username"]),Main::clean($_POST["status"]),Main::clean($_POST["ads"]),Main::clean($_POST["banned"]),Main::clean($_POST["active"]),Main::clean($_POST["splash_opt"]),Main::clean($_POST["id"])))){
					Main::set_message(array("success","This user has been successfully added."));
					echo "<p class='message success'>This user has been successfully updated.</p>";
					echo "<script>window.location='{$this->config["url"]}/admin/user?do=profile&id={$_POST['id']}'</script>";
					return;
				}	
			}
		}		
		/**
		 * Delete user
		 * @since v2.0
		 */		
		protected function user_delete(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			if(isset($_GET["id"]) && is_numeric($_GET["id"])){
				$this->db->delete("user",array("id"=>"?"),array($_GET["id"]));
				Main::redirect("admin/user",array("success","This user has been successfully deleted."));
			}	
		}
		/**
		 * Delete user + urls + stats + folders
		 * @since v2.0
		 */		
		protected function user_delete_all(){		
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));	
			if(isset($_GET["id"]) && is_numeric($_GET["id"])){
				$urls=$this->db->get("url",array("userid"=>"?"),array("limit"=>1),array($_GET["id"]));
				foreach ($url as $url) {
					$this->db->delete("stats",array("short"=>"?"),array($url["alias"]));
				}
				$this->db->delete("url",array("userid"=>"?"),array($_GET["id"]));
				$this->db->delete("user",array("id"=>"?"),array($_GET["id"]));
				Main::redirect("admin/user",array("success","This user and everything associated have been successfully deleted."));
			}	
		}		
		/**
		 * Generate Admin Custom Page page
		 * @since v2.0
		 */
		protected function page($limit=15){
			if(isset($_POST["do"])){
				if($_POST["do"]=="update"){
					$this->page_edit();
					return;					
				}elseif($_POST["do"]=="add"){
					$this->page_add();
					return;
				}
			}			
			if(isset($_GET["do"])){
					$this->out->page=array();
					if($_GET["do"]=="edit" && ($page=$this->db->get("page",array("id"=>$_GET["id"]),array("limit"=>1)))){
						$this->out->page=$page;
					}elseif($_GET["do"]=="delete"){
						$this->page_delete();
						return;
					}
					include(ROOT."/admin/system/page_form.php");
				return;
			}
			if($pages=$this->db->get("page")){
				$this->out->pages=$pages;
			}else{
				$this->out->pages=array();
			}
			include(ROOT."/admin/system/page.php");
		}	
		/**
		 * Add a Page 
		 * @since v2.0
		 */	
		protected function page_add(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			if(!Main::validate_csrf_token($_POST["token"])) {
				Main::redirect("admin/page?do=add",array("error","Something went wrong, please try again."));
				return;
			}
			if(!empty($_POST["title"]) && !empty($_POST["content"])){
				if($this->db->get("page",array("seo"=>Main::slug((!empty($_POST["seo"])?$_POST["seo"]:$_POST["title"]))))){
					Main::redirect("admin/page?do=add",array("error","This slug is already taken, please use another one."));
				}
				if($this->db->insert("page",array("name"=>"?","seo"=>"?","content"=>"?","menu"=>"?"),array($_POST["title"],Main::slug((!empty($_POST["seo"])?$_POST["seo"]:$_POST["title"])),$_POST["content"],$_POST["menu"]))){
					Main::redirect("admin/page",array("success","This page has been successfully added."));
				}					
			}
			Main::redirect("admin/page?do=add",array("error","Please make sure that you fill everything correctly."));		
			return;					
		}		 	
		/**
		 * Edit Page 
		 * @since v2.0
		 */
		protected function page_edit(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			if(!Main::validate_csrf_token($_POST["token"])) {
				Main::redirect("admin/page",array("error","Something went wrong, please try again."));
				return;
			}
			if(isset($_POST["content"]) && isset($_POST["id"])){
				if($this->db->update("page",array("name"=>"?","seo"=>"?","content"=>"?","menu"=>"?"),array("id"=>"?"),array($_POST["title"],Main::slug((!empty($_POST["seo"])?$_POST["seo"]:$_POST["title"])),$_POST["content"],$_POST["menu"],$_POST["id"]))){
					Main::redirect("admin/page?do=edit&id={$_POST["id"]}",array("success","This page has been successfully edited."));
				}					
			}
			Main::redirect("admin/page",array("error","Something went wrong, please try again."));		
			return;					
		}
		/**
		 * Delete Page 
		 * @since v2.0
		 */
		protected function page_delete(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			if(isset($_GET["id"]) && is_numeric($_GET["id"])){
				$this->db->delete("page",array("id"=>"?"),array($_GET["id"]));
				Main::redirect("admin/page",array("success","This page has been successfully deleted."));
			}					
		}		
		/**
		 * Generate Admin Settings page
		 * @since v2.1
		 */
		protected function setting(){
			if(isset($_GET["do"]) && in_array($_GET["do"], array("update","editor","theme","lang"))){	
				if($_GET["do"]=="update"){
					if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
					if(!Main::validate_csrf_token($_POST["token"])){
						Main::redirect("admin/setting",array("error","Something went wrong, please try again."));
						return;
					}	
					if(isset($_FILES["logo_path"]) && !empty($_FILES["logo_path"]["tmp_name"])) {
						$ext=array("image/png"=>"png","image/jpeg"=>"jpg","image/jpg"=>"jpg");						
						if(!isset($ext[$_FILES["logo_path"]["type"]])) return Main::redirect("admin/setting",array("error",e("Logo must be either a PNG or a JPEG.")));
						if($_FILES["logo_path"]["size"]>100*1024) return Main::redirect("admin/setting",array("error",e("Logo must be either a PNG or a JPEG (Max 200KB).")));						
						$_POST["logo"]="auto_site_logo.".$ext[$_FILES["logo_path"]["type"]];
						move_uploaded_file($_FILES["logo_path"]['tmp_name'], ROOT."/static/auto_site_logo.".$ext[$_FILES["logo_path"]["type"]]);								
					}						
					foreach($_POST as $config => $var){
						if(isset($this->config[$config])){
							$this->db->update("settings",array("var"=>addslashes($var)),array("config"=>$config));
						}
					}
					Main::redirect("admin/setting",array("success","Settings have been updated."));	
					return;				
				}else{
					$this->$_GET["do"]();
					return;
				}			
			}
			$this->out->config=$this->config;
			$this->config["email"]=($this->config["demo"])?"Hidden":$this->config["email"];
			$this->config["apikey"]=($this->config["demo"])?"Hidden":$this->config["apikey"];
			$this->config["captcha_public"]=($this->config["demo"])?"Hidden":$this->config["captcha_public"];
			$this->config["captcha_private"]=($this->config["demo"])?"Hidden":$this->config["captcha_private"];
			$this->config["facebook_secret"]=($this->config["demo"])?"Hidden":$this->config["facebook_secret"];
			$this->config["facebook_app_id"]=($this->config["demo"])?"Hidden":$this->config["facebook_app_id"];
			$this->config["twitter_key"]=($this->config["demo"])?"Hidden":$this->config["twitter_key"];
			$this->config["twitter_secret"]=($this->config["demo"])?"Hidden":$this->config["twitter_secret"];
			include(ROOT."/admin/system/settings.php");
			return;
		}
		/**
		 * Theme Editor
		 * @since v2.0
		 */
		protected function editor(){
			$list_of_allowed_files=array(
				"create",
				"custom_splash",
				"media",
				"email_template",
				"frame",
				"bundles",
				"login",
				"forgot",
				"register",
				"footer",
				"page",
				"splash",
				"private",
				"password",
				"profile",
				"header",
				"contact",
				"maintenance",
				"bundle_urls",
				"splash_alt",
				"menu",
				"user",
				"stats",
				"404",
				"index",
				"style");			
			if(isset($_POST["content"]) && in_array($_GET["file"], $list_of_allowed_files)){
				if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
				if(!Main::validate_csrf_token($_POST["token"])){
					Main::redirect("admin/setting?do=editor",array("error","Something went wrong, please try again."));
					return;
				}
				if($_GET["file"]=="style"){
					$file_path=TEMPLATE."/style.css";
				}else{
					$file_path=TEMPLATE."/{$_GET["file"]}.php";
				}
				if(file_exists($file_path)){
					$file = fopen($file_path, 'w') or die(Main::redirect("admin/setting?do=editor",array("error","Can't open file.")));
					fwrite($file, $_POST["content"]);
					fclose($file);
					Main::redirect("admin/setting?do=editor&file={$_GET["file"]}",array("success","File has been successfully edited."));
				}
				return;
			}
			$this->out->file=array();
			if(isset($_GET["file"]) && in_array($_GET["file"], $list_of_allowed_files) && $_GET["file"]!=="style"){
				$file=TEMPLATE."/{$_GET["file"]}.php";
				$this->out->content=htmlentities(file_get_contents($file));
				$this->out->name=$_GET["file"];
			}else{
				$file=TEMPLATE."/style.css";
				$this->out->content=htmlentities(file_get_contents($file));
				$this->out->name="style";
			}
			foreach (new RecursiveIteratorIterator(new RecursiveDirectoryIterator(TEMPLATE)) as $filename) { 
				$real_name=str_replace("/","",stripslashes(str_replace(".php","",str_replace(TEMPLATE,"",$filename))));
				if(Main::extension($filename)==".php" && in_array($real_name, $list_of_allowed_files)){
					$this->out->file[]=$real_name;
				}				
			}			
			include(ROOT."/admin/system/editor.php");
			return;
		}
		/**
		 * Choose Theme
		 * @since v2.0
		 */
		protected function theme(){		
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));			
			$this->out->themelist="";	
			if(isset($_GET["activate"])) {
				if(file_exists(ROOT."/themes/{$_GET["activate"]}/style.css")){					
					if($this->db->update("settings",array("var"=>"?"),array("config"=>"?"),array(Main::clean($_GET["activate"]),"theme"))){
						Main::redirect("admin/setting?do=theme",array("success","Theme has been activated."));
						return;
					}
				}else{
					$this->out->themelist.="<p class='message error'>Missing stylesheet (style.css). This theme cannot be activated. Please upload stylesheet.</p>";
				}
			}
			foreach (new RecursiveDirectoryIterator(ROOT."/themes/") as $path) { 
				if($path!=ROOT."/themes/." && $path!=ROOT."/themes/.." && is_dir($path)){
					$this->out->themelist.="<div class='theme-list'>";
					if(file_exists($path."/style.css")){
						$theme=str_replace("/","",stripslashes(str_replace("themes","",str_replace(ROOT,"",$path))));
						if(file_exists($path."/screenshot.jpg")){
							$this->out->themelist.="<img class='screen' width='100' height='80' src='{$this->config["url"]}/themes/$theme/screenshot.jpg'>";
						}
				    $data=token_get_all(file_get_contents($path."/style.css"));
				    $data=$data[0][1];
				    $this->out->themelist.="<div class='info'>";
    				if(preg_match("~Theme:\s(.*)~", $data,$name)){
    					$this->out->themelist.="<h3>".strip_tags(trim($name[1]))."";
    				}
    				$this->out->themelist.="<span class='right'>";
    				if(preg_match("~Author:\s(.*)~", $data,$author)){
    					$author=explode("-",$author[1]);
    					if(isset($author[0]) && isset($author[1])){
								$this->out->themelist.="Created by <a href='".strip_tags(trim($author[1]))."' class='button blue small' target='_blank'>".strip_tags(trim($author[0]))."</a> on ";
    					}    					
    				}
    				if(preg_match("~Date:\s(.*)~", $data,$date)){
							$this->out->themelist.=date("d M, Y",strtotime(trim(strip_tags($date[1]))));
    				}    				
    				$this->out->themelist.="</span></h3>";
    				if($this->config["theme"]==$theme){
    					$this->out->themelist.="<span class='strong'>Active</span>";
    					$this->out->themelist.="<a href='{$this->config["url"]}/admin/setting?do=editor' class='button green'>Edit Theme</a>";
    				}else{
    					$this->out->themelist.="<p><a href='{$this->config["url"]}/admin/setting?do=theme&activate=$theme' class='button small green'>Activate this theme</a></p>";
    				}
    				$this->out->themelist.="</div>";					
					}else{
						$this->out->themelist.="<p class='message error'>Missing stylesheet (style.css). This theme cannot be activated. Please upload stylesheet.</p>";
					}
					$this->out->themelist.="</div>";							
				}			
			}	
			include(ROOT."/admin/system/theme.php");
		}
		/**
		 * Language Editor
		 * @since v2.0
		 */	
		protected function lang($form=FALSE){
			if(isset($_GET["add"]) && isset($_POST["addlang"])){
				$this->lang_add();
				return;
			}
			if(isset($_POST["editlang"])){
				$this->lang_add("edited");
				return;
			}			
			if(isset($_GET["delete"]) && isset($_GET["file"])){
				$this->lang_delete();				
				return;
			}
			$path=ROOT."/includes/lang";
			$this->out->lang=array();
			$i=0;
			foreach (new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path)) as $filename) { 
				if(Main::extension($filename)==".php" && !preg_match("~lang_sample.php~", $filename)){
					$this->out->lang[$i]["lang"]="Unknown";
				  $data=token_get_all(file_get_contents($filename));
				  $data=$data[2][1];
  				if(preg_match("~Language:\s(.*)~", $data,$name)){
  					$this->out->lang[$i]["lang"]="".strip_tags(trim($name[1]))."";
  				}
  				if(preg_match("~Author:\s(.*)~", $data,$author)){	
  					$this->out->lang[$i]["author"]="".strip_tags(trim($author[1]))."";
  				}	
  				$this->out->lang[$i]["code"]=str_replace("/","",stripslashes(str_replace(".php","",str_replace(ROOT."/includes/lang", "", $filename))));
				}
				$i++;
			}			
			if($form) return $this->out->lang;
			include(ROOT."/admin/system/lang.php");
			return;
		}
		/**
		 * Add new Language
		 * @since v2.0
		 */			
		protected function lang_add($l="created"){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			if(!Main::validate_csrf_token($_POST["token"])){
				Main::redirect("admin/setting?do=lang",array("error","Something went wrong, please try again."));
				return;
			}			
			$file = substr(strtolower($_POST["language_name"]), 0, 2).".php";
			$handle = fopen(ROOT."/includes/lang/".$file, 'w') or Main::redirect("admin/setting?do=lang",array("error","Cannot create file. Make sure that the folder is writable."));
			$comment='<?php 
			/*
			 * Language: '.ucfirst($_POST["language_name"]).'
			 * ---------------------------------------------------------------
			 * Important Notice: Make sure to only change the right-hand side
			 * DO NOT CHANGE THE LEFT-HAND SIDE
			 * Edit the text between double-quotes "DONT EDIT"=> "" on the right side
			 * Make sure to not forget any quotes " and the comma , at the end
			 * ---------------------------------------------------------------
			 */
			$lang=array(';
			fwrite($handle, $comment);
			foreach ($_POST["text"] as $o => $t) {
				fwrite($handle, "\n\"".strip_tags($o,"<b><i><s><u><strong><a>")."\"".'=>'."\"".strip_tags($t,"<b><i><s><u><strong><a>")."\",");
			}
			fwrite($handle, "); ?>");
			fclose($handle);		
			Main::redirect("admin/setting?do=lang",array("success","Language file has been successfully $l."));
			return;
		}
		/**
		 * Delete Language
		 * @since v2.0
		 */		
		protected function lang_delete(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			$path=ROOT."/includes/lang/";
			if(!preg_match("~[.]~",$_GET["file"]) && file_exists($path.Main::clean($_GET["file"]).".php")){
				unlink($path.Main::clean($_GET["file"]).".php");
				Main::redirect("admin/setting?do=lang",array("success","Language file has been deleted."));
				return;
			}
			Main::redirect("admin/setting?do=lang",array("error","For some reason, this language file cannot be deleted."));
			return;
		}		
		/**
		 * Export User
		 * @since v2.0
		 */		
		protected function export(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
	  	header('Content-Type: text/csv');
		  header('Content-Disposition: attachment;filename=URL_Shortener_UserList.csv');
			$result = $this->db->get("user","",array("order"=>"id","all"=>1));
			echo "Username (empty=none), Email, Registration Date, Auth Method (empty=system)\n";
	    foreach ($result as $line) {
	     	echo "{$line["username"]},{$line["email"]},{$line["date"]},{$line["auth"]}\n";
	    }
	    return;
		}	
		/**
		 * Export User
		 * @since v3.0
		 */		
		protected function exporturls(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
	  	header('Content-Type: text/csv');
		  header('Content-Disposition: attachment;filename=URL_Shortener_URLList.csv');
			$result = $this->db->get("url","",array("order"=>"id","all"=>1));
			echo "Short URL, Long URL, Date, Clicks, User ID\n";
	    foreach ($result as $line) {
	     	echo "{$this->config["url"]}/{$line["alias"]}{$line["custom"]},{$line["url"]},{$line["date"]},{$line["click"]},{$line["click"]}\n";
	    }
	    return;
		}			
		/**
		 * In App Documentation
		 * @since v2.0
		 */
		protected function help(){
			if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));
			include(ROOT."/admin/system/help.php");
	    return;
		}			
		/**
		 * Generate Flot Data
		 * @since v2.0
		 */		
		public function chart($time=30){
			$var_url="";
			$var_user="";
			$var_click="";
			$date="";
			$timestamp = time();
			for ($i = 0 ; $i < $time ; $i++) {
			    $array[date('d M', $timestamp)]=0;
			    $timestamp -= 24 * 3600;
			}	
			$urls=$this->db->get(array("count"=>"COUNT(DATE(date)) as url_count,DATE(date) as url_date","table"=>"url"),"(date >= CURDATE( ) - INTERVAL $time DAY)",array("group"=>"DATE(date)","limit"=>30));
			if($urls){
				$new=array();	
				foreach ($urls as $data) {
					$new[date("d M",strtotime($data["url_date"]))]=$data["url_count"];
				}
				$i=0;				
				foreach ($array as $key => $value) {
					$i++;
					if(isset($new[$key])){
						$var_url.="[".($time-$i).", ".$new[$key]."], ";
						$date.="[".($time-$i).",\"$key\"], ";
					}else{
						$var_url.="[".($time-$i).", 0], ";
						$date.="[".($time-$i).", \"$key\"], ";
					}
				}		
			}					
			$users=$this->db->get(array("count"=>"COUNT(DATE(date)) as user_count,DATE(date) as user_date","table"=>"user"),"(date >= CURDATE( ) - INTERVAL $time DAY)",array("group"=>"DATE(date)","limit"=>30));
			if($users){
				$new=array();					
				foreach ($users as $data) {
					$new[date("d M",strtotime($data["user_date"]))]=$data["user_count"];
				}
				$i=0;				
				foreach ($array as $key => $value) {
					$i++;
					if(isset($new[$key])){
						$var_user.="[".($time-$i).", ".$new[$key]."], ";
						$date.="[".($time-$i).",\"$key\"], ";
					}else{
						$var_user.="[".($time-$i).", 0], ";
						$date.="[".($time-$i).", \"$key\"], ";
					}
				}					
			}
			if($this->config["tracking"]=="1"){
				$click=$this->db->get(array("count"=>"COUNT(DATE(date)) as click_count,DATE(date) as click_date","table"=>"stats"),"(date >= CURDATE( ) - INTERVAL $time DAY)",array("group"=>"DATE(date)","limit"=>30));
				if($click){
					$new=array();					
					foreach ($click as $data) {
						$new[date("d M",strtotime($data["click_date"]))]=$data["click_count"];
					}
					$i=0;				
					foreach ($array as $key => $value) {
						$i++;
						if(isset($new[$key])){
							$var_click.="[".($time-$i).", ".$new[$key]."], ";
							$date.="[".($time-$i).",\"$key\"], ";
						}else{
							$var_click.="[".($time-$i).", 0], ";
							$date.="[".($time-$i).", \"$key\"], ";
						}
					}							
				}
			}
			return "<script type='text/javascript'> 
								var data=[{
	      					label: \"Short URLs\",
	     						data: [$var_url]
							},{
						      label: \"Clicks\",
						      data: [$var_click]
							},{
						      label: \"Users\",
						      data: [$var_user]
							}];
							var xlabel=[$date];
							</script>
							";
		}
		/**
		 * Update Notification	
		 * @since v2.1 
		 */
		public function update_notification(){
			if($this->config["update_notification"] && !isset($_GET["action"])){
				if(ini_get('allow_url_fopen')){
					$c=file_get_contents("http://gempixel.com/update.php?p=".md5('shortener'));
					$c=json_decode($c,TRUE);
					if(isset($c["status"]) && $c["status"]=="ok"){
						if(_VERSION < $c["current_version"]){
							return "<div class='message note'>This script has been updated to version {$c["current_version"]}. Please download it from <a href='http://codecanyon.net/downloads' target='_blank' class='button green small'>CodeCanyon</a></div>";
						}
					}
				}
			}
		}		
		/**
		 * Stats Page
		 * @since v3.0
		 * @todo Optimize
		 */	
		public function stats($r){
			// if(empty($this->out->tmp)) $this->out->tmp=$this->db->count('stats');
			// if($this->out->tmp=="0") return "No Clicks";
			// if($r=="ref"){
			// 	$topref=$this->db->get(array("count"=>"referer AS referer, COUNT(referer) AS count","table"=>"stats"),"", array("order"=>'count','group' => "referer","limit"=>2));
			// 	$topref=$topref[0];
			// 	if($topref["referer"]=="direct") $topref["referer"]="Direct";
			// 	return "<a href='{$topref["referer"]}' target='_blank'>".Main::truncate($topref["referer"],70)."</a> (".round($topref["count"]/$this->out->tmp*100,1)."%)";
			// }
			// if($r=="country"){
			// 	$d=$this->db->get(array("count"=>"country AS country, COUNT(country) AS count","table"=>"stats"),"",array("order"=>'count',"limit"=>2,"group"=>"country"));				
			// 	if($d[0]["country"]=="-") $d[0]["country"]="Unknown";
			// 	return "{$d[0]["country"]} (".round($d[0]["count"]/$this->out->tmp*100,1)."%)";
			// }	
			// if($r=="social"){
			// 	$fb=$this->db->count("stats","referer REGEXP '(http://|https://|www.)+(facebook.)(.*)'");
			// 	$tw=$fb=$this->db->count("stats","referer REGEXP '(http://|https://|www.)+(twitter.)(.*)'");
			// 	return "Facebook (".round($fb/$this->out->tmp*100,3)."%) - Twitter (".round($tw/$this->out->tmp*100,3)."%)";
			// }				
		}
	/**
		* Delete Inactive URLs
		* @since v3.0
		*/		
	public function deleteinactiveurls($clicks='0',$days='30'){
		if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));		
		if(isset($_GET["token"]) AND $_GET["token"]==md5(date('YndH')."DeleteInactiveURL")){
			$this->db->delete('url',"click='$clicks' AND date<(CURDATE() - INTERVAL $days DAY)");
			Main::redirect("admin/setting",array("success","Inactive URLs have been removed from the database."));
			return;
		}else{
			Main::redirect("admin/setting",array("error","An error has occured."));
			return;			
		}		
	}	
	/**
		* Delete Inactive Users
		* @since v3.0
		*/		
	public function deleteinactiveusers(){
		if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));		
		if(isset($_GET["token"]) AND $_GET["token"]==md5(date('YndH')."DeleteInactiveUsers")){
			$this->db->delete('user',array("active"=>'0',"admin"=>'0'));
			Main::redirect("admin/setting",array("success","Inactive users have been removed from the database."));
			return;
		}else{
			Main::redirect("admin/setting",array("error","An error has occured."));
			return;			
		}		
	}				
	/**
		* Optimize Database
		* @since v3.0
		*/		
	public function optimize(){
		if(!$this->update) return Main::redirect("admin",array("error","Feature disabled in demo."));		
		$this->db->run("OPTIMIZE TABLE {$this->config["prefix"]}user");
		$this->db->run("OPTIMIZE TABLE {$this->config["prefix"]}url");
		$this->db->run("OPTIMIZE TABLE {$this->config["prefix"]}stats");
		$this->db->run("OPTIMIZE TABLE {$this->config["prefix"]}settings");
		$this->db->run("OPTIMIZE TABLE {$this->config["prefix"]}bundle");
		$this->db->run("OPTIMIZE TABLE {$this->config["prefix"]}page");
		Main::redirect("admin/setting",array("success","Database has been optimized."));
	}						 	
}
?>