<?php 
/**
 * ====================================================================================
 *                           PREMIUM URL SHORTENER (c) KBRmedia
 * ----------------------------------------------------------------------------------
 * @copyright This software is exclusively sold at CodeCanyon.net. If you have downloaded this
 *  from another site or received it from someone else than me, then you are engaged
 *  in an illegal activity. You must delete this software immediately or buy a proper
 *  license from http://gempixel.com/buy/short.
 *
 *  Thank you for your cooperation and don't hesitate to contact me if anything :)
 * ====================================================================================
 *
 * @author KBRmedia (http://gempixel.com)
 * @link http://gempixel.com 
 * @package Premium URL Shortener
 * @subpackage App Request Handler (App.class.php)
 */
class App{
	/**
	 * @var If you are using SSL (https), make sure to enable this (set it to TRUE)
	 * @since 2.1
	 */
	protected $ssl=FALSE;
	/**
	 * Reserved Script Actions
	 * @var array Each of these responds to the URL e.g. http://site.com/user will call the function user()
	 * @since 3.0
	 */
	protected $actions=array(
						"user", // Userpage
						"page", // Custom Pages
						"api", // API Calls
						"contact", // Contact Page
						"analytic", // Analytics Data
						"profile", // User Public Profile
						"bundles", // Logged User Bundles
						"bundle");	 // Public Bundle URLs

	// Don't edit anything below!
	protected $db, $config, $page=1; 
	protected $logged=FALSE, $admin=FALSE, $show_ads=1, $user_domain="",$splash=0;
	protected $logged_id=0;
	public $isHome=FALSE, $is404=FALSE, $lang="en";

	public function __construct($db,$config){
		$this->db=$db;
		$this->config=$config;
		
    $_GET=array_map("Main::clean", $_GET);
    if(isset($_GET["page"]) && is_numeric($_GET["page"]) && $_GET["page"]>0) $this->page=Main::clean($_GET["page"]);		    
    $this->check();
	}
  public function __destruct(){
		unset($this->db,$this->config, $this->user);
	}
	/**
	 * Return Variables
	 * @since v2.0
	 */	
	public function logged(){
		return $this->logged;
	}	
	public function admin(){
		return $this->admin;
	}		
	/**
	 * Run Application
	 * @since v3.0
	 */
	public function run(){
		// Show Homepage
		if(empty($_GET["action"])){
			$this->home();
			return;
		}
		// Show Other Pages
		if(isset($_GET["action"]) && !empty($_GET["action"]) && in_array($_GET["action"], $this->actions) && method_exists("App", $_GET["action"])){			
			$this->{$_GET["action"]}();
			return;
		}elseif($_GET["action"]=="api"){
			// Run API
			require("Short.class.php");  
  		$short = new Short($this->db,$this->config);  			
			$short->api();
			return;
		}else{
			// Redirect
			require("Short.class.php");  
  		$short = new Short($this->db,$this->config);  			
			$short->redirect();
			return;
		}
		// Show 404
		$this->_404();
		return;
	}
	/**
	 * Check if user is authenticated
	 * @since v2.1
	 */
	public function check(){				
		if($info=Main::user()){
			if($user=$this->db->get("user",array("id"=>"?","password"=>"?"),array("limit"=>1),array($info[0],$info[1]))){
				if($user["banned"] || !$user["active"]) {
					$this->logout(FALSE);
					if($user["banned"]){
						Main::redirect("user/login",array("error",e("You have been banned due to abuse. Please contact us for clarification.")));
						exit;					
					}
					if(!$user["active"]){
						Main::redirect("user/login",array("error",e("You haven't activated your account. Please check your email for the activation link. If you haven't received any emails from us, please contact us.")));
						exit;				
					}
				}
				if($user["admin"]=="1"){
					$this->admin=TRUE;
				}				
				$this->logged=TRUE;				
				$this->logged_id=$user["id"];
				$this->show_ads=$user["ads"];
				$this->user_domain=$user["domain"];
				$this->splash=$user["splash_opt"];
				$user=NULL;
			}
		}
		return FALSE;
	}	
	/**
	 * Login Template
	 * @since v2.0
	 */	
	protected function login(){
		if(isset($_POST["email"]) && isset($_POST["password"]) && !$this->logged){
			$this->user_login();
			return;					
		}				
		// Set meta info
		Main::set("title",e("Login to your account"));
		Main::set("description","Login to your account and bookmark your favorite sites.");		
		Main::set("url","{$this->config["url"]}/user/login");	
		include(TEMPLATE."/header.php"); 
		include(TEMPLATE."/login.php");
		include(TEMPLATE."/footer.php"); 	

	}
	/**
	 * Login User
	 * @since v2.0
	 */	
	protected function user_login($auth=FALSE,$array=array()){
		if($auth){
			if($auth=="facebook"){
				$user=$this->db->get("user",array("email"=>"?","auth"=>"?"),array("limit"=>1),array($array["email"],"facebook"));
			}elseif($auth=="twitter"){
				$user=$this->db->get("user",array("auth_id"=>"?","auth"=>"?"),array("limit"=>1),array($array["id"],"twitter"));
			}
		}else{
			$error="";
			if(!Main::validate_csrf_token($_POST["token"])){
				Main::redirect("user/login",array("error",e("Something went wrong, please try again.")));
				return;			
			}
			if(empty($_POST["email"])) $error.="<span>".e("Please enter a valid email.")."</span>";
			if(empty($_POST["password"]) || strlen($_POST["password"])<3) $error.="<span>".e("Please enter a valid password.")."</span>";
			if(!empty($error)){
				Main::redirect("user/login",array("error",$error));
				return;
			}
			$user=$this->db->get("user","(email=:id OR username=:id) AND password=:pass",array("limit"=>1),array(":id"=>Main::clean($_POST["email"]),":pass"=>Main::encode($this->config["secret_key"].Main::clean($_POST["password"],3,FALSE))));
		}
		if($user){
			if($user["banned"]){
				Main::redirect("user/login",array("error",e("You have been banned due to abuse. Please contact us for clarification.")));
				return;					
			}
			if(!$user["active"]){
				Main::redirect("user/login",array("error",e("You haven't activated your account. Please check your email for the activation link. If you haven't received any emails from us, please contact us.")));
				return;						
			}
			$json=base64_encode(json_encode(array("loggedin"=>TRUE,"key"=>$user["password"].$user["id"].'_$P$5648')));
			if(isset($_POST["rememberme"]) && $_POST["rememberme"]=="1"){
				setcookie("login",$json, time()+60*60*24*5, "/","",FALSE,TRUE);
			}else{
				$_SESSION["login"]=$json;
			}
			Main::redirect("user/",array("success",e("You have been successfully logged in.")));
			return;				
		}else{
			Main::redirect("user/login",array("error",e("Wrong email and password combination.")));
			return;			
		}
	}	
	/**
	 * Auth Social User
	 * @since v2.0
	 */		
	public function auth($auth,$array=array()){
    if($auth=="facebook"){
			$user_info=$this->db->get("user",array("email"=>"?"),array("limit"=>1),array($array["email"]));
			if(isset($array["username"]) && !empty($array["username"])){
				if($user=$this->db->get("user",array("username"=>"?"),array("limit"=>1),array($array["username"]))){
					$array["username"]=$array["username"].rand(0,10);
				}
			}
      if($user_info && empty($user_info["auth"])) {
        Main:: redirect("",array("error",e("The email that this facebook account is using is already registered.")));
      }
      if(!$this->db->get("user",array("email"=>"?","auth"=>"?"),array("limit"=>1),array($array["email"],"facebook"))){
        $this->user_register('facebook',$array);
        $this->user_login('facebook',$array);  
      }else{
        $this->user_login('facebook',$array);
      }        	
    }elseif($auth="twitter"){
      if(!$this->db->get("user",array("auth_id"=>"?","auth"=>"?"),array("limit"=>1),array($array["id"],"twitter"))){
        $this->user_register('twitter',$array);
        $this->user_login('twitter',$array);  
      }else{
        $this->user_login('twitter',$array);
      }     	
    }
    return;
	}
	/**
	 * Logout User
	 * @since v2.1
	 */
	public function logout($redirect=TRUE){
		if(isset($_COOKIE["login"])) setcookie('login','',time()-3600,'/');
		if(isset($_SESSION["login"])) unset($_SESSION["login"]);
		if($redirect) Main::redirect("",array("success",e("You have been logged out. See you later!")));
		return TRUE;
	}	
	/**
	 * Retrieve Password Template
	 * @since v2.1
	 */	
	public function forgot($ok=FALSE){
		if(isset($_POST["event"]) && $_POST["event"]=="send_password"){
			$this->send_password();
			return;
		}										
		if(isset($_GET["token"])){	
			if(isset($_POST["event"]) && $_POST["event"]=="change_password"){				
				$this->change_password();
				return;
			}							
      $i=array(substr($_GET["token"], 0, 12),substr($_GET["token"], 12));
      if(isset($i[0]) && isset($i[1]) && md5($this->config["secret_key"].": Expires on".strtotime(date('Y-m-d')))==$i[1]) {
      	$_SESSION["time_token"]=$i[0];	
				$ok=TRUE;	      			      	
      }else{
       	Main::redirect("user/forgot",array("error",e("Link has expired. You can request a new link below.")));
       	return;
      }
		}		
		Main::set("title",e("Reset your password"));
		Main::set("description","If you have forgotten your password, you can easily restore it.");		
		Main::set("url","{$this->config["url"]}/user/forgot");	
		include(TEMPLATE."/header.php"); 
		include(TEMPLATE."/forgot.php");
		include(TEMPLATE."/footer.php"); 			
	}
	protected function change_password(){
		if(!Main::validate_csrf_token($_POST["token"])){
			Main::redirect("user/forgot?token={$_GET["token"]}",array("error",e("Something went wrong, please try again.")));	
			return;
		}
		if(empty($_POST["password"]) || strlen($_POST["password"])<5){
			Main::redirect("user/forgot?token={$_GET["token"]}",array("error",e("Password must be at least 5 characters.")));
				return;
		}else{
			if($_POST["password"]!=$_POST["cpassword"]){
				Main::redirect("user/forgot?token={$_GET["token"]}",array("error",e("Passwords don't match.")));
				return;	
			}
		}	
		$this->db->update("user",array("password"=>"?"),array("api"=>"?"),array(Main::encode($this->config["secret_key"].strip_tags($_POST["password"])),$_SESSION["time_token"]));
			Main::redirect("user/login",array("success",e("Your password has been successfully changed. You may now login.")));
			return;				
		return;
	}
	/**
	 * Activate User
	 * @since v2.1.1
	 */		
	protected function activate(){
		if(isset($_GET["email"]) && isset($_GET["key"])){
			$key=str_replace("P1U2","",Main::clean($_GET["key"]));
				if($user=$this->db->get("user",array("email"=>"?","api"=>"?"),array("limit"=>1),array(Main::clean($_GET["email"]),$key))){
					if($user["active"]=="1"){
						Main::redirect("user/login",array("error","Your account has already been activated."));		
						return;
					}
					$this->db->update("user",array("active"=>"1"),array("id"=>$user["id"]));
					Main::redirect("user/login",array("success","Your account has been activated you may now login."));
					return;
				}
		}
		Main::redirect("contact",array("error","Activation key is invalid. Please contact us."));		
		return;
	}
	/**
	 * Retrieve Password
	 * @since v2.0
	 */	
	protected function send_password(){
		if(!Main::validate_csrf_token($_POST["token"])){
			Main::redirect("user/forgot",array("error",e("Something went wrong, please try again.")));
			return;			
		}
		if(empty($_POST["email"])) {
			Main::redirect("user/forgot",array("error",e("Please enter a valid email.")));
			return;				
		}
		if(!$user=$this->db->get("user",array("email"=>"?"),array("limit"=>1),array($_POST["email"]))){
			Main::redirect("user/forgot",array("error",e("Please enter a valid email.")));
			return;				
		}
		$forgot_url=$this->config["url"]."/user/forgot/?token=".$user["api"].md5($this->config["secret_key"]."Expires on".strtotime(date('Y-m-d')));  
 		$var["to"] = Main::clean($_POST["email"]);
    $var["subject"] = "[{$this->config["title"]}] Password Reset Instructions";
		$var["message"] = "
      <p><b>A request to reset your password was made.</b> If you <b>didn't</b> make this request, please ignore and delete this email otherwise click the link below to reset your password.</p>
      <a href='$forgot_url' class='link'><b>Click here to reset your password.</b></a>
      <p>If you cannot click on the link above, simply copy &amp; paste the following link into your browser.</p>
      <a href='$forgot_url' class='link'>$forgot_url</a>
      <p><b>Note: This link is only valid for one day. If it expires, you can request another one.</b></p>";		
      Main::send($var);
			Main::redirect("user/forgot",array("success",e("Please check your email for further instructions.")));
			return;	      
		return;
	}	
	/**
	 * Register Template
	 * @since v2.0
	 */	
	protected function register(){
		// Check if under maintenance
		if($this->config["maintenance"] && !$this->admin()) {
			$this->_maintenance();
			exit;
		}							
		if($this->config["private"]){
			Main::redirect("");
			return;
		}
		if(isset($_POST["event"]) && $_POST["event"]=="user_register"){
			$this->user_register();
			return;
		}
		Main::set("title",e("Register and start bookmarking"));
		Main::set("description","Register an account and easily bookmark your favorite sites and share them with your friends.");		
		Main::set("url","{$this->config["url"]}/user/register");	
		include(TEMPLATE."/header.php");
		include(TEMPLATE."/register.php");
		include(TEMPLATE."/footer.php");
	}	
	/**
	 * Register User
	 * @since v2.0
	 */	
	protected function user_register($auth_type="",$array=array()){
		$unique=FALSE;
		while (!$unique) {
			$api=Main::api();
			if(!$this->db->get("user",array("api"=>$api),array("limit"=>1))) $unique=TRUE;
		}
		if($auth_type=="facebook"){
			$key=array(
			"email" => "?",
			"username" => "?",
			"password" => "?",
			"api"	=> "?",
			"date" => "NOW()",
			"auth"=>"?",
			"auth_id"=>"?"
			);	
			$values=array(Main::clean($array["email"]),(isset($array["username"])?Main::clean($array["username"]):""),Main::encode($this->config["secret_key"].$array["email"]),$api,"facebook",$array["id"]);
		}elseif($auth_type=="twitter"){
			$key=array(
				"username" => "?",				
				"password" => "?",
				"api"	=> "?",
				"date" => "NOW()",
				"auth"=>"?",
				"auth_id"=> "?"
			);	
			$values=array(Main::clean($array["username"]),Main::clean(Main::encode($this->config["secret_key"].$array["id"])),$api,"twitter",$array["id"]);			
		}else{		
			$error="";
			if(!Main::validate_csrf_token($_POST["token"])){
				Main::redirect("user/register",array("error",e("Something went wrong, please try again.")));
				return;			
			}

			if(empty($_POST["email"]) || !Main::email($_POST["email"])) $error.="<span>".e("Please enter a valid email.")."</span>";
			elseif($this->db->get("user",array("email"=>"?"),array("limit"=>1),array($_POST["email"]))) $error.="<span>".e("An account is already associated with this email.")."</span>";

			if(!empty($_POST["username"])){
				if(strlen($_POST["username"])<3) $error.="<span>".e("Username must contain at least 3 characters")."</span>";
				elseif($this->db->get("user",array("username"=>"?"),array("limit"=>1),array($_POST["username"]))) $error.="<span>".e("An account is already associated with this username.")."</span>";			
			} 

			if(empty($_POST["password"]) || strlen($_POST["password"])<3) $error.="<span>".e("Password must be at least 4 characters.")."</span>";
			if($_POST["password"]!=$_POST["cpassword"]) $error.="<span>".e("Passwords don't match.")."</span>";
			
			// Check Captcha
			if($this->config["captcha"]){
				$captcha=Main::check_captcha($_POST);
				if($captcha!='ok'){
					$error.=$captcha;
				}
			}	
			if(!isset($_POST["terms"]) OR $_POST["terms"]!=1) $error.="<span>".e("You must agree to the terms and conditions.")."</span>";

			if(!empty($error)){
				Main::redirect("user/register",array("error",$error));
				return;
			}
			$status="1";
			if($this->config["user_activate"]) $status="0";
			$key=array(
				"email" => "?",		
				"username" => "?",		
				"password" => "?",
				"api"	=> "?",
				"date" => "NOW()",
				"active" => "?"
			);	
			$values=array(Main::clean($_POST["email"]),Main::clean(preg_replace('/\s+/', '', $_POST["username"])),Main::encode($this->config["secret_key"].Main::clean($_POST["password"])),$api,$status);				
		}		
		if($this->db->insert("user",$key,$values)){
			if(empty($auth_type)){
				$array["to"]=Main::clean($_POST["email"]);
		    $array["subject"] = "[{$this->config["title"]}] Registration has been successful";
		    if($this->config["user_activate"] && empty($auth_type)){
		    	$activate="{$this->config["url"]}/user/activate?email={$array["to"]}&key=P1U2{$api}";
					$array["message"] = "
		      	<b>Hello ".Main::clean(preg_replace('/\s+/', '', $_POST["username"]))."</b>
		      	<p>You have been successfully registered at {$this->config["title"]}. To login you will have to activate your account by clicking the URL below.</p>
		      	<p><a href='$activate'>$activate</a></p>
		     	";
		    }else{
					$array["message"] = "
		      	<b>Hello</b>
		      	<p>You have been successfully registered at {$this->config["title"]}. You may now login and enjoy our URL shortener.</p>
		     	";		    	
		    }
		    $mail=Main::send($array);
		    if($mail!==TRUE){
					error_log($mail);
		    }	    	
		    $message=($this->config["user_activate"])?"Please check your email for an activation link":"You may now login";
				Main::redirect("user/login",array("success",e("Congratulations! You have been successfully registered. $message.")));		    			    	
				return;		    
			}
		}
	}	
	/**
	 * Generate Home Page
	 * @since v2.0
	 */
	public function home(){		
		// Check if private
		if($this->config["private"] && !$this->logged()) {
			$this->_private();
			return;
		}	  			
		// Check if under maintenance
		if($this->config["maintenance"] && !$this->admin()) {
			$this->_maintenance();
			return;
		}
		if(isset($_GET["bookmark"])) {			
			$this->bookmark();
			exit;
		}			
		$this->isHome=TRUE;
  	Main::add($this->config["url"]."/static/zclip.js","script",FALSE);
  	Main::add("<script type='text/javascript'>$('#domains').dropkick();</script>","custom",TRUE);
  	Main::add("<script type='text/javascript'>$('#domains2').dropkick();</script>","custom",TRUE);
		include(TEMPLATE."/header.php"); 
		include(TEMPLATE."/index.php");
	 	include(TEMPLATE."/footer.php"); 		
	}
	/**
	 * Shorten URL using bookmarklet
	 * @since v3.0
	 */
	protected function bookmark(){
		if(Main::bot()) return FALSE;
		require(ROOT."/includes/Short.class.php");  
		$short = new Short($this->db,$this->config);  			
		$short=$short->add(array("url"=>$_GET["url"]));		
		if(isset($_GET["callback"])){
			header("Content-type: application/javascript");
			echo "{$_GET["callback"]}(".json_encode($short).")";
			exit;
		}
		if($short["error"]){
			Main::redirect("?url={$_GET["url"]}",array("error",$short["msg"]));
			return;			
		}else{
			Main::redirect($short["short"]."+",array("success",e("URL has been successfully shortened")),"",TRUE);
			return;
		}
		return;	
	}
	/**
	 * Generate user account page
	 * @since v3.0
	 */
	protected function user(){
		// Logged in actions
		if($this->logged===TRUE && $this->logged_id){
			// Check if under maintenance
			if($this->config["maintenance"] && !$this->admin()) {
				$this->_maintenance();
				return;
			}
			$this->run_logged();
		}else{
			$this->run_unlogged();
		}				
		$this->user_dashboard();
	}
/**
	 * Generate user dashboard
	 * @since v3.0
	 */
	protected function user_dashboard($limit=15,$archive=0){
		if($user=$this->db->get("user",array("id"=>"?"),array("limit"=>"1"),array($this->logged_id))){
			if($user["auth"]=="facebook" && !empty($user["auth_id"])){
				$user["avatar"]=(($this->ssl)?"https://":"http://")."graph.facebook.com/".$user["auth_id"]."/picture?type=large";
			}else{
				$user["avatar"]=(($this->ssl)?"https://":"http://")."www.gravatar.com/avatar/".md5(trim($user["email"]))."?s=80";
			}
			$user["breadcrumb"]="";
			$user["username"]=empty($user["username"])?e("Not specified"):ucfirst($user["username"]);
			$user["url_count"]=$this->db->count("url","userid={$this->logged_id}");
			$user["bundle_count"]=$this->db->count("bundle","userid={$this->logged_id}");
			$user["clicks_count"]=$this->db->count("url","userid={$this->logged_id}","click");
			$user["new_urls"] = array();		

			if(empty($this->user_domain)) $this->user_domain=$this->config["url"];

			$order=array("date",FALSE,"newest");
			if(isset($_GET["sort"])){
				if(Main::clean($_GET["sort"],3,TRUE)=="popular"){
					$order=array("click",FALSE,"popular");
				}elseif(Main::clean($_GET["sort"],3,TRUE)=="oldest"){
					$order=array("date",TRUE,"oldest");
				}
			}
			if($data=$this->db->get("url",array("userid"=>$user["id"],"archived"=>$archive),array("order"=>$order[0],"limit"=>(($this->page-1)*$limit).", $limit","count"=>TRUE,"asc"=>$order[1]))){
				$user["new_urls"]=$data;
			}									
			if(($this->db->rowCount%$limit)<>0) {
				$max=floor($this->db->rowCount/$limit)+1;
			} else {
				$max=floor($this->db->rowCount/$limit);
			}		
			$user["pagination"]=Main::pagination($max, $this->page, $this->config["url"]."/user?page=%d&sort={$order[2]}");	
  		Main::add("<script type='text/javascript'>$('#filter').dropkick({change: function (value) {location.href=appurl+'/user/?sort='+value;}});</script>","custom");
			Main::set("title",e("User Account"));
			Main::set("description","Manage your urls, share them or delete them.");
			Main::set("url","{$this->config["url"]}/user/");			
			include(TEMPLATE."/header.php"); 
			include(TEMPLATE."/user.php");	
			include(TEMPLATE."/footer.php"); 		
			$user=NULL;
		}		
	}
	/**
	 * Run Logged Actions
	 * @since v3.0
	 */
	private function run_logged(){
		// User Actions
		$actions=array("bundles","logout","settings","create","disable_ads","verify","archive","statistics","export","unlock_splash");

		if(isset($_GET["do"])){
			if($_GET["do"]=="bundles" && isset($_GET["delete"]) && is_numeric($_GET["delete"])){
				$this->bundle_delete();
				exit;		
			}			
			if(in_array($_GET["do"], $actions)){
				$this->{$_GET["do"]}();
				exit;
			}
			$this->_404();
			exit;
		}		
		// User Events
		$events = array(
			"mass-delete"=>"url_delete_all",
			"delete"=>"url_delete",
			"updateuser"=>"user_update",
			"bundle_create"=>"bundle_create",
			"bundle_update"=>"bundle_edit",
			"updateurl"=>"url_update",
			"url_bundle_add"=>"url_bundle_add"
		);
		if(isset($_REQUEST["event"]) && isset($events[$_REQUEST["event"]])){				
			$this->{$events[$_REQUEST["event"]]}();
			exit;
		}													
	}
	/**
	 * Run Logged Actions
	 * @since v3.0
	 */
	private function run_unlogged(){
		// Switch Actions
		if(isset($_GET["do"])){			
			$actions = array(
				"activate"=>"activate",
				"register"=>"register",
				"forgot"=>"forgot",
				"login"=>"login"
			);
			if(isset($_GET["do"]) && isset($actions[$_GET["do"]])){
				$this->{$actions[$_GET["do"]]}();
				exit;
			}									
		}
		Main::redirect('user/login');
		exit;
	}	
	/**
	 * Delete URL + everything attached
	 * @since v2.0		 
	 */		
	public function user_edit(){
	 if($user=$this->db->get("user",array("id"=>"?"),array("limit"=>1),array($this->logged_id))){
	 	echo '
		<form action="'.$this->config["url"].'/user" method="post" class="form">
				<div class="row">
					<div class="grid fifth">
						<a href="'.(($this->ssl)?"https://":"http://").'gravatar.com" target="_blank"><img src="'.(($this->ssl)?"https://":"http://").'www.gravatar.com/avatar/'.md5(trim($user["email"])).'?s=64" alt=""></a>
					</div>
					<div class="grid fourfifth">
					'.e("If you have a Gravatar, we will use your email to grab your Gravatar and display it. Click on the your avatar to change it and make sure to use the same email.").'
					</div>
				</div>
				<label>'.e("Email").' ('.e("required").')</label>			
				<input type="text" value="'.$user["email"].'" name="email" class="input" />

				<label>'.e("Username").' ('.e("optional").')</label>			
				<input type="text" value="'.$user["username"].'" name="username" class="input"'.(empty($user["username"])?"":" disabled").'/>

				<label>'.e("Password").' ('.e("leave blank to keep current one").')</label>
				<input type="password" value="" name="password" class="input" />

				<label>'.e("Confirm Password").'</label>
				<input type="password" value="" name="cpassword" class="input" />
				<ul class="form_opt" data-id="public">
					<li class="label">'.e("Profile Access").'
					<small>'.e("Everyone would access your profile including URLs and bundles. Username is required.").'</small>
					</li>
					<li><a href="" class="last'.(!$user["public"]?" current":"").'" data-value="0">'.e("Private").'</a></li>
					<li><a href="" class="first'.($user["public"]?" current":"").'" data-value="1">'.e("Public").'</a></li>
				</ul>
				<input type="hidden" name="public" id="public" value="'.$user["public"].'">				

				<input type="hidden" name="id" value="'.$user["id"].'">
				<input type="hidden" name="event" value="updateuser">	
				'.Main::csrf_token(TRUE).'
				<button type="submit" class="button">'.e("Update").'</button>							
		</form>';
	 }		
		return;
	}
	/**
	 * Edit user
	 * @since v2.0
	 */			
	protected function user_update(){
		if($this->config["demo"]){
			Main::redirect("user/settings",array("error",e("Feature disabled in demo.")));
			return;
		}
		if(!Main::validate_csrf_token($_POST["token"])) {
			Main::redirect("user/settings",array("error",e("Something went wrong, please try again.")));
			return;
		}
		$error="";
		$user=$this->db->get("user",array("id"=>"?"),array("limit"=>1),array($_POST["id"]));
		if($user["auth"]!="twitter" && (empty($_POST["email"]) || !Main::email($_POST["email"]))){
			$error.="<span>".e("Please enter a valid email.")."</span>";
		}
		if($_POST["email"]!==$user["email"]){
			if($this->db->get("user",array("email"=>"?"),array("limit"=>1),array($_POST["email"]))){
				$error.="<span>".e("An account is already associated with this email.")."</span>";
			}
		}	
		$array_key["email"]="?";
		$array_value[]=$_POST["email"];

		if(!empty($_POST["username"]) && empty($user["username"]) && $_POST["username"]!==$user["username"]){
			if($this->db->get("user",array("username"=>"?"),array("limit"=>1),array($_POST["username"]))){
				$error.="<span>".e("This username has already been used. Please try again.");
			}
			$array_key["username"]="?";
			$array_value[]=$_POST["username"];
		}		
		
		if(!empty($_POST["password"])){
			if(strlen($_POST["password"])<5){
				$error.="<span>".e("Password has to be at least 6 characters.")."</span>";			
			}
			if(empty($_POST["cpassword"]) || $_POST["cpassword"]!=$_POST["password"]){
				$error.="<span>".e("Passwords don't match.")."</span>";				
			}
			$array_key["password"]="?";
			$array_value[]=Main::encode($_POST["password"].$_POST["password"]);			
		}	
		if(isset($_POST["public"]) && is_numeric($_POST["public"]) && $_POST["public"]>=0 && $_POST["public"]<=1){
			$array_key["public"]="?";
			$array_value[]=Main::clean($_POST["public"]);
		}		
		if(isset($_POST["media"]) && is_numeric($_POST["media"]) && $_POST["media"]>=0 && $_POST["media"]<=1){
			$array_key["media"]="?";
			$array_value[]=Main::clean($_POST["media"]);
		}		
		if(isset($_POST["splash_opt"]) && is_numeric($_POST["splash_opt"]) && $_POST["splash_opt"]>=0 && $_POST["splash_opt"]<=1 && empty($this->config["custom_splash_amount"])){
			$array_key["splash_opt"]="?";
			$array_value[]=Main::clean($_POST["splash_opt"]);
		}				
		if(isset($_POST["domain"]) && !empty($_POST["domain"]) && $this->validate_domain_names($_POST["domain"])){
			$array_key["domain"]="?";
			$array_value[]=Main::clean($_POST["domain"]);
		}

		if(!empty($error)) {
			Main::redirect("user",array("error",$error));
			return;
		}
		$array_value[]=$this->logged_id;
		if($this->db->update("user",$array_key,array("id"=>"?"),$array_value)){
			Main::redirect("user/settings",array("success",e("Account has been successfully updated.")));
			return;
		}			
	}		
	/**
	 * URL Edit
	 * @since v2.0
	 */
	public function url_edit(){
		if($url=$this->db->get("url",array("id"=>"?","userid"=>"?"),array("limit"=>1),array($_POST["id"],$this->logged_id))){
			echo '
				<form action="'.$this->config["url"].'/user" method="post" class="form">
					<ul class="form_opt" data-id="access">
						<li class="label">'.e("URL Access").'
						<small>'.e("If you set it to private, only you can access the URLs").'.</small>
						</li>
						<li><a href="#" class="last'.(!$url["public"]?" current":"").'" data-value="0">'.e("Private").'</a></li>
						<li><a href="#" class="first'.($url["public"]?" current":"").'" data-value="1">'.e("Public").'</a></li>
					</ul>
					<input type="hidden" name="access" id="access" value="'.$url["public"].'">					
					<label>'.e("Long URL").' ('.e("required").')</label>			
					<input type="text" value="'.$url["url"].'"" name="url" class="input" />

					<label>'.e("Note").' ('.e("optional").')</label>			
					<input type="text" value="'.$url["description"].'"" name="description" class="input" />
					<br class="clear">
					<h2>'.e("Geotargeting Data").' <a href="#user" class="button small right add_geo">'.e("Add a Field").'</a></h2>
						<div id="geo">';
						if(!empty($url["location"])){
							$geo=json_decode($url["location"],TRUE);
							foreach ($geo as $country => $u){
								echo '<div class="block">
									<h3>'.e("Geotargeting data for").' '.ucwords($country).' <a href="#" class="button red right small delete_geo">'.e("Delete").'</a></h3>
									<label>'.e("Country").'</label>
									<input type="text" name="location[]" value="'.ucwords($country).'" class="input country" />

									<label>'.e("URL").'</label>
									<input type="text" name="target[]" value="'.$u.'" class="input" />
								</div><!-- /.block -->';
							}
						}
					echo '</div>
					<input type="hidden" name="id" value="'.$url["id"].'">
					<input type="hidden" name="event" value="updateurl">	
					'.Main::csrf_token(TRUE).'
					<button type="submit" class="button">'.e("Update").'</button>							
				</form>';
		}		
		return;		
	}
	/**
	 * URL Update
	 * @since v2.0
	 */
	protected function url_update(){
		if($this->config["demo"]){
			Main::redirect("user",array("error",e("Feature disabled in demo.")));
			return;
		}		
		if(!Main::validate_csrf_token($_POST["token"])) {
			Main::redirect("user",array("error",e("Something went wrong, please try again.")));
			return;
		}
		if(!empty($_POST['location'][0]) && !empty($_POST['target'][0])){
				foreach ($_POST['location'] as $i => $country) {
					if(!empty($country)){
						$countries[strtolower(Main::clean($country))]=$_POST['target'][$i];
				  }
				}
				$countries=json_encode($countries);
			}else{
				$countries='';
			}	
			if($this->db->update("url",array("url"=>"?","description"=>"?","location"=>"?","public"=>"?"),array("id"=>"?", "userid"=>"?"),array(Main::clean($_POST["url"]),Main::clean($_POST["description"]),$countries,Main::clean($_POST["access"]),Main::clean($_POST["id"]),$this->logged_id))){
				Main::redirect("user",array("success","This URL has been successfully updated."));
				return;
			}
			Main::redirect("admin",array("error","This url doesn't exist."));
			return;
	}	
	/**
	 * URL Delete
	 * @since v2.0
	 */
	protected function url_delete($id=NULL){		
		if(isset($_GET["id"]) && is_numeric($_GET["id"]) && is_null($id)){
			$deleteid=$_GET["id"];
		}elseif(!is_null($id)){
			$deleteid=$id;
		}else{
			Main::redirect("user",array("error",e("That action cannot be completed.")));
			return;
		}
		$url=$this->db->get("url",array("id"=>"?","userid"=>"?"),array("limit"=>1),array($deleteid,$this->logged_id));
		$this->db->delete("url",array("id"=>"?","userid"=>"?"),array($deleteid,$this->logged_id));
		$this->db->delete("stats",array("short"=>"?"),array($url["alias"]));
		if(is_null($id)) Main::redirect("user",array("success",e("This url and associated stats have been successfully deleted.")));	
		return;
	}		
	/**
	 * Delete URL all
	 * @since v2.0
	 */
	protected function url_delete_all(){
		if(!Main::validate_csrf_token($_POST["token"])){
			Main::redirect("user",array("error",e("Something went wrong, please try again.")));
			return;
		}			
		if(isset($_POST["delete-id"]) && is_array($_POST["delete-id"]) && !empty($_POST["delete-id"])){
			foreach($_POST["delete-id"] as $id){
				if(is_numeric($id)){
					$this->url_delete($id);
				}
			}				
			Main::redirect("user",array("success",e("Selected URLs have beed deleted.")));
			return;
		}else{
			Main::redirect("user");
			return;
		}
	}
	/**
	 * URL Archive 
	 * @since v3.0
	 */
	public function url_archive(){		
		if($this->db->update("url",array("archived"=>"?"),array("id"=>"?","userid"=>"?"),array("1",Main::clean($_POST["id"],3),$this->logged_id))){
			echo "<p class='message success'>".e("URL successfully archived.")."</div>";
			echo "<script type='text/javascript'>$('#url-container-".Main::clean($_POST["id"],3)."').fadeOut('slow');</script>";
		}
	}
	/**
	 * URL Unrchive 
	 * @since v3.0
	 */
	public function url_unarchive(){
		if($this->db->update("url",array("archived"=>"?"),array("id"=>"?","userid"=>"?"),array("0",Main::clean($_POST["id"],3),$this->logged_id))){
			echo "<p class='message success'>".e("URL successfully unarchived.")."</div>";
			echo "<script type='text/javascript'>$('#url-container-".Main::clean($_POST["id"],3)."').fadeOut('slow');</script>";
		}
	}	
	/**
	 * Archive URLs
	 * @since v3.0
	 */
	public function archive(){
		return $this->user_dashboard(15,1);
	}
	/**
	 * Search URLs
	 * @since v3.0
	 */	
	public function search($custom_template="",$limit=10){
		$q=Main::clean($_POST["q"],3);
		if(!empty($q) && strlen($q)>=3){
			if($urls=$this->db->search("url",array(array("userid",$this->logged_id),"url"=>":q","alias"=>":q","custom"=>":q","meta_title"=>":q","description"=>":q"),array("limit"=>$limit),array(":q"=>"%{$q}%",":q"=>"%{$q}%",":q"=>"%{$q}%"))){
				echo "<h3 class='heading'>URLs Results for '<strong>{$q}</strong>'</h3>";
				foreach ($urls as $url) {
					echo "<div class='url-list'>
						<div class='option checkbox'>
							<ul class='toggle'>
								<li><a href=''><i class='icon-arrow-down'></i>".e('Options')."</a>
									<div class='dropdown'>";
											if (!empty($url['bundle'])){
											$bundle=$this->db->get('bundle',array('id'=>$url['bundle']),array('limit'=>1));
											echo "<a href='#' class='ajax_call button small' data-content='".e('Click to change bundle')."' data-action='url_bundle_add' data-id='{$url['id']}' data-title='".e('Change Bundle')."'>".e('Bundle').": {$bundle['name']}</a>";
										}else{
											echo "<a href='#' class='ajax_call button small' data-content='".e('Click to add to a bundle')."' data-action='url_bundle_add' data-id='{$url['id']}' data-title='".e('Add to bundle')."'>".e('Add to bundle')."</a>";
										}		
										echo "<a href='#edit' class='ajax_call' data-title='".e('Edit URL')."' data-action='url_edit' data-id='{$url['id']}'>".e('Edit')."</a>
										<a href='{$this->config['url']}/user/?event=delete&amp;id={$url['id']}' class='delete'>".e('Delete')."</a>													
										<a href='https://www.facebook.com/sharer.php?u={$this->config['url']}/{$url['alias']}{$url['custom']}' class='u_share'>Share on Facebook</a>		
										<a href='https://twitter.com/share?url={$this->config['url']}/{$url['alias']}{$url['custom']}' class='u_share'>Share on Twitter</a>						
									</div>	
								</li>
							</ul>
						</div><!-- /.checkbox -->						
						<div class='url-info'>
							<h3 class='title'>
								<img src='http://www.google.com/s2/favicons?domain={$url['url']}' alt='Favicon'>
								<a href='{$url['url']}' target='_blank'>".Main::truncate(empty($url['meta_title'])?$url['url']:$url['meta_title'],50)."</a>
								<p class='short-url'>
									<a href='{$this->config['url']}/{$url['alias']}{$url['custom']}' target='_blank'>{$this->config['url']}/{$url['alias']}{$url['custom']}</a> 
									&nbsp;&nbsp;·&nbsp;&nbsp;
									<span class='lock-url-{$url['id']}'>";
										if ($url['public']){
											echo "<a href='#private?' class='button transparent small ajax_call' data-id='{$url['id']}' data-action='lock' data-class='lock-url-{$url['id']}'><i class='icon-unlock'></i> ".e('Public')."</a>";
										}else{
											echo "<a href='#public?' class='button transparent small ajax_call' data-id='{$url['id']}' data-action='unlock' data-class='lock-url-{$url['id']}'><i class='icon-lock'></i> ".e('Private')."</a>";
										}							
									echo "</span><!-- /.lock -->";
									if (!empty($url['description'])){
										echo "&nbsp;&nbsp;·&nbsp;&nbsp; 
										<a href='#' class='tooltip button small' data-content='{$url['description']}'>".e('View Note')."</a>";
									}			
									if($url["archived"]) echo "&nbsp;&nbsp;·&nbsp;&nbsp; ".e("Archived");
								echo "</p>
								<div class='info'>
									<span><i class='icon-time'></i> ".Main::timeago($url['date'])."</span>";
									if (!empty($url['location'])){
										echo "<span><i class='icon-globe'></i> ".e('Geotargeted')."</span>";
									}
									if (!empty($url['pass'])){
										echo "<span><i class='icon-pass'></i> ".e('Protected')."</span>";
									}
								"
								</div><!-- /.info -->
							</h3>								
						</div>		
						<div class='url-stats'>
							<strong>{$url['click']}</strong>
							<a href='{$this->config['url']}/{$url['alias']}{$url['custom']}+' target='_blank' class='button blue small round'>".e('Clicks')."</a>
						</div><!-- /.url-stats -->											
					</div><!-- /.url-list -->";						
				}
				return;
			}	
		}
		echo "<p class='message error' style='margin: 10px;'>".e("Nothing found.")."</p>";
	}
	/**
	 * Display logged user bundles
	 * @since v2.0
	 */
	protected function bundles($limit=15){
		if(isset($_GET["id"]) && is_numeric($_GET["id"])){		
			$this->bundle_urls();
			return;
		}		
		$bundles=$this->db->get("bundle",array("userid"=>$this->logged_id));
		// Set Meta info
		Main::set("title",e("Manage your bundles"));
		Main::set("description","Manage your bundles, share them or delete them.");
		Main::set("url","{$this->config["url"]}/user/bundles");
		include(TEMPLATE."/header.php");		
		include(TEMPLATE."/bundles.php");		
		include(TEMPLATE."/footer.php");		
	}
	/**
	 * Display URL Bundles
	 * @since v3.0
	 */	
	protected function bundle_urls($limit=15){
		$bundle=array();
		if($bundle=$this->db->get("bundle",array("userid"=>$this->logged_id,"id"=>Main::clean($_GET["id"])),array("limit"=>1))){
				$bundle["url"]=$this->config["url"]."/bundle/".Main::slug($bundle["name"])."-{$bundle["id"]}";
				$urls=$this->db->get("url",array("userid"=>$this->logged_id,"bundle"=>$bundle["id"]),array("limit"=>(($this->page-1)*$limit).", $limit"));
				if(($this->db->rowCount%$limit)<>0) {
					$max=floor($this->db->rowCount/$limit)+1;
				} else {
					$max=floor($this->db->rowCount/$limit);
				}					
			$bundle["pagination"]=Main::pagination($max, $this->page, $this->config["url"]."/user/bundle?id=".Main::clean($_GET["id"])."&page=%d");			
			Main::set("title",e("Manage your bundle's URLs"));
			Main::set("description","Manage your bundled URLs, share them or delete them.");

			include(TEMPLATE."/header.php");		
			include(TEMPLATE."/bundle_urls.php");			
			include(TEMPLATE."/footer.php");		
			return;				
		}			
	}
	/**
	 * Display user bundles
	 * @since v2.0
	 */
	public function public_bundles($limit=15){
		$user=$this->db->get("user",array("id"=>"?","public"=>"?"),array("limit"=>1),array($_POST["id"],"1"));
		$bundles=$this->db->get("bundle",array("userid"=>$user["id"],"access"=>"public"));
		echo "<h2>".e('Public Bundles')."</h2>";
		echo "<div id='bundles'>";
		echo "<span class='clear'></span>";
		foreach ($bundles as $bundle) {
			$count=$this->db->get("url",array("bundle"=>$bundle["id"]),array("count"=>true))?$this->db->rowCount:"0";
			echo '<div class="bundle list">';
				echo '<div class="count">';
					echo '<a href="'.$this->config["url"].'/bundle/'.Main::slug($bundle["name"]).'-'.$bundle["id"].'">'.$count.' <span>'.e("URLs").'</span></a>';
				echo '</div><!-- /.count -->';
				echo '<a href="'.$this->config["url"].'/bundle/'.Main::slug($bundle["name"]).'-'.$bundle["id"].'">'.Main::truncate($bundle["name"],50).'</a>';
				echo '<span>'.Main::timeago($bundle["date"]).'</span>';
			echo '</div><!-- /.bundle -->';			
		}
		echo "</div>";
	}		
	/**
	 * Public Bundle URLs
	 * @since v2.1
	 */
	public function bundle($limit=15){
		if(empty($_GET["do"])){
			$this->_404();
			return;
		}
		$id=explode("-",$_GET["do"]);
		$id=array_reverse($id);
		$bundle=$this->db->get("bundle",array("id"=>"?","access"=>"?"),array("limit"=>1),array($id[0],"public"));
		if(!$bundle) {
			$this->_404();
			return;
		}

		$this->db->update("bundle","view= view + 1",array("id"=>$bundle["id"]));
		$user=$this->db->get("user",array("id"=>"?","public"=>"?"),array("limit"=>1),array($bundle["userid"],"1"));
		if(!$user) {
			$this->_404();
			return;
		}
		$urls=$this->db->get("url",array("userid"=>"?","public"=>"?","bundle"=>"?"),array("count"=>true,"limit"=>(($this->page-1)*$limit).", $limit"),array($user["id"],"1",$bundle["id"]));
		$url_count=$this->db->rowCount;
		$user["profile"]=$this->config["url"]."/profile/".$user["username"];		
		$bundle_view=$bundle["view"]+1;
		$bundle["url"]=$this->config["url"]."/bundle/".Main::clean($_GET["do"]);
		if(($this->db->rowCount%$limit)<>0) {
			$max=floor($this->db->rowCount/$limit)+1;
		} else {
			$max=floor($this->db->rowCount/$limit);
		}		
		if($this->page>1 && $this->page>$max) Main::redirect("bundle/".Main::clean($_GET["do"]));		
		$this->user["pagination"]=Main::pagination($max, $this->page, $this->config["url"]."/bundle/".Main::clean($_GET["do"])."?page=%d");

		if($user["auth"]=="facebook" && !empty($user["auth_id"])){
			$user["avatar"]=(($this->ssl)?"https://":"http://")."graph.facebook.com/".$user["auth_id"]."/picture?type=large";
		}else{
			$user["avatar"]=(($this->ssl)?"https://":"http://")."www.gravatar.com/avatar/".md5(trim($user["email"]))."?s=80";
		}		
		Main::set("title",ucfirst($bundle["name"])." ".e("Bundle"));
		include(TEMPLATE."/header.php");
		include(TEMPLATE."/profile.php");
		include(TEMPLATE."/footer.php");
	}		
	/**
	 * Create Bundle
	 * @since v2.0
	 */
	public function bundle_create(){
		if(isset($_POST["event"]) && $_POST["event"]=="bundle_create"){
			if($this->config["demo"]){
				Main::redirect("user",array("error",e("Feature disabled in demo.")));
				return;
			}					
			if(!Main::validate_csrf_token($_POST["token"])){
				Main::redirect("user",array("error",e("Something went wrong, please try again.")));
				return;
			}			
			if(empty($_POST["name"]) || strlen(Main::clean($_POST["name"]))<2){
				Main::redirect("user",array("error",e("Bundle name cannot be empty and must have at least 2 characters.")));
				return;				
			}
			if($this->db->get("bundle",array("name"=>"?","userid"=>"?"),"",array(Main::clean($_POST["name"]),$this->logged_id))){
				Main::redirect("user",array("error",e("You already have a bundle with that name.")));
				return;		
			}
			if($this->db->insert("bundle",array("name"=>"?","access"=>"?","userid"=>"?","date"=>"NOW()"),array(Main::clean($_POST["name"]),Main::clean($_POST["access"]),$this->logged_id))){
				Main::redirect("user",array("success",e("Bundle was successfully created. You may start adding URLs in it now.")));
				return;				
			}
			return;
		}
		echo '
				<form action="'.$this->config["url"].'/user" method="post" class="form">
						<label>'.e("Bundle Name").' ('.e("required").')</label>			
						<input type="text" value="" name="name" class="input" />

						<ul class="form_opt" data-id="access">
							<li class="label">'.e("Bundle Access").'
							<small>'.e("If you set it to private, only you can access the URLs").'.</small>
							</li>
							<li><a href="" class="last current" data-value="private">'.e("Private").'</a></li>
							<li><a href="" class="first" data-value="public">'.e("Public").'</a></li>
						</ul>
						<input type="hidden" name="access" id="access" value="private">	

						<input type="hidden" name="event" value="bundle_create">	
						'.Main::csrf_token(TRUE).'
						<button type="submit" class="button">'.e("Create Bundle").'</button>							
				</form>';
	}
	/**
	 * Edit Bundle
	 * @since v2.1
	 */
	public function bundle_edit(){
		if(!$bundle=$this->db->get("bundle",array("userid"=>$this->logged_id,"id"=>Main::clean($_POST["id"])),array("limit"=>1))){
			echo e("This bundle doesn't exist");
			return;
		}
		if(isset($_POST["event"]) && $_POST["event"]=="bundle_update"){
			if($this->config["demo"]){
				Main::redirect("user",array("error",e("Feature disabled in demo.")));
				return;
			}		
			if(!Main::validate_csrf_token($_POST["token"])){
				Main::redirect("user/bundles",array("error",e("Something went wrong, please try again.")));
				return;
			}			
			if(empty($_POST["name"]) || strlen(Main::clean($_POST["name"]))<2){
				Main::redirect("user/bundles",array("error",e("Bundle name cannot be empty and must have at least 2 characters.")));
				return;				
			}
			$this->db->update("bundle",array("name"=>"?","access"=>"?"),array("id"=>$bundle["id"]),array(Main::clean($_POST["name"]),Main::clean($_POST["access"])));
			Main::redirect("user/bundles",array("success",e('Bundle has been updated.')));	
			return;
		}
		echo '
				<form action="'.$this->config["url"].'/user" method="post" class="form">
						<label>'.e("Bundle Name").' ('.e("required").')</label>			
						<input type="text" value="'.$bundle["name"].'" name="name" class="input" />

						<ul class="form_opt" data-id="access">
							<li class="label">'.e("Bundle Access").'
							<small>'.e("If you set it to private, only you can access the URLs").'.</small>
							</li>
							<li><a href="#" class="last'.($bundle["access"]=="private"?" current":"").'" data-value="private">'.e("Private").'</a></li>
							<li><a href="#" class="first'.($bundle["access"]=="public"?" current":"").'" data-value="public">'.e("Public").'</a></li>
						</ul>
						<input type="hidden" name="access" id="access" value="'.$bundle["access"].'">	
						<input type="hidden" name="id" value="'.$bundle["id"].'">
						<input type="hidden" name="event" value="bundle_update">	
						'.Main::csrf_token(TRUE).'
						<button type="submit" class="button">'.e("Update Bundle").'</button>							
				</form>';
	}	
	/**
	 * Delete Bundle
	 * @since v2.0
	 */
	public function bundle_delete(){
		if($this->config["demo"]){
			Main::redirect("user",array("error",e("Feature disabled in demo.")));
			return;
		}				
		if(isset($_GET["delete"]) && is_numeric($_GET["delete"])){
			if($bundle=$this->db->get("bundle",array("id"=>"?","userid"=>$this->logged_id),array("limit"=>1),array($_GET["delete"]))){
				$this->db->update("url",array("bundle"=>""),array("userid"=>$this->logged_id,"bundle"=>$bundle["id"]));
				$this->db->delete("bundle",array("userid"=>$this->logged_id,"id"=>$bundle["id"]));
				Main::redirect("user/bundles",array("success","This bundle has been deleted."));
				return;
			}
		}		
	}	
	/**
	 * Add URL to bundle
	 * @since v2.0
	 */
	public function url_bundle_add(){
		if(isset($_POST["event"]) && $_POST["event"]=="url_bundle_add"){
			if(!Main::validate_csrf_token($_POST["token"])){
				Main::redirect("user",array("error",e("Something went wrong, please try again.")));
				return;
			}	
			if($this->db->update("url",array("bundle"=>"?"),array("id"=>"?","userid"=>$this->logged_id),array($_POST["bundle_id"],$_POST["url_id"]))){
				Main::redirect("user",array("success",e("This URL has been added to the bundle.")));
				return;				
			}	
		}
		if(isset($_POST["id"]) && is_numeric($_POST["id"])){
			if($url=$this->db->get("url",array("id"=>"?"),array("limit"=>1),array($_POST["id"]))){
				if($bundles=$this->db->get("bundle",array("userid"=>$this->logged_id))){
					echo '<form class="form" action="'.$this->config["url"].'/user" method="post">
							<label>'.e("URL").'</label>
							<input type="text" class="input" value="'.$url["url"].'" disabled>

							<label>'.e("Choose Bundle").' <a href="#" data-action="bundle_create" data-title="'.e("Create Bundle").'" class="button small right ajax_call round">'.e("Create Bundle").'</a></label>
							<select name="bundle_id" class="selectized" style="display:none">';					
							foreach ($bundles as $bundle) {
								echo '<option value="'.$bundle["id"].'">'.$bundle["name"].'</option>';
							}
					echo '</select><br>
							'.Main::csrf_token(TRUE).'
							<input type="hidden" name="url_id" value="'.$url["id"].'">							
							<input type="hidden" name="event" value="url_bundle_add">
							<button type="submit" class="button">'.e("Add to bundle").'</button>
							<script>$(".selectized").dropkick()</script>
					';
				}else{
					echo '<a href="#" data-action="bundle_create" data-title="'.e("Create Bundle").'" class="button ajax_call round">'.e("Create Bundle").'</a>';
				}

			}
		}
	}
	/**
	 * User public profile
	 */
	public function profile($bundle=NULL,$limit=15){
		if(empty($_GET["do"])){
			$this->_404();
			return;
		}
		$user=$this->db->get("user",array("username"=>"?","public"=>"?"),array("limit"=>1),array($_GET["do"],"1"));
		if(!$user) {
			$this->_404();
			return;
		}
		$urls=$this->db->get("url",array("userid"=>"?","public"=>"?"),array("count"=>true,"limit"=>(($this->page-1)*$limit).", $limit"),array($user["id"],"1"));
		$url_count=$this->db->rowCount;			

		if(($this->db->rowCount%$limit)<>0) {
			$max=floor($this->db->rowCount/$limit)+1;
		} else {
			$max=floor($this->db->rowCount/$limit);
		}		
		if($this->page>1 && $this->page>$max) Main::redirect("profile/{$user["username"]}");
		$this->user["pagination"]=Main::pagination($max, $this->page, $this->config["url"]."/profile/{$user["username"]}?page=%d");

		$bundles=$this->db->get("bundle",array("userid"=>"?","access"=>"?"),"",array($user["id"],"public"));
		$bundle_count=$this->db->rowCountAll;
		$user["profile"]=$this->config["url"]."/profile/".$user["username"];		
		if($user["auth"]=="facebook" && !empty($user["auth_id"])){
			$user["avatar"]=(($this->ssl)?"https://":"http://")."graph.facebook.com/".$user["auth_id"]."/picture?type=large";
		}else{
			$user["avatar"]=(($this->ssl)?"https://":"http://")."www.gravatar.com/avatar/".md5(trim($user["email"]))."?s=80";
		}		
		Main::set("title",ucfirst($user["username"]));
		include(TEMPLATE."/header.php");
		include(TEMPLATE."/profile.php");
		include(TEMPLATE."/footer.php");
	}
	/**
	 * Lock a URL
	 * @since v2.0
	 */
	public function lock(){
		if($this->db->update("url",array("public"=>"?"),array("userid"=>"?","id"=>"?"),array("0",$this->logged_id,Main::clean($_POST["id"])))){
			echo '<a href="#public?" class="button transparent small ajax_call" data-id="'.Main::clean($_POST["id"]).'" data-action="unlock" data-class="lock-url-'.Main::clean($_POST["id"]).'"><i class="icon-lock"></i> '.e('Private').'</a>';
			return;
		}
	}
	/**
	 * Unlock a URL
	 * @since v2.0
	 */
	public function unlock(){
		if($this->db->update("url",array("public"=>"?"),array("userid"=>"?","id"=>"?"),array("1",$this->logged_id,Main::clean($_POST["id"])))){
			echo '<a href="#private?" class="button transparent small ajax_call" data-id="'.Main::clean($_POST["id"]).'" data-action="lock" data-class="lock-url-'.Main::clean($_POST["id"]).'"><i class="icon-unlock"></i> '.e('Public').'</a>';
			return;
		}
	}	
	/**
	 * Generate chart data
	 * @since v2.0
	 */
	public function chart($time="15"){
		$var_url="";
		$var_user="";
		$var_click="";
		$date="";
		$timestamp = time();
		for ($i = 0 ; $i < $time ; $i++) {
		    $array[date('d M', $timestamp)]=0;
		    $timestamp -= 24 * 3600;
		}	
		$urls=$this->db->get(array("count"=>"COUNT(DATE(date)) as url_count,DATE(date) as url_date","table"=>"url"),"(date >= CURDATE( ) - INTERVAL $time DAY) AND userid='{$this->logged_id}'",array("group"=>"DATE(date)","limit"=>30));
		if($urls){
			$new=array();	
			foreach ($urls as $data) {
				$new[date("d M",strtotime($data["url_date"]))]=$data["url_count"];
			}
			$i=0;				
			foreach ($array as $key => $value) {
				$i++;
				if(isset($new[$key])){
					$var_url.="[".($time-$i).", ".$new[$key]."], ";
					$date.="[".($time-$i).",\"$key\"], ";
				}else{
					$var_url.="[".($time-$i).", 0], ";
					$date.="[".($time-$i).", \"$key\"], ";
				}
			}		
		}							
		return "<script type='text/javascript'> 
							var data=[{
      					label: \"".e("Short URLs")."\",
     						data: [$var_url]
						}];
							var xlabel=[$date];
						</script>
						";
	}
	/**
	 * Display advertisement
	 * @since v2.0	 
	 */	
	public function ads($size,$text=TRUE,$breadcrumb=""){
		if(in_array($size, array("728","468","300"))){
			if($this->config["ads"] && $this->show_ads){
				return "<div class='ads ad_$size'>".($text?"<p class='text'><small class='left'>".e('Advertisment')."</small><a href='{$this->config["url"]}/user/disable_ads' class='right'><small>(Remove Ads)</small></a></p>":"")."{$this->config["ad$size"]}</div>";				
			}
			if(!empty($breadcrumb)) return "<h2 class='breadcrumb'>".e($breadcrumb)."</h2>";
		}
		return;		
	}
	/**
	 * Contact page
	 */
	public function contact(){
		if(isset($_POST["event"]) && $_POST["event"]=="send_email"){
			if(!Main::validate_csrf_token($_POST["token"])){
				Main::redirect("contact",array("error",e("Something went wrong, please try again.")));
				return;
			}		
			if(empty($_POST["email"]) || empty($_POST["message"])){
				Main::redirect("contact",array("error",e("Please fill everything")));
				return;				
			}
			// Check Captcha
			if($this->config["captcha"]){
				$captcha=Main::check_captcha($_POST);
				if($captcha!='ok'){
					Main::redirect("contact",array("error",$captcha));
					return;					
				}
			}	
			$array["to"]=$this->config["email"];
			$array["subject"]="[{$this->config["title"]}] You have been contacted!";
			$email=Main::clean($_POST["email"]);
			$name=Main::clean($_POST["name"]);
			$array["message"]="From: $name ($email)<br><br>".Main::clean("{$_POST["message"]}",3,FALSE);
			Main::send($array);
			Main::redirect("contact",array("success",e("Your message has been sent. We will reply as soon as possible.")));
			return;
		}
		Main::set("title",e("Contact Us"));
		Main::set("description",e("If you have any questions, feel free to contact us on this page."));
		Main::set("url","{$this->config["url"]}/contact");
		
		include(TEMPLATE."/header.php"); 
		include(TEMPLATE."/contact.php");	
		include(TEMPLATE."/footer.php"); 
		return;
	}
 /**
	* Get Pages
	* @since v2.0	
	*/
	public function get_pages($limit=5){
		return $this->db->get("page",array("menu"=>"1"),array("limit"=>$limit,"order"=>"name"));
	}
 /**
	* Custom Page
	* @since v2.0	
	*/	
	public function page(){
		if(!empty($_GET["do"])){
			if($this->lang!="en"){
				if(!$page=$this->db->get("page",array("seo"=>"?"),array("limit"=>1),array(Main::clean($_GET["do"])."_".$this->lang))){
					$page=$this->db->get("page",array("seo"=>"?"),array("limit"=>1),array(Main::clean($_GET["do"])));
				}				
			}else{
				$page=$this->db->get("page",array("seo"=>"?"),array("limit"=>1),array(Main::clean($_GET["do"])));
			}
			if(!$page){
				$this->_404();
				return;
			}
			$page["content"]=$this->page_replace($page["content"]);
			Main::set("title",e($page["name"]));
			Main::set("description",Main::truncate(Main::clean(str_replace(array("\r","\n","	"),"",$page["content"]),3),100));	
			Main::set("url","{$this->config["url"]}/page/{$page["seo"]}");		
			include(TEMPLATE."/header.php"); 
			include(TEMPLATE."/page.php");	
			include(TEMPLATE."/footer.php"); 
			return;			
		}else{
			$this->_404();
			exit;
		}
	}
	/**
	 * Analytics 
	 * @since v2.0
	 */
	public function analytic(){
		include(ROOT."/analytics.php");
	}
	/**
	 * Page replace function
	 */	
	protected function page_replace($text){
	  $text=str_replace("{URL}",$this->config["url"],$text);
	  if($this->config["ads"]){
	    $text=str_replace("{AD728}",$this->ads('728'),$text);
	    $text=str_replace("{AD468}",$this->ads('468'),$text);
	    $text=str_replace("{AD300}",$this->ads('ad300'),$text);
	  }else{
	    $text=str_replace("{AD728}","",$text);
	    $text=str_replace("{AD468}","",$text);
	    $text=str_replace("{AD300}","",$text);
	  }
	  return $text;
	} 	
	/**
	 * 404 Page
	 * @since v2.0
	 */	
	public function _404(){
		Main::set("title","404 Page Not Found");			
		Main::set("description","The page you were looking for has not been found.");
		Main::set("body_class","dark");	
		Main::set("url","{$this->config["url"]}/404");	
		$this->is404=TRUE;					
		include(TEMPLATE."/header.php");
		include(TEMPLATE."/404.php");	
		include(TEMPLATE."/footer.php");		
	}	
	/**
	 * Private Page
	 * @since v2.0
	 */		
	public function _private(){
		Main::set("title","Private URL Shortener");			
		Main::set("description","This URL shortener is private and internal-use only.");
		Main::set("body_class","dark");	
		Main::set("url","{$this->config["url"]}/private");						
		include(TEMPLATE."/header.php");
		include(TEMPLATE."/private.php");	
		include(TEMPLATE."/footer.php");		
	}		
	/**
	 * Maintenance Page
	 * @since v2.0
	 */		
	public function _maintenance(){
		Main::set("title","Under Maintenance");			
		Main::set("description","We are currently under maintenance.");
		Main::set("body_class","dark");	
		Main::set("url","{$this->config["url"]}/private");						
		include(TEMPLATE."/header.php");
		include(TEMPLATE."/maintenance.php");	
		include(TEMPLATE."/footer.php");		
	}			
	/**
	 * Get multiple domain names
	 * @since v3.0
	 */
	public function get_domains($e=''){
		if($this->config["multiple_domains"]){
			$html='<select name="domain'.$e.'" id="domains'.$e.'">';
			$html.='<optgroup label="'.e('Choose Domain').'" />';
			$domains=explode("\n", $this->config["domain_names"]);
			$html.='<option value="'.strtolower($this->config["url"]).'">'.ucfirst(str_replace("https://","",str_replace("http://", "",$this->config["url"]))).'</option>';
			foreach ($domains as $domain) {
				if(!empty($domain)) $html.='<option value="'.strtolower(trim($domain)).'">'.ucfirst(str_replace("https://","",str_replace("http://", "", trim($domain)))).'</option>';
			}
			$html.='</select>';
		return $html;
		}
	}
	/**
	 * Validate multiple domain names
	 * @since v2.0
	 */	
	protected function validate_domain_names($domain,$return=TRUE){
		if($this->config["multiple_domains"]){
			$domains=explode("\n", trim($this->config["domain_names"]));
			$domains[]=$this->config["url"];
			foreach ($domains as $array) {
			  if(preg_match("~$domain~i", $array)) {
			  	if($return) return $array;
			  	return TRUE;
			  }
			}
		}
		return FALSE;
	}			
	/**
	 * Get domain
	 * @since v2.0
	 */		
	protected function domain($url){
		$domain=parse_url($url);
		if(isset($domain["host"])){
			$domain=str_replace("www.","",$domain["host"]);
			return $domain; 
		}
		return FALSE;
	}	
	/**
	 * Anonymous User history
	 * @since v3.0
	 */	
	 public function history($limit=10){
	 	if(!$this->config["user_history"]) return FALSE;
	 	$c=Main::cookie("aid");
	 	if($c && !$this->logged_id){
	 		$ids=explode("-",$c);
	 		if(!empty($ids)){	 			
	 			$urls=array();
	 			$i=1;
	 			$query="";
	 			foreach ($ids as $id) {
	 				if($i>$limit) break;
	 				if(!empty($id)){
	 					if($i==count($ids)-1) $query.="(alias='$id' OR custom='$id')";
	 					else $query.="(alias='$id' OR custom='$id') OR ";
	 					$i++;
	 				}
	 			}
	 			return $this->db->get("url","($query) AND userid=:id",array("limit"=>10),array(":id"=>"0"));
	 		}	 		
	 	}	
	 	return FALSE;
	}	
	/**
	 * Generate Languages
	 * @since v2.0
	 */
	public function languages(){
		$path=ROOT."/includes/lang";
		$l="";
		$n="";
		echo "<li><a href='?lang=en'>English</a></li>";
		foreach (new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path)) as $filename) { 
			if(Main::extension($filename)==".php" && !preg_match("~lang_sample.php~", $filename) && !preg_match("~index.php~", $filename)){
				$l=str_replace("/","",stripslashes(str_replace(".php","",str_replace(ROOT."/includes/lang", "", $filename))));
			  $data=token_get_all(file_get_contents($filename));
			  $data=$data[2][1];
				if(preg_match("~Language:\s(.*)~", $data,$name)){
					$n=strip_tags(trim($name[1]));
				}
				echo "<li><a href='?lang=$l'>$n</a></li>";
			}
		}		
		return;
	}
	/**
	 * URLs Clicks Users Count
	 * @since v2.1
	 */
	public function urls_count(){
		return $this->db->count("url");
	}
	public function clicks_count(){
		return $this->db->count("url","","click");
	}
	public function users_count(){
		return $this->db->count("user");
	}		 
	/**
	* User Settings Page
	* @since v3.0
	*/		
	public function settings(){
		if($user=$this->db->get("user",array("id"=>"?"),array("limit"=>"1"),array($this->logged_id))){
			if($user["auth"]=="facebook" && !empty($user["auth_id"])){
				$user["avatar"]=(($this->ssl)?"https://":"http://")."graph.facebook.com/".$user["auth_id"]."/picture?type=large";
			}else{
				$user["avatar"]=(($this->ssl)?"https://":"http://")."www.gravatar.com/avatar/".md5(trim($user["email"]))."?s=80";
			}		

			if($this->config["multiple_domains"]){

				$domain_html='<label>'.e("Default Domain Name").'</label>		<select name="domain" id="domains">';
				$domain_html.='<optgroup label="'.e('Choose Domain').'" />';
				$domains=explode("\n", $this->config["domain_names"]);
				$domain_html.='<option value="" '.(($user["domain"]==$this->config["url"] || empty($user["domain"]))?'selected':'').'>'.ucfirst(str_replace("https://","",str_replace("http://", "",$this->config["url"]))).'</option>';
				foreach ($domains as $domain) {
					$domain_html.='<option value="'.strtolower(trim($domain)).'" '.($user["domain"]==$domain?'selected':'').'>'.ucfirst(str_replace("https://","",str_replace("http://", "", trim($domain)))).'</option>';
				}
				$domain_html.='</select>';
			}else{
				$domain_html="";
			}			
  		Main::add("<script type='text/javascript'>$('#domains').dropkick();</script>","custom",TRUE);			
			Main::set("title",e("User Settings"));
			Main::set("description","Edit your account's information.");
			include(TEMPLATE."/header.php"); 
			include(TEMPLATE."/settings.php");	
			include(TEMPLATE."/footer.php"); 		
		}				
	}
	/**
	 * Create a custom splash page
	 * @since v3.0
	 */
	public function create(){
		if(!$this->splash && !empty($this->config["custom_splash_amount"])) return Main::redirect("user/settings",array("error",e("You need to unlock this feature by paying &#36;{$this->config["custom_splash_amount"]}.")));
		if(isset($_POST["action"]) && $_POST["action"]=="create_splash") {
			return $this->create_splash_page();
		}
		$data=array(
				"avatar"=>"http://placehold.it/100x100/000/fff&text=Avatar",
				"banner"=>"http://placehold.it/980x300/000/fff&text=Banner",
				"title"=>"Custom Title",
				"message"=>"Your custom message about the product in less than 140 characters.",
				"product"=>"http://gempixel.com"
		);
		$user=$this->db->get("user",array("id"=>"?"),array("limit"=>"1"),array($this->logged_id));
		if(!empty($user["splash"])){
			$data=json_decode($user["splash"],TRUE);
			$data["banner"]=$this->config["url"]."/static/user_content/{$this->logged_id}_files/{$data["banner"]}";
			$data["avatar"]=$this->config["url"]."/static/user_content/{$this->logged_id}_files/{$data["avatar"]}";
		}
		Main::set("title",e("Create a Custom Splash Page"));
		Main::set("description","Customize the splash page to attract more customers to your product or site.");
		include(TEMPLATE."/header.php"); 
		include(TEMPLATE."/create.php");
		include(TEMPLATE."/footer.php"); 		
	}
	/**
	 * Create Splash Page
	 * @since v3.0
	 */
	public function create_splash_page(){
		if($this->config["demo"]){
			Main::redirect("user/settings",array("error",e("Feature disabled in demo.")));
			return;
		}		
		if(!Main::validate_csrf_token($_POST["token"])){
			Main::redirect("user/create/",array("error",e("Something went wrong, please try again.")));
			return;
		}		
		$upload_path=ROOT."/static/user_content/";
		$ext=array("image/png"=>"png","image/jpeg"=>"jpg","image/jpg"=>"jpg");

		$_POST["title"]=Main::clean($_POST["title"],3);
		$_POST["message"]=Main::clean($_POST["message"],3);
		$_POST["url"]=Main::clean($_POST["url"],3);

		if(!filter_var($_POST["product"],FILTER_VALIDATE_URL)) return Main::redirect("user/create",array("error",e("Please enter a valid URL.")));
		if(strlen($_POST["message"])>140) return Main::redirect("user/create",array("error",e("Message is too long. It must be less than 140 characters.")));
		
		if(!isset($ext[$_FILES["avatar"]["type"]])) return Main::redirect("user/create",array("error",e("Avatar must be either a PNG or a JPEG.")));
		if(!isset($ext[$_FILES["banner"]["type"]])) return Main::redirect("user/create",array("error",e("Avatar must be either a PNG or a JPEG.")));

		if($_FILES["avatar"]["size"]>300*1024) return Main::redirect("user/create",array("error",e("Avatar must be either a 100x100 PNG or a JPEG (Max 300KB).")));		
		if($_FILES["banner"]["size"]>500*1024) return Main::redirect("user/create",array("error",e("Banner must be either a 980x300 PNG or a JPEG (Max 500KB).")));		
		list($width, $height) = getimagesize($_FILES["avatar"]["tmp_name"]);
		if($width!=100 && $height!=100)	return Main::redirect("user/create",array("error",e("Avatar must be either a 100x100 PNG or a JPEG (Max 300KB).")));		
		list($width, $height) = getimagesize($_FILES["banner"]["tmp_name"]);
		if($width!=980 && $height!=300)	return Main::redirect("user/create",array("error",e("Banner must be either a 980x300 PNG or a JPEG (Max 500KB).")));	
		// OK Let's upload
		$folder=$upload_path."{$this->logged_id}_files/";
		if(!file_exists($folder) OR !is_dir($folder)){
	    mkdir($folder);         
	  }			  	
		$avatar=$folder."avatar.".$ext[$_FILES["avatar"]["type"]];
		$banner=$folder."banner.".$ext[$_FILES["banner"]["type"]];
    move_uploaded_file($_FILES["avatar"]['tmp_name'], $avatar);
		move_uploaded_file($_FILES["banner"]['tmp_name'], $banner);

		$array=array(
			"title" => $_POST["title"],
			"message" => $_POST["message"],
			"banner"=>"banner.".$ext[$_FILES["banner"]["type"]],
			"avatar"=>"avatar.".$ext[$_FILES["avatar"]["type"]],
			"product" => $_POST["product"]
			);
		$array=json_encode($array);
		if($this->db->update("user",array("splash"=>$array),array("id"=>$this->logged_id))){
			Main::redirect("user/create",array("success",e("Splash has been created.")));
		}
	}
	/**
	 * Paypal Link Generator - Disable Ads
	 * @since v3.0
	 */	
	public function disable_ads($array=array(),$sandbox=false){		
		if($this->config["demo"]){
			Main::redirect("user/settings",array("error",e("Feature disabled in demo.")));
			return;
		}			
		$default=array(
				"cmd"=>"_xclick",
				"business"=>"{$this->config["paypal_email"]}",
   			"currency_code"=>"USD",
   			"item_name"=>"Advertisment Removal (User: {$this->logged_id})",
   			"amount"=>"{$this->config["removal_amount"]}",
   			"return"=>"{$this->config["url"]}/user/verify?token=".md5($this->config["secret_key"].'disable_ads'),
   			"notify_url"=>"{$this->config["url"]}/user/verify?token=".md5($this->config["secret_key"].'disable_ads'),
   			"cancel_return"=>"{$this->config["url"]}/user/verify?cancel"
			);		
		$options=array_replace($default,$array);		
		if(empty($options["business"])) Main::redirect("",array("error","PayPal is not set up correctly. Please contact the administrator."));
		if($sandbox){
			$paypal_url="https://www.sandbox.paypal.com/cgi-bin/webscr?";
		}else{
			$paypal_url="https://www.paypal.com/cgi-bin/webscr?";
		}
    $q = http_build_query($options);
    $paypal_url=$paypal_url.$q;
		//die($paypal_url);
		header("Location: $paypal_url");
		exit;
	}
	/**
	 * Paypal Link Generator - Unlock Custom Splash Page
	 * @since v3.0
	 */	
	public function unlock_splash($array=array(),$sandbox=false){
		if($this->config["demo"]){
			Main::redirect("user/settings",array("error",e("Feature disabled in demo.")));
			return;
		}			
		$default=array(
				"cmd"=>"_xclick",
				"business"=>"{$this->config["paypal_email"]}",
   			"currency_code"=>"USD",
   			"item_name"=>"Unlock Custom Splash Page (User: {$this->logged_id})",
   			"amount"=>"{$this->config["custom_splash_amount"]}",
   			"return"=>"{$this->config["url"]}/user/verify?token=".md5($this->config["secret_key"].'unlock_splash'),
   			"notify_url"=>"{$this->config["url"]}/user/verify?token=".md5($this->config["secret_key"].'unlock_splash'),
   			"cancel_return"=>"{$this->config["url"]}/user/verify?cancel"
		);		
		$options=array_replace($default,$array);		
		if(empty($options["business"])) Main::redirect("",array("error","PayPal is not set up correctly. Please contact the administrator."));
		if($sandbox){
			$paypal_url="https://www.sandbox.paypal.com/cgi-bin/webscr?";
		}else{
			$paypal_url="https://www.paypal.com/cgi-bin/webscr?";
		}
    $q = http_build_query($options);
    $paypal_url=$paypal_url.$q;
		//die($paypal_url);
		header("Location: $paypal_url");
		exit;
	}	
	/**
	 * Verify Paypal Purchase
	 * @since v3.0
	 */
	public function verify($sandbox=false){
		if($this->config["demo"]){
			Main::redirect("user/settings",array("error",e("Feature disabled in demo.")));
			return;
		}			
   	// intantiate the IPN listener
    include(ROOT.'/includes/lib/Paypal.class.php');
    $listener = new IpnListener();

    // tell the IPN listener to use the PayPal test sandbox
    $listener->use_sandbox = $sandbox;

    // try to process the IPN POST
    try {
        $listener->requirePostMethod();
        $verified = $listener->processIpn();
    } catch (Exception $e) {
        error_log($e->getMessage());
        Main::redirect("user/",array("error",e("An error has occured. Your payment could not be verified. Please contact us for more info.")));
        exit(0);
    }
    // If Verified Purchase	
    if ($verified){
    	$user=$this->db->get("user",array("id"=>"?"),array("limit"=>"1"),array($this->logged_id));
    	if($_GET["token"]==md5($this->config["secret_key"].'disable_ads')){
	    	$this->db->update("user",array("ads"=>"0"),array("id"=>$this->logged_id));
				$var["to"] = $this->config["email"];
		    $var["subject"] = "[{$this->config["title"]}] Advertisment Removal Payment";
				$var["message"] = "
		      <p><b>A payment of &#36;{$this->config["removal_amount"]} has been made to remove ads</b>. The user's email is {$user["email"]} and id is {$user["id"]}. </p>";	
		    	Main::send($var); 	
				$var["to"] = $user["email"];
		    $var["subject"] = "[{$this->config["title"]}] Advertisment Removal Successful";
				$var["message"] = "
		      <p><b>Your payment of &#36;{$this->config["removal_amount"]} was successful</b>. Now you will not see any advertisement when you are logged in. If you have any questions, please feel free to contact us.</p>";	
		      Main::send($var);
					Main::redirect("user/",array("success",e("Your payment was successful and an email has been sent.")));
				}elseif($_GET["token"]==md5($this->config["secret_key"].'unlock_splash')){
		    	$this->db->update("user",array("splash_opt"=>"1"),array("id"=>$this->logged_id));
					$var["to"] = $this->config["email"];
			    $var["subject"] = "[{$this->config["title"]}] Custom Splash Page Payment";
					$var["message"] = "
			      <p><b>A payment of &#36;{$this->config["custom_splash_amount"]} has been made to unlock custom splash</b>. The user's email is {$user["email"]} and id is {$user["id"]}. </p>";	
			    	Main::send($var); 	
					$var["to"] = $user["email"];
			    $var["subject"] = "[{$this->config["title"]}] Custom Splash Page Unlocked";
					$var["message"] = "
			      <p><b>Your payment of &#36;{$this->config["custom_splash_amount"]} was successful</b>. Now you will be able to create a custom splash page to advertise your products. If you have any questions, please feel free to contact us.</p>";	
			      Main::send($var);
						Main::redirect("user/",array("success",e("Your payment was successful and an email has been sent.")));					
				}
    }    
    Main::redirect("user/",array("error",e("An error has occured. Your payment could not be verified. Please contact us for more info.")));
	}
	/**
	 *  Users Stats
	 * @since v3.0
	 */
	protected function statistics(){

	}
	/**
	 * User Export URLs
	 * @since v3.0
	 */
	protected function export(){
		if($this->config["demo"]){
			Main::redirect("user/settings",array("error",e("Feature disabled in demo.")));
			return;
		}			
  	header('Content-Type: text/csv');
	  header('Content-Disposition: attachment;filename=URL_Shortener_URLList.csv');
	  $result = $this->db->get("url",array("userid"=>$this->logged_id),array("order"=>"id","all"=>1));
		echo "Short URL, Long URL, Date, Clicks\n";
    foreach ($result as $line) {
     	echo "{$this->config["url"]}/{$line["alias"]}{$line["custom"]},{$line["url"]},{$line["date"]},{$line["click"]}\n";
    }
    return;
	}	
}
?>