<?php 
/**
 * ====================================================================================
 *                           PREMIUM URL SHORTENER (c) KBRmedia
 * ----------------------------------------------------------------------------------
 * @copyright This software is exclusively sold at CodeCanyon.net. If you have downloaded this
 *  from another site or received it from someone else than me, then you are engaged
 *  in an illegal activity. You must delete this software immediately or buy a proper
 *  license from http://gempixel.com/buy/short.
 *
 *  Thank you for your cooperation and don't hesitate to contact me if anything :)
 * ====================================================================================
 *
 * @author KBRmedia (http://gempixel.com)
 * @link http://gempixel.com 
 * @package Premium URL Shortener
 * @subpackage Database Class (Database.class.php)
 */
class Database{

	protected $config=array(), $dbinfo, $db;
	public $db_error, $query;
	public $rowCount,$rowCountAll;
	public $num_queries=0;

	public function __construct($config,$db){
		$this->config=$config;
		$this->dbinfo=$db;
		try{
		  $this->db = new PDO("mysql:host=".$this->dbinfo["host"].";dbname=".$this->dbinfo["db"]."", $this->dbinfo["user"], $this->dbinfo["password"]);    
		}catch (Exception $e){
		  $this->db_error = "Cannot connect to database: {$e->getMessage()}";
		  exit;
		}
	}

	public function __destruct(){
		if(!empty($this->db_error) && $this->config["debug"]){
			print_r("<h3>Database Error</h3><pre>{$this->db_error}</pre>");
			if($this->config["debug"]=="2" && !empty($this->query)) {
				print_r("<h3>Database Query</h3><pre>{$this->query}</pre>");
			}
			error_log("Database Error: {$this->db_error} occured at http://{$_SERVER["HTTP_HOST"]}{$_SERVER["REQUEST_URI"]}");
		}		
		unset($this->config);
		unset($this->db_error);
		unset($this->query);
		unset($this->dbinfo);
		unset($this->db);
	}	

	// Get configuration
	public function get_config(){
		// Get Config	
		$c=$this->get('settings');
		foreach ($c as $key) {
			$config[$key['config']] = stripslashes($key['var']);
		}
		return $config+$this->config;
	}

	// Select function
	public function get($table,$where='',$sort='',$param=array()){
		// Build Query
		if(is_array($table)){
			$query="SELECT {$table["count"]} FROM ";
			$query.="`{$this->dbinfo["prefix"]}{$table["table"]}`";
		}else{
			$query="SELECT * FROM ";
			$query.="`{$this->dbinfo["prefix"]}$table`";
		}
		if(!empty($where)){
			if(is_array($where)){
				$query.=" WHERE ";
				$count=count($where);
				$i=0;
				foreach ($where as $key => $value) {
					$query.="`$key` = ".$this->quote($value,$param);
					if(++$i != $count) {
					   $query.=" AND ";
					}			
				}				
			}else{
				$query.=" WHERE ";
				$query.= $where;			
			}
		}
		if(!empty($sort) && isset($sort["count"])){
			$result = $this->db->prepare($query);
			$result->execute($param);
			$this->rowCount=$result->rowCount();
		}
		if(!empty($sort)){
			if(isset($sort["group"])){
					$query.=" GROUP BY {$sort["group"]}";	
			}				
			if(isset($sort["order"])){
				if($sort["order"]=="RAND()"){
					$query.=" ORDER BY RAND()";
				}else{
					$query.=" ORDER BY `{$sort["order"]}`";
				}				
			}		
			if(isset($sort["order"])){
				if(isset($sort["asc"]) && $sort["asc"]==TRUE){
					$query.=" ASC";
				}else{
					$query.=" DESC";
				}
			}			
			if(isset($sort["limit"])){
				$query.=" LIMIT {$sort["limit"]}";
			}			
		}
		$result = $this->db->prepare($query);
		$result->execute($param);
		$this->rowCountAll=$result->rowCount();
			if($this->error_message($result->errorInfo())) {
				$this->query=strtr($query,$param);
				$this->db_error=$this->error_message($result->errorInfo());
				exit;
			}
		++$this->num_queries;
		if((isset($sort["limit"]) && $sort["limit"]=="1")){
			return $result->fetch(PDO::FETCH_ASSOC);
		}else{
			$data=array();
			while($row = $result->fetch(PDO::FETCH_ASSOC)){
				$data[] = $row;
			}
			return $data;
		}		
	return FALSE;				
	}

	// Run Queries
	public function run($query,$param=array(),$fetch=FALSE,$array=FALSE){
		$data="";
		$result = $this->db->prepare($query);
		if($result->execute($param) && !$fetch){
				return TRUE;
		}
		if($this->error_message($result->errorInfo())) {
			$this->query=strtr($query,$param);
			$this->db_error=$this->error_message($result->errorInfo());
			exit;
		}		
		++$this->num_queries;
		// Return Response
		if($result->rowCount() > '1'){
			while($row = $result->fetch(PDO::FETCH_ASSOC)){
				$data[] = $row;
			}
				return $data;
		}else {
			$data=$result->fetch(PDO::FETCH_ASSOC);
				if($array) return array($data);
				return $data;
		}					
	}

	// Insert to database
	public function insert($table,$insert,$parameters=array()){
		$param="";
		$val="";

		//Build Query
		$query="INSERT INTO {$this->dbinfo["prefix"]}$table";						
		if(is_array($insert)){
			$count=count($insert);
			$i=0;			
			foreach ($insert as $key => $value) {
				$param.="`$key`";
				$val.=$this->quote($value,$parameters);
				if(++$i != $count) {
				    $param.=",";
				    $val.=",";
				}				
			}
			$query.=" ($param) VALUES ($val)";
		}
		$result = $this->db->prepare($query);
		$result->execute($parameters);
		if($this->error_message($result->errorInfo())) {
			$this->query=strtr($query,$parameters);
			$this->db_error=$this->error_message($result->errorInfo());
			exit;
		}
		++$this->num_queries;
	return TRUE;		
	}
	// Update Query
	public function update($table,$field,$where,$param=array()){
		//Build Query
		$query="UPDATE {$this->dbinfo["prefix"]}$table SET ";
		if(is_array($field)){
			$count=count($field);
			$i=0;			
			foreach ($field as $key => $value) {
				$query.="`$key`=".$this->quote($value,$param);
				if(++$i != $count) {
				    $query.=",";
				}				
			}
		}else{
			$query.=$field;
		}
		if(is_array($where)){
			$count=count($where);
			$i=0;		
			$query.=" WHERE ";
			foreach ($where as $key => $value) {
				$query.="`$key`=".$this->quote($value,$param);
				if(++$i != $count) {
				    $query.=" AND ";
				}				
			}
		}else{
			$query.=" WHERE $where";
		}		
		$result = $this->db->prepare($query);
		$result->execute($param);
		if($this->error_message($result->errorInfo())) {
			$this->query=strtr($query,$param);
			$this->db_error=$this->error_message($result->errorInfo());
			exit;
		}
		++$this->num_queries;
	return TRUE;	
	}

	// Delete Function
	public function delete($table,$where,$param=array()){
		//Build Query
		$query="DELETE FROM {$this->dbinfo["prefix"]}$table";
		if(is_array($where)){
			$count=count($where);
			$i=0;		
			$query.=" WHERE ";
			foreach ($where as $key => $value) {
				$query.="`$key`=".$this->quote($value,$param);
				if(++$i != $count) {
				    $query.=" AND ";
				}				
			}
		}		
		$result = $this->db->prepare($query);
		$result->execute($param);		
		if($this->error_message($result->errorInfo())) {
			$this->query=strtr($query,$param);
			$this->db_error=$this->error_message($result->errorInfo());
			exit;
		}
		++$this->num_queries;
	return TRUE;	
	}
	// Search Database
	public function search($table,$where,$sort=array(),$param=array()){

		$query="SELECT * FROM {$this->dbinfo["prefix"]}$table";
		$query.=" WHERE ";
		$i=0;
		$count=count($where);			
		foreach ($where as $key => $value) {
			if(is_array($value)){
				$query.="`{$value[0]}`='{$value[1]}' AND (";
				++$i;
			}else{
				if($i==0) $query.="(";
				$query.="`$key` LIKE $value";
				if(++$i != $count) {
			    $query.=" OR ";
				}else{
					 $query.=")";
				}
			}						
		}

		$result = $this->db->prepare($query);
		$result->execute($param);
		$this->rowCount=$result->rowCount();		
		if(!empty($sort)){
			if(isset($sort["order"])){
				if($sort["order"]=="RAND()"){
					$query.=" ORDER BY RAND()";
				}else{
					$query.=" ORDER BY `{$sort["order"]}`";
				}				
			}
			if(isset($sort["order"])){
				if(isset($sort["asc"])){
					$query.=" ASC";
				}else{
					$query.=" DESC";
				}
			}			
			if(isset($sort["limit"])){
				$query.=" LIMIT {$sort["limit"]}";
			}			
		}			
		$result = $this->db->prepare($query);
		$result->execute($param);		
		if($this->error_message($result->errorInfo())) {
			$this->query=strtr($query,$param);
			$this->db_error=$this->error_message($result->errorInfo());
			exit;
		}

		if($result->rowCount()){
			// Return Response
			while($row = $result->fetch(PDO::FETCH_ASSOC)){
				$data[] = $row;
			}
			return $data;			
		}
		++$this->num_queries;
		return FALSE;
	}

	// Row Count
	public function count($table,$where='',$sum='',$format=FALSE,$division=FALSE) {
		if(!empty($where)) $where="WHERE $where";
		if($sum) {			
	  	$query = "SELECT SUM($sum) FROM {$this->dbinfo["prefix"]}$table $where";
			$result = $this->db->prepare($query);
			$result->execute();	
			if($this->error_message($result->errorInfo())) {
				$this->query=$query;
				$this->db_error=$this->error_message($result->errorInfo());
				exit;
			}							  		
			while($row = $result->fetch(PDO::FETCH_ASSOC)){
				$count=$row['SUM('.$sum.')'];
				if(!$count) $count="0";
			}
		}else{
	  	$query = "SELECT * FROM {$this->dbinfo["prefix"]}$table $where";
			$result = $this->db->prepare($query);
			$result->execute();
			if($this->error_message($result->errorInfo())) {
				$this->query=$query;
				$this->db_error=$this->error_message($result->errorInfo());
				exit;
			}									
			$count=$result->rowCount();
			if(!$count) $count="0";
		}
		++$this->num_queries;
		if($format) return Main::formatnumber($count,2);
		return $count;
	}

	// Check if there is an error
	private function error_message($error){
		if(!empty($error[2])){
			return $error[2];
		}
		return FALSE;
	}
	// Check if quotes are needed
	private function quote($string,$param=''){
		if(empty($param)){
			return "'$string'";
		}
		return $string;
	}
}