<?php 
/**
 * ====================================================================================
 *                           PREMIUM URL SHORTENER (c) KBRmedia
 * ----------------------------------------------------------------------------------
 * @copyright This software is exclusively sold at CodeCanyon.net. If you have downloaded this
 *  from another site or received it from someone else than me, then you are engaged
 *  in an illegal activity. You must delete this software immediately or buy a proper
 *  license from http://gempixel.com/buy/short.
 *
 *  Thank you for your cooperation and don't hesitate to contact me if anything :)
 * ====================================================================================
 *
 * @author KBRmedia (http://gempixel.com)
 * @link http://gempixel.com 
 * @package Premium URL Shortener
 * @subpackage Main Helper Class (Main.class.php)
 */
class Main{
/**
 * SMTP configuration Host - Port - Username - Password
 * @var (array) $smtp 
 */
  protected static $smtp=array(
                        "host"=>"", //SMTP Host 
                        "port"=>587, // SMTP Port - usually 587
                        "username"=>"", //SMTP 
                        "password"=>""
                        ); 
  protected static $title="";
  protected static $description="";
  protected static $url="";
  protected static $image="";
  protected static $video="";
  protected static $body_class="";

/**
* Dispatcher
* @param none
* @return File Name
* @since v2.0
* @deprecated since v2.0 
*/
  public static function dispatch(){
    if(isset($_GET["action"])){
      if(in_array($_GET["action"], array("user","profile","analytics","bundle"))) return self::clean($_GET["action"]);
      if(in_array($_GET["action"],array("page","contact","api"))) return "handler";    
    }
    return "redirect";
  }  
/**
* Generate meta title
* @param none
* @return title
* @since v2.0
*/
  public static function title(){
    global $config;
    if(empty(self::$title)){
      return $config["title"];
    }else{
      return self::$title." - ".$config["title"];
    }
  }
/**
* Generate meta description
* @param none
* @return description
* @since v2.0
*/
  public static function description(){
    global $config;
    if(empty(self::$description)){
      return $config["description"];
    }else{
      return self::$description;
    }
  }
/**
* Generate URL
* @param none
* @return description
* @since v2.0
*/
  public static function url(){
    global $config;
    if(empty(self::$url)){
      return $config["url"];
    }else{
      return self::$url;
    }
  }  
/**
* Generate URL
* @param none
* @return description
* @since v2.0
*/
  public static function image(){
    global $config;
    if(empty(self::$image)){
      return "http://api.pagepeeker.com/v2/thumbs.php?size=l&url=".self::url();
    }else{
      return self::$image;
    }
  }   
/**
* Set meta info
* @param none
* @return Formatted array
* @since v2.0
*/
  public static function set($meta,$value){
    if(!empty($value)){
      self::$$meta=$value;
    }
  }  

/**
* Generate Open-graph tags
* @param none
* @return string
* @since v2.0
*/  
  public static function ogp(){
    $meta="<meta property='og:type' content='website' />\n";
    $meta.="<meta property='og:url' content='".self::url()."' />\n"; 
    $meta.="<meta property='og:title' content='".self::title()."' />\n";
    $meta.="<meta property='og:description' content='".self::description()."' />\n";  
    $meta.="<meta property='og:image' content='".self::image()."' />\n"; 
    if(!empty(self::$video)){
      $meta.=self::$video; 
    }
    echo $meta; 
  }
/**
* Generate Open-graph video tag
* @param none
* @return string
* @since v2.0
*/  
  public static function video($url,$embed=FALSE){
    if(preg_match('%(?:youtube(?:-nocookie)?\.com/(?:[^/]+/.+/|(?:v|e(?:mbed)?)/|.*[?&]v=)|youtu\.be/)([^"&?/ ]{11})%i', $url, $match)) {                     
       Main::set("image","http://i1.ytimg.com/vi/{$match[1]}/maxresdefault.jpg?feature=og");
       Main::set("video",'<meta property="og:video" content="http://www.youtube.com/v/'.$match[1].'?version=3&amp;autohide=1">
      <meta property="og:video:type" content="application/x-shockwave-flash">
      <meta property="og:video:width" content="1920">
      <meta property="og:video:height" content="1080">');
     }  
     if($embed) return '<iframe id="ytplayer" type="text/html" width="640" height="390" src="http://www.youtube.com/v/'.$match[1].'?version=3&amp;autohide=1" frameborder="0"/>';
  }    
/**
* Generate slug
* @param string
* @return slug
*/  
  public static function slug($url) {
      $url=preg_replace('/[^_0-9a-zA-Z -]/', '', strtolower($url));
      $url=preg_replace('/\s\s+/', ' ', $url);
      $url=str_replace(' ','-',$url);
    return $url;
  } 
  
/**
* Redirect function
* @param url/path (not including base), message and header code
* @return nothing
* @since v2.0
*/   
  public static function redirect($url,$message=array(),$header="",$fullurl=FALSE){
    global $config;

    if(!empty($message)){      
      $_SESSION["msg"]=self::clean("{$message[0]}::{$message[1]}",3,FALSE,"<span>");
    }
    switch ($header) {
      case '301':
        header('HTTP/1.1 301 Moved Permanently');
        break;
      case '404':
        header('HTTP/1.1 404 Not Found');
        break;
      case '503':
        header('HTTP/1.1 503 Service Temporarily Unavailable');
        header('Status: 503 Service Temporarily Unavailable');
        header('Retry-After: 60');
        break;
    }
    if($fullurl){
      header("Location: $url");
      exit;
    }
    header("Location: {$config["url"]}/$url");
    exit;
  }
/**
* Notification Function
* @param none
* @return message
* @since v2.0
*/     
  public static function message(){
    if(isset($_SESSION["msg"])) {
      $message=explode("::",self::clean($_SESSION["msg"],3,FALSE,"<span>"));
      $message="<div class='message {$message[0]}'>".e($message[1])."</div>";
      unset($_SESSION["msg"]);
    }else {
      $message="";
    }
    return stripslashes($message);
  }
/**
* Body Class inject
* @param none
* @return message
* @since v2.0
*/     
  public static function body_class(){
    return " class='".self::$body_class."'";
  }  
/**
* Set Notification Function
* @param none
* @return message
* @since v2.0
*/     
  public static function set_message($message=array()){
    $_SESSION["msg"]=self::clean("{$message[0]}::{$message[1]}",3,FALSE,"<span>");
  }
/**  
* Generates pagination with class "pagination"
* @param total number of pages, current pages, format of url
* @return complete pagination elements
* @since v2.0
*/
  public static function pagination($total, $current, $format, $limit='1'){
         $page_count = ceil($total/$limit);
         $current_range = array(($current-5 < 1 ? 1 : $current-3), ($current+5 > $page_count ? $page_count : $current+3));

         $first_page = $current > 3 ? '<a href="'.sprintf($format, '1').'">1</a>'.($current < 5 ? ' ' : ' ... ') : null;
         $last_page = $current < $page_count-2 ? ($current > $page_count-4 ? ' ' : ' ... ').'<a href="'.sprintf($format, $page_count).'">Last</a>' : null;

         $previous_page = $current > 1 ? '<a href="'.sprintf($format, ($current-1)).'">Previous</a> ' : null;
         $next_page = $current < $page_count ? ' <a href="'.sprintf($format, ($current+1)).'">Next</a> ' : null;

         for ($x=$current_range[0];$x <= $current_range[1]; ++$x)    
        $pages[] = ($x == $current ? '<span class="current">'.$x.'</span>' : '<a href="'.sprintf($format, $x).'"">'.$x.'</a>');
         if ($page_count > 1)
      return '<div class="pagination">'.$previous_page.implode(' ', $pages).$last_page.$next_page.'</div>';
  }

/**  
* Validates the captcha based on settings
* @param data
* @return ok
* @since v2.0
*/  
  public static function check_captcha($array){
    global $config;
      if($config["captcha"]=="1"){
        // Recaptcha
        require_once(ROOT."/includes/lib/Recaptcha.php");
        if(empty($array["recaptcha_response_field"])) {
          return e('Please enter the CAPTCHA.');  
        }else{
          $resp = recaptcha_check_answer ($config["captcha_private"],$_SERVER["REMOTE_ADDR"],$array["recaptcha_challenge_field"],$array["recaptcha_response_field"]);
          if (!$resp->is_valid) {
            return e("The CAPTCHA wasn't entered correctly. Please try it again.")."<script>Recaptcha.reload()</script>";
          }
        }
      }elseif($config["captcha"]=="2"){
        // SolveMedia
        require_once(ROOT."/includes/lib/Solvemedia.php");
        if(empty($array["adcopy_response"])) {
          return e('Please enter the CAPTCHA.');  
        }else{
          $resp = solvemedia_check_answer(SV_PRIVKEY,$_SERVER["REMOTE_ADDR"],$array["adcopy_challenge"],$array["adcopy_response"],SV_HASHKEY);
          if (!$resp->is_valid) {
           return e("The CAPTCHA wasn't entered correctly. Please try it again.");
          }       
        }       
      }
      return 'ok';    
    }

/**  
* Generates CAPTCHA html based on settings
* @param none
* @return captcha
* @since v2.0
*/     
    public static function captcha(){
      global $config;
        if($config["captcha"]=="1"){
          require_once(ROOT."/includes/lib/Recaptcha.php");
          echo recaptcha_get_html($config["captcha_public"]);
        }elseif($config["captcha"]=="2"){
          require_once(ROOT."/includes/lib/Solvemedia.php");
          echo solvemedia_get_html(SV_CHALLENGE);
        }
    }

/**
* Generated CSRF Token
* @param none
* @return token
* @since v3.0
*/   
  public static function csrf_token($form=FALSE,$echo=TRUE){
      if($form && $echo && isset($_SESSION["CSRF"])) return "<input type='hidden' name='token' value='{$_SESSION["CSRF"]}' />";      
      if($echo && isset($_SESSION["CSRF"])) return $_SESSION["CSRF"];

      $token = self::encode("csrf_token".rand(0,1000000).time().uniqid(),"SHA1");
      $_SESSION["CSRF"] = $token;

      if($form) return "<input type='hidden' name='token' value='$token' />";
    return $token;
  }

/**
* Validate CSRF Token
* @param token
* @return boolean
* @since v3.0
*/   
  public static function validate_csrf_token($token,$redirect=""){
    if(isset($_SESSION["CSRF"]) && ($_SESSION["CSRF"] == trim($token))) {
      unset($_SESSION["CSRF"]);
      return TRUE;
    }
    if(!empty($redirect)) self::redirect($redirect,array("error",e("The CSRF token is not valid. Please try again.")));
    return FALSE;
  }    
/**
* Truncate a string
* @param string, delimiter, append string
* @return truncated message
* @since v2.0
*/  
  public static function truncate($string,$del="150",$limit="...") {
    $len = strlen($string);
      if ($len > $del) {
         $new = substr($string,0,$del).$limit;
          return $new;
      }
      return $string;
  }   
/**
* Convert a timestap into timeago format
* @param time
* @return timeago
* @since v2.0
*/  
  public static function timeago($time){
    $time=strtotime($time);
    $periods = array(e("second"), e("minute"), e("hour"), e("day"), e("week"), e("month"), e("year"), e("decade"));
    $lengths = array("60","60","24","7","4.35","12","10");
    $now = time();
      $difference = $now - $time;
      $tense= e("ago");
      for($j = 0; $difference >= $lengths[$j] && $j < count($lengths)-1; $j++) {
       $difference /= $lengths[$j];
      }
      $difference = round($difference);
      if($difference != 1) {
       $periods[$j].= "s";
      }
    return "$difference {$periods[$j]} $tense";
  } 
/**
* Validate and sanitize email
* @param string
* @return email
* @since v2.0
*/  
  public static function email($email){
      $email=trim($email);
      if (preg_match('/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]{2,})+$/i', $email) && strlen($email)<=50 && filter_var($email, FILTER_SANITIZE_EMAIL)){
          return filter_var($email, FILTER_SANITIZE_EMAIL);
      }
      return FALSE;
  }

/**
* Validate and sanitize username
* @param string
* @return username
* @since v2.0
*/  

  public static function username($user){
    if(preg_match('/^\w{4,}$/', $user) && strlen($user)<=20 && filter_var($user,FILTER_SANITIZE_STRING)) {
      return filter_var(trim($user),FILTER_SANITIZE_STRING);
    }
    return false;    
  }

/**
* Encode string
* @param string, encode= MD5, SHA1 or SHA256 
* @return hash
* @since v2.0
*/   
  public static function encode($string,$encoding="md5",$salt=''){
    return hash($encoding,$string.$salt);
  }

/**
* Generate api or random string
* @param length, start
* @return 
* @since v2.0
*/    
  public static function api($length=12,$api=""){    
      $use = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"; 
      srand((double)microtime()*1000000); 
      for($i=0; $i<$length; $i++) { 
        $api.= $use[rand()%strlen($use)]; 
      } 
    return $api; 
  }

/**
* Generate api or random string
* @param length, start
* @return 
* @since v2.0
*/   
  public static function strrand($length,$api=""){
    return self::api($length,$api);
  }

/**
* Clean a string
* @param string, cleaning level (1=lowest,2,3=highest)
* @return cleaned string
* @since v2.0
*/

  public static function clean($string,$level='1',$rchars=false,$leave=""){
      $string=preg_replace('/<script[^>]*>([\s\S]*?)<\/script[^>]*>/i', '', $string);      
      switch ($level) {
        case '3':
          $string=strip_tags($string,$leave);        
          if($rchars) $string=preg_replace("/[^\w\d ]/ui", '', $string);
          break;
        case '2':
          $string=strip_tags($string,'<b><i><s><u><strong><a>');
          break;
        case '1':
          $string=strip_tags($string,'<b><i><s><u><strong><a><pre><code><p><div>');
          break;
      }   
      $string=str_replace('href=','rel="nofollow" href=', $string);         
      return $string;
  } 
/**
 * Get extension
 * @param string filename
 * @return extension
 * @since v2.0
 */  
  public static function extension($filename) {
    return strrchr($filename, "."); 
  }  
/**
 * Read user cookie and extract user info
 * @param 
 * @return array of info
 * @since v2.0
 */
  public static function user(){
    if(isset($_COOKIE["login"])){
      $data=json_decode(base64_decode($_COOKIE["login"]),TRUE);
    }elseif(isset($_SESSION["login"])){
      $data=json_decode(base64_decode($_SESSION["login"]),TRUE);     
    }
    if(isset($data["loggedin"]) && !empty($data["key"])){  
      $info=str_replace('_$P$5648',"",$data["key"]);
      return array(self::clean(substr($info,32)),self::clean(substr($info,0,32)));
    }     
    return FALSE;  
  }
/**
 * Set ucookie
 * @param Name, value
 * @since v2.0
 */  
  public static function cookie($name,$value="",$time=1){
    if(empty($value)){
      if(isset($_COOKIE[$name])){
        return Main::clean($_COOKIE[$name],3,FALSE);
      }else{
        return FALSE;
      }
    }
    setcookie($name,$value, time()+($time*60), "/","",FALSE,TRUE);
  }
/**
 * Enqueue scripts to header and footer
 * @since v2.0
 */
  public static function enqueue($where="header"){
    if($where=="footer"){  
      global $enqueue_footer;
      echo $enqueue_footer;
    }else{
      global $enqueue_header;
      echo $enqueue_header;
    } 
  }
/**
 * Add scripts to header and footer
 * @since v2.0
 */  
  public static function add($url,$type="script",$footer=TRUE){
    if($type=="style"){
      $tag='<link rel="stylesheet" type="text/css" href="'.$url.'">';
    }elseif($type=="custom"){
      $tag=$url;
    }else{
      $tag='<script type="text/javascript" src="'.$url.'"></script>';
    }
    if($footer){
      global $enqueue_footer;
      $enqueue_footer.=$tag."\n";
    }else{
      global $enqueue_header;
      $enqueue_header.=$tag."\n";
    }
  } 
/**
 * Translate strings
 * @since v2.0
 */   
  public static function e($text){
    global $lang;
    if(isset($lang[$text]) && !empty($lang[$text])) {
      return $lang[$text];
    }
    return $text;    
  }
/**
 * Check if user agent is bot
 * @since v2.0
 */  
  public static function bot($ua=""){
    if(empty($ua)) $ua=$_SERVER['HTTP_USER_AGENT'];
    $list = array("facebookexternalhit","Teoma", "alexa", "froogle", "Gigabot", "inktomi",
    "looksmart", "URL_Spider_SQL", "Firefly", "NationalDirectory",
    "Ask Jeeves", "TECNOSEEK", "InfoSeek", "WebFindBot", "girafabot",
    "crawler", "www.galaxy.com", "Googlebot", "Scooter", "Slurp",
    "msnbot", "appie", "FAST", "WebBug", "Spade", "ZyBorg", "rabaz",
    "Baiduspider", "Feedfetcher-Google", "TechnoratiSnoop", "Rankivabot",
    "Mediapartners-Google", "Sogou web spider", "WebAlta Crawler","TweetmemeBot",
    "Butterfly","Twitturls","Me.dium","Twiceler");
    foreach($list as $bot){
      if(strpos($ua,$bot)!==false) return true;
    }
    return false; 
  }
  /**
   * Get Meta data of URL
   * @param url
   * @return formatted array
   */
  public static function get_meta_data($url){
    $content=@file_get_contents($url);
    if($content){  
      $array = array('title'=>'','description'=>'');
      $pattern = "|<[\s]*title[\s]*>([^<]+)<[\s]*/[\s]*title[\s]*>|Ui";
        if(preg_match($pattern, $content, $match)){
          $array['title']=$match[1];
        }
      $data=get_meta_tags($url);
        if(isset($data['description'])){
          $array['description']=$data['description'];
        }
      unset($data);
      unset($content);
      unset($match);      
      return $array;
    }
    return FALSE;
  }  
  /**
   * Curl Function
   * @param url and param array
   */
  public static function curl($url,$param=array()){
      if(!in_array('curl', get_loaded_extensions())) return FALSE;
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $url);
      curl_setopt($ch, CURLOPT_POST, 1);
      curl_setopt($ch, CURLOPT_POSTFIELDS, $param);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
      $result = curl_exec($ch);
      curl_close($ch);
    return $result;
  }
  /**
   * Send Email
   * @param array
   * @return boolean
   */  
  public static function send(array $array){
    global $config;
    if (!class_exists("phpmailer")) {
          include(ROOT."/includes/lib/PHPMailer.class.php");
    }

    $mail= new PHPMailer();  

    $content=file_get_contents(TEMPLATE."/email_template.php");
    $content=str_replace("[subject]",$array["subject"],$content);
    $content=str_replace("[message]",$array["message"],$content);
    $content=str_replace("[title]",$config["title"],$content);
    $content=str_replace("[url]","<a href='{$config["url"]}'>{$config["url"]}</a>",$content);

    if(!empty($config["facebook"])){
      $content=str_replace("[facebook]"," | <a href='{$config["facebook"]}'>Like us on Facebook</a>",$content);  
    }else{
      $content=str_replace("[facebook]","",$content);  
    }
    if(!empty($config["twitter"])){
      $content=str_replace("[twitter]"," | <a href='{$config["twitter"]}'>Follow us on Twitter</a>",$content);
    }else{
      $content=str_replace("[twitter]","",$content);  
    }    
    if(!empty(self::$smtp["host"])){
      $mail->IsSMTP();
      $mail->SMTPDebug  = 0;
      $mail->SMTPAuth   = true; 
      $mail->SMTPSecure = "tls";
      $mail->Host= self::$smtp["host"];
      $mail->Port = self::$smtp["port"]; 
      $mail->Username= self::$smtp["username"]; 
      $mail->Password  = self::$smtp["password"];     
    }
    $mail->AddReplyTo($config["email"], $config["title"]);
    $mail->SetFrom($config["email"], $config["title"]);
    $mail->AddAddress($array["to"]);
    $mail->Subject = $array["subject"];
    $mail->MsgHTML($content);
    if(!$mail->Send()) {
        error_log("SMTP Error: {$mail->ErrorInfo}");
        $headers  = "From: {$config["email"]}\r\n";
        $headers  = 'MIME-Version: 1.0' . "\r\n";
        $headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
        mail($array["to"], $array["subject"], $content, $headers);
        $mail=NULL;
        return TRUE;
    }  
    $mail=NULL;        
  }
}
?>