/**
 *  Premium URL Shortener jQuery Custom Functions - Don't edit anything below!
 *  Copyright @KBRmedia - All rights Reserved 
 */
(function($){
  // Sticky
  $.fn.extend({
    sticky: function(a) {
      var b = {
        TopMargin: '0'
      }
      var e=$(this);
      if(!e.length)  return false;
      var s = $.extend(b, a);
      pos=e.position();
      $(window).scroll(function(){   
        if(window.pageYOffset>=pos.top){              
            e.css({
                position: 'fixed',
                top: s.TopMargin,
                left: pos.left,
                margin: 0
            });                                   
        }else{
            e.attr('style','');           
        }   
      });                   
    }       
  });
  // Tooltip
  $.fn.extend({
    tooltip: function(a){   
      $(this).hover(function(){
        var d=$(this).attr("data-content");              
        var pos=$(this).position();
        var x=pos.left + $(this).width() + 20;
        var y=pos.top;
        $("body").append("<span id='tooltip' style='position:absolute;top:"+y+"px;left:"+x+"px'>"+d+"</span>");
      },function(){
        $("#tooltip").remove();
      });
    }
  });
  // Modal
  $.fn.extend({
    modal: function(settings) {
      var defaults = {
          confimation: 0,
          title:$(this).attr("title"),
          content:$(this).attr("data-content"),
          link:$(this).attr("href")
      };
      var s = $.extend(defaults, settings);
      if(!s.content){
          s.content="Note that this action is permanent. Once you click proceed, you <strong>may not undo</strong> this. Click anywhere outside this modal or click <a href='#close' class='close round'>close</a> to close this.";
      }
      if(!s.title){
        s.title="Are you sure you want to proceed?";
      }
      if(s.confimation){
          var proceed="";
      }else{
          var proceed="<a href='" + s.link + "' class='button green round'>Proceed</a> <a href='#' class='button red round delete close'>Cancel</a>";
      }
      var destroy=function(){
        $("#modal-shadow").fadeOut('normal',function(){
          $(this).remove();
        });
        $("#modal-alert").slideUp('normal',function(){
          $(this).remove();
        }); 
        return;       
      }
      if($("#modal-alert").length>0) destroy();
      $("body").prepend('<div id="modal-alert"></div><div id="modal-shadow"></div>');
      $("#modal-shadow").css("height",$(document).height()).hide();
      $("#modal-shadow").show();
      var left=($(document).width() - $("#modal-alert").width())*0.5;
      $("#modal-alert").css({"top":"67px","left":left}).hide();
      $("#modal-alert").slideDown();
      $("#modal-alert").html("<div class='title'>"+s.title+" <a href='#' class='button right small close'>Close</a></div><p>"+ s.content +"</p>"+proceed);
      $(document).on('click',".close,#modal-shadow",function() {
        destroy();
        return false;
      });
      var pos=$('#modal-alert').position(); 
      $('body,html').animate({scrollTop: pos.top - 20});           
      $(document).keyup(function(e) {
        if (e.keyCode == 27) {       
          destroy();
          return false;
        }   
      });                 
    }    
  }); 
  $.fn.extend({ 
    smoothscroll: function() {
      $(this).click(function(e){
        e.preventDefault();
        var href=$(this).attr("href");
        var pos=$(href).position(); 
        var css=$(this).attr('class');
            $("."+css).removeClass("active");
            $('body,html').animate({ scrollTop: pos.top-30 });               
      });
    }        
  });   
})(jQuery);    