<?php if(!defined('APP')) die(); ?>
<section>	
	<?php if(!$this->logged()): //If Users is not logged show promo bar ?>	
	<div class="promo">
		<div class="container">
			<div class="row features">
				<div class="grid third">
					<div class="row">
						<div class="grid fifth">
							<i class="icon-stats"></i>
						</div><!-- /.fifth -->
						<div class="grid fourfifth">
							<h2><?php echo e("Advanced Statistics") ?></h2>
							<p><?php echo e("Track each short URL from A to Z.") ?></p>								
						</div><!-- /.fourfifth -->
					</div><!-- /.row -->
				</div><!-- /.grid third -->
				<div class="grid third">
					<div class="row">
						<div class="grid fifth">
							<i class="icon-case"></i>
						</div><!-- /.fifth -->
						<div class="grid fourfifth">
							<h2><?php echo e("Store and Manage") ?></h2>
							<p><?php echo e("Each URL is stored and can be access at any time.") ?></p>								
						</div><!-- /.fourfifth -->
					</div><!-- /.row -->				
				</div><!-- /.grid third -->
				<div class="grid third">
					<div class="row">
						<div class="grid fifth">
							<i class="icon-fav"></i>
						</div><!-- /.fifth -->
						<div class="grid fourfifth">
							<h2><?php echo e("Share them anytime") ?></h2>
							<p><?php echo e("Easily share them through social networks.") ?></p>								
						</div><!-- /.fourfifth -->
					</div><!-- /.row -->								
				</div><!-- /.grid third -->
			</div><!-- /.row -->													
		</div><!-- /.container -->		
	</div><!-- /.promo-->	
	<?php endif ?>
	<div class="container noflow<?php if($this->logged()) echo " addmargin"?>">	
		<?php echo Main::message() ?>				
		<div class="ajax"></div><!--/.ajax-->
		<?php if($this->config["sharing"]):?>
			<div class="share-this"></div>		
		<?php endif?>				
		<div class="url-shortener">			
			<form action="<?php echo $this->config["url"]?>/?url" class="form" id="shortener" method="post">
				<div class="form-holder">
					<div class="main-form current-container" id="single-form">
						<i class="icon-link pre"></i>				
						<input type="text" placeholder="<?php echo e("Paste Long URL")?>..." name="url" id="url" class="main-input" value="<?php echo (isset($_GET["url"])?$_GET["url"]:"") ?>">					
						<button class="form-button" type="submit" id="button"><?php echo e("Shorten")?></button>
						<button class="form-button" id="copyurl" type="button"><?php echo e("Copy")?></button>											
					</div><!-- /.main-form -->		
					<div id="multiple-form">
						<textarea name="urls" id="urls" placeholder="<?php echo e('One URL per line and they must be valid.') ?>"></textarea>
						<button class="form-button"><?php echo e("Shorten")?></button>
					</div><!-- /#multiple-form -->
				</div><!-- /.form-holder -->		
				<div id="captcha">
					<?php Main::captcha() ?>
				</div><!--/#captcha-->
				<div class="row noflow">
					<div class="grid half" style="min-height:1px;">
						<?php echo $this->get_domains() ?>	
						<a href="" class="advanced"><?php echo e("Advanced Options")?></a>			
					</div><!-- /.grid half -->
					<div class="grid half">																								
						<ul class="switcher right">
							<li class="current" data-type="single"><?php echo e("Single")?></li>
							<li data-type="multiple"><?php echo e("Multiple")?></li>
						</ul>													
					</div><!-- /.grid half -->
				</div><!-- /.row -->		
				<div id="placeholder">
					<div class="advanced-options">
						<div class="row">
							<div class="grid third">
								<h3><?php echo e("Custom Alias")?></h3>
								<span><?php echo e('If you need a custom alias, you can enter it below.')?> </span>
								<div class="input-label">
									<i class="icon-setting"></i>
									<input type="text" name="custom" class="option-input" placeholder="<?php echo e("Type your custom alias here")?>">
								</div><!--/.input-label-->
							</div><!-- /.grid third -->
							<div class="grid third">
								<div class="inner">
									<h3><?php echo e("Password Protect")?></h3>
									<span><?php echo e('By adding a password, you can restrict the access of statistics.')?></span>
									<div class="input-label">
										<i class="icon-pass"></i>
										<input type="text" name="password" id="pass" class="option-input" placeholder="<?php echo e("Type your password here")?>">
									</div><!--/.input-label-->
								</div><!-- /.inner -->
							</div><!-- /.grid third -->
							<div class="grid third">
								<h3><?php echo e("Description")?></h3>
								<span><?php echo e('This can be used to identify URLs on your account.')?></span>
								<div class="input-label">
									<i class="icon-help"></i>
									<input type="text" name="description" class="option-input" placeholder="<?php echo e("Type your description here")?>">
								</div><!--/.input-label-->
							</div><!-- /.grid third -->										
						</div><!-- /.row -->
						<?php if($this->config["geotarget"]):?>
						<div class="row geotarget" id="geo">
							<h3><?php echo e("Geotargeting")?> <a href="#" class="button small blue right add_geo round"><?php echo e("Add more locations")?></a></h3>
							<span><?php echo e('If you have different pages for different countries then it is possible to redirect users to that page using the same URL. Simply choose the country and enter the URL.')?></span> 
							<div class="geo-input">							
								<div class="row">
									<div class="grid half">
										<label><?php echo e("Country")?></label>
										<input type="text" class="country small" name="country[]" placeholder="<?php echo e("Type the country to redirect from.")?>">
									</div><!-- /.grid half -->	
									<div class="grid half">
										<label><?php echo e("URL")?></label>
										<input type="text" name="target[]" class="large" placeholder="<?php echo e("Type the url to redirect user to.")?>">
									</div><!-- /.grid half -->	
								</div><!-- /.row -->
							</div><!-- /.geo-input -->
						</div><!-- /.row -->						
						<?php endif; ?>
					</div><!-- /.advanced-options -->
				</div><!-- /#placeholder -->
				<input type="hidden" name="action" value="shorten">				
			</form><!-- /.form -->		
		</div><!-- /.url-shortener -->		
	</div><!-- /.container -->
</section>
<?php if($this->config["user_history"] && $urls=$this->history()): ?>
	<section class="light">
		<div class="promo">
			<div class="container">
				<?php echo $this->ads(728); ?>
			</div>
		</div><!-- /.promo -->
		<div class="container fixed">
			<div class="content">
				<div id="url-container">
					<h2><?php echo e("Your last 10 URLs") ?></h2>
					<?php foreach ($urls as $url): ?>	
						<?php if(!empty($url)): ?>
						<div class="url-list full">						
							<div class="url-info">
								<h3 class="title">
									<img src="http://www.google.com/s2/favicons?domain=<?php echo $url["url"] ?>" alt="Favicon">
									<a href="<?php echo $this->config["url"]."/".$url["custom"].$url["alias"] ?>"><?php echo Main::truncate(empty($url["meta_title"])?$url["url"]:$url["meta_title"],100) ?></a>
									<p class="short-url">
										<a href="<?php echo $this->config["url"]."/".$url["custom"].$url["alias"] ?>"><?php echo $this->config["url"]."/".$url["custom"].$url["alias"] ?></a>&nbsp;&nbsp;·&nbsp;&nbsp;
										<a href="<?php echo $this->config["url"]."/".$url["custom"].$url["alias"] ?>/qr" class="button small round"><?php echo e("QR code") ?></a>
									</p>
								</h3>					
							</div>		
							<div class="url-stats">
								<strong><?php echo $url["click"] ?></strong>
								<a href="<?php echo $this->config["url"]."/".$url["custom"].$url["alias"] ?>+" class="button small round"><?php echo e('Clicks')?></a>
							</div><!-- /.url-stats -->											
						</div><!-- /.url-list -->			
						<?php endif; ?>									
					<?php endforeach; ?>			
				</div><!-- /#url-container -->					
			</div><!-- /.content -->	
			<div class="sidebar">				
				<?php echo $this->ads('300') ?>		
			</div><!-- /.sidebar -->		
		</div><!-- /.container -->		
	</section>
<?php endif; ?>
